# 
# compileGplBundle.sh - build rules for D-Link DSR GPL bundle
#
# Copyright (c) 2010, TeamF1, Inc.
#
# modification history
# --------------------
# 01a,26may10,anp  written.
#
# DESCRIPTION
# This script build a firmware for D-Link DSR.
#

COMPILER=mips64-octeon-linux-gnu-gcc
WORK_BASE=${PWD}
COMPS_BASE=${PWD}/comps
GPL_BASE=${WORK_BASE}/comps/gpl
KERNEL_BASE=${GPL_BASE}/linux-2.6.21
TGT_BOARD=DSR-1000N
CFGVER=1.0
HARDWARE_VERSION=A1
COUNTRY_CODE=

[ -z $1 ] && { echo "Usage: sh compileGplBundle.sh <firmVersion>"; exit 1; }
FIRMVER=${1}

echo 'Unsetting  OCTEON_CPPFLAGS_GLOBAL_ADD'
export -n OCTEON_CPPFLAGS_GLOBAL_ADD
echo "Done."

# check for compiler 
${COMPILER} -v > /dev/null 2>&1
if [ $? -ne 0 ]; then
    echo "Error: Could not find compiler. Please set compiler path first !!!";
    exit 1;
fi

export OCTEON_ROOT=${WORK_BASE}/sdk

# build kernel
cp -f kernel.cfg ${KERNEL_BASE}/.config
make -C ${KERNEL_BASE} CROSS_COMPILE=mips64-octeon-linux-gnu- vmlinux.64 modules
mips64-octeon-linux-gnu-strip ${KERNEL_BASE}/vmlinux.64

make -C ${COMPS_BASE} all

mips64-octeon-linux-gnu-strip --strip-debug --strip-unneeded `find pfrm2.0` > /dev/null 2>&1

chmod +x utils/mksquashfs

utils/mksquashfs pfrm2.0 squash.img -be -noappend
dd if=/dev/zero of=tmpImage ibs=512 obs=512 count=18432
dd if=${KERNEL_BASE}/vmlinux.64 of=tmpImage ibs=512 obs=512 count=18432 conv=notrunc seek=1
cat squash.img >> tmpImage
utils/firmGen tmpImage ${TGT_BOARD} ${FIRMVER} ${CFGVER} ${HARDWARE_VERSION} ${COUNTRY_CODE}  
rm squash.img
rm tmpImage

# generate firmware
echo -e "Firmware \033[31m${TGT_BOARD}_${HARDWARE_VERSION}_FW${FIRMVER}\033[0m is ready.";
