#ifndef _XT_IFGROUP_H
#define _XT_IFGROUP_H

#define XT_IFGROUP_INVERT_IN   0x01
#define XT_IFGROUP_INVERT_OUT  0x02
#define XT_IFGROUP_MATCH_IN    0x04
#define XT_IFGROUP_MATCH_OUT   0x08
#define XT_IFGROUP_INVERT_MASK 0x10
#define XT_IFGROUP_MATCH_MASK  0x20
#define XT_IFGROUP_MATCH_NF_HOOK 0x40
#define TPROXY

#define XT_IFGROUP_NF_PRE_ROUTING  0
#define XT_IFGROUP_NF_LOCAL_IN     1
#define XT_IFGROUP_NF_FORWARD      2
#define XT_IFGROUP_NF_LOCAL_OUT    3
#define XT_IFGROUP_NF_POST_ROUTING 4
#define XT_IFGROUP_NF_MAX          5

struct xt_ifgroup_info {
       u_int32_t in_group;
       u_int32_t in_mask;
       u_int32_t out_group;
       u_int32_t out_mask;
       u_int8_t flags;
#ifdef TPROXY       
       u_int32_t tproxy_mark_value;
       u_int32_t tproxy_mark_mask;
       u_int8_t nf_hook;
#endif /* TPROXY */       
};

#endif /*_XT_IFGROUP_H*/
