#ifndef _IPT_LOG_H
#define _IPT_LOG_H

#ifndef TEAMF1_CHANGES
#define TEAMF1_CHANGES
#endif /* TEAMF1_CHANGES */

/* make sure not to change this without changing netfilter.h:NF_LOG_* (!) */
#define IPT_LOG_TCPSEQ		0x01	/* Log TCP sequence numbers */
#define IPT_LOG_TCPOPT		0x02	/* Log TCP options */
#define IPT_LOG_IPOPT		0x04	/* Log IP options */
#define IPT_LOG_UID		0x08	/* Log UID owning local socket */
#define IPT_LOG_NFLOG		0x10	/* Unsupported, don't reuse */
#define IPT_LOG_MASK		0x1f

#ifdef TEAMF1_CHANGES
#define IPT_LOG_UNICAST            1
#define IPT_LOG_BCAST_MCAST        2
#define IPT_LOG_UCAST_BCAST_MCAST  3
#define IPT_LOG_NO_PKT             0
#endif /* TEAMF1_CHANGES */

struct ipt_log_info {
	unsigned char level;
	unsigned char logflags;
#ifdef TEAMF1_CHANGES
	char prefix[40];
	char format[256];
#else /* TEAMF1_CHANGES */
	char prefix[30];
#endif /* TEAMF1_CHANGES */
};

#ifdef TEAMF1_CHANGES
struct sk_buff;

void dump_packet_wrapper(const struct ipt_log_info *,
			const struct sk_buff *, unsigned int);
int ipt_log_target_ex(struct sk_buff **, const struct net_device *,
	       const struct net_device *, unsigned int,
	       const void *, const void *);
#endif /* TEAMF1_CHANGES */
#endif /*_IPT_LOG_H*/
