#ifndef __ipt_time_h_included__
#define __ipt_time_h_included__


#define IPT_TIME_DROP               1
#define IPT_TIME_ACCEPT             2
#define IPT_TIME_LOG_AND_DROP       3
#define IPT_TIME_LOG_AND_ACCEPT     4

#define IPT_SUNDAY                 64     
#define IPT_MONDAY                 32 
#define IPT_TUESDAY                16 
#define IPT_WEDNESDAY               8
#define IPT_THRUSDAY                4
#define IPT_FRIDAY                  2
#define IPT_SATURDAY                1

#define IPT_NEXT_DAY                1
#define IPT_PREV_DAY                0

#define FW_MINUTES_IN_DAY           24 * 60  

struct ipt_time_info {
	u_int8_t  days_match;   /* 1 bit per day. -SMTWTFS                      */
	u_int16_t time_start;   /* 0 < time_start < 23*60+59 = 1439             */
	u_int16_t time_stop;    /* 0:0 < time_stat < 23:59                      */

				/* FIXME: Keep this one for userspace iptables binary compability: */
	u_int8_t  kerneltime;   /* ignore skb time (and use kerneltime) or not. */

	time_t    date_start; 
#ifndef __KERNEL__
	int dummy1;
#endif	
	time_t    date_stop;
#ifndef __KERNEL__
	int dummy2;
#endif	
    int       action;  
    char      prefix[32];
};


#endif /* __ipt_time_h_included__ */
