#ifndef _IP6T_IP6RANGE_H
#define _IP6T_IP6RANGE_H

#include <linux/types.h>

#define IP6RANGE_SRC		0x01	/* Match source IP address */
#define IP6RANGE_DST		0x02	/* Match destination IP address */
#define IP6RANGE_SRC_INV	0x10	/* Negate the condition */
#define IP6RANGE_DST_INV	0x20	/* Negate the condition */

struct ip6t_ip6range {
	/* Inclusive: network order. */
    struct in6_addr min_addr;
    struct in6_addr max_addr;
};

struct ip6t_ip6range_info
{
	struct ip6t_ip6range src;
	struct ip6t_ip6range dst;

	/* Flags from above */
	u_int8_t flags;
};

#endif /* _IP6T_IP6RANGE_H */

