#!/bin/sh
#
# Copyright (c) 2008, TeamF1, Inc.
#
# modification history
# --------------------
# 01b,29Mar08,vpp modified for linksys.
# 01a,07feb08,anp  written. 
# 
#
# DESCRIPTION:
# This script patches the kernel for iptables-1.3.4 patch.
#

setupenv()
    {
    EXIT=0;
    if [ -z $KERNELPATH ]; then
    while [ $EXIT = 0 ]
    do
        echo "Enter the path of the kernel source: ";
        read KERNELPATH;

        if [ $KERNELPATH ]; then
            if [ -d $KERNELPATH ]; then
                EXIT=1
            else
                echo "Directory does not exist. Please enter again: ";
            fi
        fi;
    done

    fi
    }

patchkernel()
    {
    LIN_DIR=linux-2.6.21.7
    PATCH_DIR=$TEAMF1_BASE/patches/teamf1/$LIN_DIR
    PATCHFILES=`cd $PATCH_DIR/; find -type f | sed '/.svn/d'`;

    for i in $PATCHFILES
    do
        j=`basename $i`
        cmp -s $PATCH_DIR/$i $KERNELPATH/$i;
        if [ $? -gt 0 ]; then
            echo "Patching file: $KERNELPATH/$i";
            cp -f -b --suffix=.orig $PATCH_DIR/$i $KERNELPATH/$i;
        fi
    done
    return 0;
    }

setupenv;
patchkernel;

# patch wireless driver
echo "Patching atheros driver ...";
find $TEAMF1_BASE/patches/teamf1/atheros -name .svn | xargs rm -rf 
cp -f -r -b --suffix=.orig $TEAMF1_BASE/patches/teamf1/atheros $TEAMF1_BASE/comps/
