# conf.mk - build configuration parameters for sip
#
# Copyright (c) 2007-2010, TeamF1, Inc.
#
# modification history
# --------------------
# 01a,25jul07,rks  written.
#
# DESCRIPTION 
# 
# This file contains configuration to build sip component
#
#*/

OPTION_INCLUDE_DIR=-I

ifeq ($(TEAMF1_BASE),)
TEAMF1_BASE=$(WIND_BASE)/target
endif

ifeq ($(TEAMF1_SIP_BASE),)
TEAMF1_SIP_BASE=$(TEAMF1_BASE)
endif

ifeq ($(SIP_INC_DIR),)
SIP_INC_DIR=$(TEAMF1_SIP_BASE)/h/sip
endif

ifeq ($(TEAMF1_ADAPTOS_BASE),)
TEAMF1_ADAPTOS_BASE=$(TEAMF1_BASE)
endif

ifeq ($(ADAPTOS_INC_DIR),)
ADAPTOS_INC_DIR=$(TEAMF1_ADAPTOS_BASE)/h/adaptos
endif

ifeq ($(TEAMF1_UMI_BASE),)
TEAMF1_UMI_BASE=$(TEAMF1_BASE)
endif

ifeq ($(UMI_INC_DIR),)
UMI_INC_DIR=$(TEAMF1_UMI_BASE)/h/umi
endif

ifeq ($(TEAMF1_SQLITE_BASE),)
TEAMF1_SQLITE_BASE=$(TEAMF1_BASE)
endif

ifeq ($(SQLITE_INC_DIR),)
SQLITE_INC_DIR=$(TEAMF1_SQLITE_BASE)/h/sqlite
endif

ifeq ($(TEAMF1_EVTDSPTCH_BASE),)
TEAMF1_EVTDSPTCH_BASE=$(TEAMF1_BASE)
endif

ifeq ($(EVTDSPTCH_INC_DIR),)
EVTDSPTCH_INC_DIR=$(TEAMF1_EVTDSPTCH_BASE)/h/evtDsptch
endif

ifeq ($(TEAMF1_LOGGING_BASE),)
TEAMF1_LOGGING_BASE=$(TEAMF1_BASE)
endif

ifeq ($(LOGGING_INC_DIR),)
LOGGING_INC_DIR=$(TEAMF1_LOGGING_BASE)/h/logging
endif

ifeq ($(SIPALG_INC_DIR),)
SIPALG_INC_DIR=$(TEAMF1_SIP_BASE)/h/sip
endif

# LUA header base

ifeq ($(TEAMF1_LUA_BASE),)
TEAMF1_LUA_BASE=$(TEAMF1_BASE)
endif

ifeq ($(LUA_INC_DIR),)
LUA_INC_DIR=$(TEAMF1_LUA_BASE)/h/lua
endif

ifeq  ($(MULTI_LIB),n)
LIB_SUFFIX= 
else
LIB_SUFFIX=sip
endif

ADDED_CFLAGS += $(OPTION_INCLUDE_DIR)$(SQLITE_INC_DIR)      \
                $(OPTION_INCLUDE_DIR)$(ADAPTOS_INC_DIR)     \
                $(OPTION_INCLUDE_DIR)$(UMI_INC_DIR)         \
		$(OPTION_INCLUDE_DIR)$(SIPALG_INC_DIR)      \
		$(OPTION_INCLUDE_DIR)$(EVTDSPTCH_INC_DIR)   \
                $(OPTION_INCLUDE_DIR)$(LOGGING_INC_DIR) 


ifeq ($(DEBUG),y)
ADDED_CFLAGS += -g 
endif

ifeq ($(ALG_SIP),y)
ADDED_CFLAGS += -DALGCONF_SIP
endif
