/*
** Copyright (C) 2002-2008 Sourcefire, Inc.
** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License Version 2 as
** published by the Free Software Foundation.  You may not use, modify or
** distribute this program under any other version of the GNU General
** Public License.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/* Modification History
 * --------------------
 */

/* $Id$ */

/* This file gets included in plugbase.h when it is integrated into the rest 
 * of the program.  Sometime in The Future, I'll whip up a bad ass Perl script
 * to handle automatically loading all the required info into the plugbase.*
 * files.
 */

#ifndef __SPO_TEAMF1_H__
#define __SPO_TEAMF1_H__

#define UMI_IOCTL_OPT_NO_RESULT 2

void AlertTeamf1Setup(void);

typedef enum 
    {
    UMI_COMP_UMI        = 1,
    UMI_COMP_LOGGING    = 20,
    UMI_COMP_IPS        = 54,
    UMI_COMP_ID_MAX     = 1000
    } UMI_COMP_ID;

typedef struct
    {
    unsigned int        cmd;
    UMI_COMP_ID         srcId;
    unsigned int        reqOpt;
    unsigned int        reqId;
    int                 req;
    int                 status;
    } UMI_REQ_INFO;


typedef struct
    {
    UMI_COMP_ID compId;     /* component id */
    int         logLevel;   /* log level */
    char        text[32];   /* text string for binary log */
    } LOGGING_LOG_REQ;

#define LOGGING_CMD_LOG 32
#define LOGGING_LEVEL_ALERT       0x02

#endif  /* __SPO_TEAMF1_H__ */
