#!/pfrm2.0/bin/lua 

--[[
#### File: dot11mgmt.lua
#### Description: lua layer to handle updates on tables

#### Revisions:
01a,28Nov'09, nsr written
]]--


--************* Requires *************
require "teamf1lualib/db"

--************* Functions *************

--************* Initial Code *************
local dbfile = arg[1]
local table  = arg[3]
local opcode = tonumber(arg[2])
local rowid  = tonumber(arg[4])
local ppOldValuesIdx = 5        -- lookup arg list

--************* Logic *************

db.connect (dbfile)

-- if reboot table has been updated/inserted
if (table == "dot11Radio" or table == "dot11VAP") then
    -- get the row that got updated
    local row = db.getRow ("dot11Radio", "rowid", rowid);
    local rows = db.getRows ("dot11vap", "vapenabled", "1");

    -- if 5Ghz mode, glow the second led
    if (row and 
        (row["dot11Radio.opMode"] == "na" or 
        row["dot11Radio.opMode"] == "na40+" or 
        row["dot11Radio.opMode"] == "na40-" or 
        row["dot11Radio.opMode"] == "a only")) then
        os.execute ("ledctrl mini1 on");
        os.execute ("ledctrl mini2 off");
    else
        os.execute ("ledctrl mini1 off");
        os.execute ("ledctrl mini2 on");
    end

    -- turn off leds if no vaps are up
    if (not rows or #rows == 0) then
        os.execute ("ledctrl mini1 off");
        os.execute ("ledctrl mini2 off");
    end
elseif (table == "dot11WPSSessStatus" or table == "dot11WPS") then
     -- get the row that got updated
    local row = db.getRow ("dot11WPSSessStatus", "rowid", "1");
    local wpstate = db.getAttribute ("dot11WPS", "rowid", "1", "wpsEnabled");

    -- if WPS is enabled 
    if (tonumber(wpstate) == 1) then

      -- if session is currently in progress, keep blinking
      if (tonumber(row["dot11WPSSessStatus.sessionStatus"]) == 1) then
          if (row["dot11WPSSessStatus.sessionMsg"] == "Initializing WPS session") then
            os.execute ("ledctrl wps blink 3");
          end

          -- assume everything went fine if we sent M8
          if (row["dot11WPSSessStatus.sessionMsg"] == "Sending message M8") then
            os.execute ("ledctrl wps on");
          end
      else 
          if (row["dot11WPSSessStatus.sessionMsg"] == "WPS session timed out" or 
              row["dot11WPSSessStatus.sessionMsg"] == "WPS registration failed" or 
              row["dot11WPSSessStatus.sessionMsg"] == "WPS session failed !!") then
            os.execute ("ledctrl wps off");
          end
      end
    else
      os.execute ("ledctrl wps off");
    end
end

db.close() -- close db handle
