#!/bin/sh
#

FIRMWARE_IMAGE=$1
KERNEL_PARTITION=$2
ROOTFS_PARTITION=$3
MD5SUM_BIN=/usr/bin/md5sum
FIRM_MD5SUM=/data/tmp/firmMd5sum
FIRM_MD5SUM_TMP=/data/tmp/temp1
CUT=/usr/bin/cut
RM=/bin/rm

# Verify the firmware header. The upgrade binary is from the firmware 
# component.This only verifies the sanity of the image by using the firmware
# header.


$MD5SUM_BIN  $FIRMWARE_IMAGE > $FIRM_MD5SUM_TMP
$CUT -f1 -d " " $FIRM_MD5SUM_TMP > $FIRM_MD5SUM
$RM $FIRM_MD5SUM_TMP

/mnt/tmpfs/eraseall -q $KERNEL_PARTITION 
/bin/dd if=$FIRMWARE_IMAGE of=$KERNEL_PARTITION bs=65536 count=144 2> /dev/null 

/mnt/tmpfs/eraseall -q $ROOTFS_PARTITION 
/bin/dd if=$FIRMWARE_IMAGE of=$ROOTFS_PARTITION bs=65536 skip=144 2> /dev/null 


umount -l /pfrm2.0 
mount /mnt/tmpfs/pfrm2.0 /pfrm2.0 
sleep 3  

exit 0; 
