-- CLI.lua
-- Gaurav Mathur
-- TeamF1
-- www.TeamF1.com

-- Modification History
-- 08amr10 rac added lua library for pptpd and l2tpd servers
-- 27feb10 rac added lua library for dmz
-- 23jan09 ss  added lua libraries for vipsecure, rip, bwLimit, customServices, snmp, firewall6-rule,
--             nimf6CLI, ipMode, idsCLI, radius, trafficMeter, schedules, contentFiltering,
--             sourceMacFiltering, portTriggering, 6to4CLI, isatap, mldproxy, radvd
--             portManagement, langroupsCLI, lanMultihoming, dot11
-- 07nov08 nlm added lua libraries for vpn passthrough, security checks, basic
--             security settings, NAT, Access control and port forwarding rules and
--             DoS attacks 
-- 07oct08 ss  added dhcp lua library
-- 07oct08 ss  reverting changes for accessmgmt and langroups 
--             by removing inclusion of remoteCLI, langroupsCLI lua libraries.
-- 24sep08 rfi adding nimf,dhcpc,pppoe and ifStatic lua libraries
-- 19sep08 rfi adding upnp lua libraries
-- 28nov07 gnm written
--
-- Description
-- CLISH entry point
--

-- load requried libraries
require "teamf1lualib/clishCLI"
require "teamf1lualib/db"
require "teamf1lualib/util"
require "teamf1lualib/utilsCLI"
require "teamf1lualib/timeCLI"
require "teamf1lualib/userdbCLI"
require "teamf1lualib/ifDevCLI"
require "teamf1lualib/logConfigCLI"
require "teamf1lualib/loggingCLI"
require "teamf1lualib/utilitiesCLI"
require "teamf1lualib/systemCLI"
require "teamf1lualib/ddnsCLI"
require "teamf1lualib/upnpCLI"
require "teamf1lualib/nimfCLI"
require "teamf1lualib/iprouteCLI"
require "teamf1lualib/dhcpCLI"
require "teamf1lualib/vpnpassthroughCLI"
require "teamf1lualib/natCLI"
require "teamf1lualib/firewall-ruleCLI"
require "teamf1lualib/ripCLI"
require "teamf1lualib/bwLimitCLI"
require "teamf1lualib/customServicesCLI"
require "teamf1lualib/vipsecureCLI"
require "teamf1lualib/snmpCLI"
require "teamf1lualib/firewall6-ruleCLI"
require "teamf1lualib/nimf6CLI"
require "teamf1lualib/ipModeCLI"
require "teamf1lualib/remoteCLI"
--require "teamf1lualib/idsCLI"
require "teamf1lualib/radiusCLI"
require "teamf1lualib/trafficMeterCLI"
require "teamf1lualib/schedulesCLI"
--require "teamf1lualib/contentFilteringCLI"
require "teamf1lualib/sourceMacFilteringCLI"
require "teamf1lualib/6to4CLI"
require "teamf1lualib/isatapCLI"
--require "teamf1lualib/mldproxyCLI"
require "teamf1lualib/radvdCLI"
require "teamf1lualib/portManagementCLI"
--require "teamf1lualib/langroupsCLI"
--require "teamf1lualib/lanMultihomingCLI"
require "teamf1lualib/dot11ConfigCLI"
require "teamf1lualib/dot11ShowCLI"
require "teamf1lualib/dmzCLI"
require "teamf1lualib/advancedCLI"
require "teamf1lualib/applicationrulesCLI"
require "teamf1lualib/websiteFilteringCLI"
require "teamf1lualib/usbCLI"
require "teamf1lualib/pptpdCLI"
require "teamf1lualib/l2tpdCLI"

-- This is a hack for now. We'll attach the CLI to login.login later
ACCESS_LEVEL = 0

-- types
TRUE = 0
FALSE = -1

-- Set language global variable
LANGUAGE = "en_US"

-- Database location
DB_FILE_NAME="/tmp/system.db"

-- Connect to the system DB once when CLISH starts
db.connect(DB_FILE_NAME)
SETTINGS_FILE = db.getAttribute("environment", "name", "TEAMF1_CFG_ASCII", "value")
