-- applicationrulesCLI.lua
-- Ravindranath
-- TeamF1
-- www.TeamF1.com
-- 02/03/10
-- Description
-- CLISH security application rules LUA routines

-- Modification History
-- 22mar10,rac added portTriggeringStatusGet to get the application rules status
-- 02mar10,rac written

-- Required Libraries
require "teamf1lualib/fwView"

function portTriggeringCfgInit(args)
    local rowId = args[1]
    if (rowId == nil) then
        configRow={}
        configRow = db.getDefaults(true, "PortTriggering")
        configRow["PortTriggering._ROWID_"] = "-1"
        configRow["PortTriggering.OID"] = "10"
    else
        configRow= db.getRow("PortTriggering","_ROWID_",rowId)
        if (configRow == nil) then
           print("Row does not exist probably deleted.Please ext the mode")          
           return -1, {}
        end
    end
    return configRow["PortTriggering._ROWID_"], configRow
end

function portTriggeringCfgSave(configRow)
    local errorFlag = "Error"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "PortTriggering"

    if (configRow["PortTriggering._ROWID_"] == "-1" or configRow["PortTriggering._ROWID_"] == nil) then
        errorFlag, statusCode = fwView.portTrgConfig(configRow, RowId, "add")
    else
        errorFlag, statusCode = fwView.portTrgConfig(configRow, configRow["PortTriggering._ROWID_"], "edit")
    end
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
        statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function portTriggeringCfgDel(args)
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "PortTriggering"
    local configRow=db.getRow("PortTriggering","_ROWID_",args)
    if (configRow == nil)then
	errorFlag="ERROR"
	statusMessage="Row doesnt exist"
	printCLIError("Row doesnt exist")
	return errorFlag, statusMessage
    end
    local rows = {}
    rows["rowid"] = configRow["PortTriggering._ROWID_"]
    errorFlag, statusCode = fwView.deleteRules(rows)
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
        statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function portTriggeringCfgInputVal(configRow)
    if (configRow["PortTriggering.RuleName"] == "") then
        printCLIError ("Enter valid rule name\n")
        return false
    end
    if (configRow["PortTriggering.RuleStatus"] == "") then
        printCLIError ("Enter valid rule status\n")
        return false
    end
    if (configRow["PortTriggering.Protocol"] == "") then
        printCLIError ("Enter valid protocol name\n")
        return false
    end
    if (configRow["PortTriggering.OutgoingPortStart"] == "") then
        printCLIError ("Enter valid starting port number of outgoing traffic\n")
        return false
    end
    if (configRow["PortTriggering.OutgoingPortEnd"] == "") then
        printCLIError ("Enter valid ending port number of outgoing traffic\n")
        return false
    end
    if (configRow["PortTriggering.IncomingPortStart"] == "") then
        printCLIError ("Enter valid starting port number of incoming traffic\n")
        return false
    end
    if (configRow["PortTriggering.IncomingPortEnd"] == "") then
        printCLIError ("Enter valid ending port number of incoming traffic\n")
        return false
    end
	if (configRow["PortTriggering.IncomingPortEnd"] ~= nil and configRow["PortTriggering.IncomingPortStart"] ~= nil)then
    		if (tonumber(configRow["PortTriggering.IncomingPortEnd"]) < tonumber(configRow["PortTriggering.IncomingPortStart"]))then
        		printCLIError ("Incoming end port  cannot be less than incoming start port")
        		return false
    end
	end
	if (configRow["PortTriggering.OutgoingPortEnd"] ~= nil and configRow["PortTriggering.OutgoingPortStart"] ~= nil)then
   		if (tonumber(configRow["PortTriggering.OutgoingPortEnd"]) < tonumber(configRow["PortTriggering.OutgoingPortStart"]))then
        		printCLIError ("Outgoing end port  cannot be less than incoming start port")
        		return false
    		end
	end

    
    return true
end

function portTriggeringCfgGet()
    local portTriggeringTable = db.getTable ("PortTriggering")
    local resultTab = {}
    local portTriggeringRow = nil
    local rowId = "0"

    printLabel ("Port Triggering")    
    printLabel ("List of Available Port Triggering Rules")    
    for col, val in pairs(portTriggeringTable) do
        rowId = rowId+1
        local portTriggeringRow = portTriggeringTable[rowId]
	if (rowId == nil) then
	    resTab.insertField (resultTab, "Port Triggering","Disabled" )
        else
	    resTab.insertField (resultTab, "ROW ID", 
			      portTriggeringRow["PortTriggering._ROWID_"] or "")
	    resTab.insertField (resultTab, "Name", 
			      portTriggeringRow["PortTriggering.RuleName"] or "")
	    if(portTriggeringRow["PortTriggering.RuleStatus"] == "0")then
                resTab.insertField (resultTab, "Enable", "No")
            else
                resTab.insertField (resultTab, "Enable", "Yes")
            end
            if(portTriggeringRow["PortTriggering.Protocol"] == "6")then
            resTab.insertField (resultTab, "Type", "TCP")
            elseif(portTriggeringRow["PortTriggering.Protocol"] == "17")then
            resTab.insertField (resultTab, "Type", "UDP")
            end -- if Type
	    if(portTriggeringRow["PortTriggering.Interface"] == "SECURE") then
		resTab.insertField (resultTab,"Interface","LAN")
	    else
		resTab.insertField (resultTab,"Interface","DMZ")
	    end
            resTab.insertField (resultTab, "Outgoing Start Port", 
			      portTriggeringRow["PortTriggering.OutgoingPortStart"] or "")
            resTab.insertField (resultTab, "Outgoing End Port", 
			      portTriggeringRow["PortTriggering.OutgoingPortEnd"] or "")
            resTab.insertField (resultTab, "Incoming Start Port", 
			      portTriggeringRow["PortTriggering.IncomingPortStart"] or "")
            resTab.insertField (resultTab, "Incoming End Port", 
			      portTriggeringRow["PortTriggering.IncomingPortEnd"] or "")
        end -- if rowid nil
    end -- for 
    resTab.print (resultTab, 0)
end

--
--
function portTriggeringStatusGet()

		local resultTab = {}
		local i = 0
		local table = db.getTable("PortTriggerStatus")
		printLabel ("Application Rules Status")
	        if (#table ~= 0)then
		  for k,v in pairs(table) do
			i = i + 1
			local row = table[i]
			 resTab.insertField (resultTab,"LAN/DMZ IP Address",row["PortTriggerStatus.LanIpAddr"])
			 local portrange=row["PortTriggerStatus.OpenPortRangeStart"].."-"..row["PortTriggerStatus.OpenPortRangeEnd"]
			 resTab.insertField (resultTab,"Open Ports",portrange)
			 resTab.insertField (resultTab,"Time Remaining(Sec)",row["PortTriggerStatus.TimeRemaining"])
       	    	  end
		end
		resTab.print (resultTab, 0)	

end
