--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### June 24, 2008

#### File: attackChecks.lua
#### Description: attacks Checks and IDS Configuration functions

#### Revisions:
None
]]--


--************* Requires *************
require "teamf1lualib/fwRules"

--************* Initial Code *************
--package attackChecks
attackChecks = {}
attackChecks6 = {}
--************* Functions *************
-- attackChecks config
function attackChecks.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    
    db.beginTransaction() --begin transaction
    local valid = false

    -- validate

    DBTable = "AttackChecks"
    valid = fw.config(inputTable, rowid, operation)

    if (valid) then
        DBTable = "IcsaSettings"
        valid = fw.config (inputTable, rowid, operation)

        if (valid) then
            DBTable = "FwDosAttackSettings"
            valid = fw.config (inputTable, rowid, operation)
        end
    end

    if(inputTable["AttackChecks.ExternalPing"] == "1" ) then 
         inputTable["AttackChecks6.ExternalPing"] = "1"
         
    elseif (inputTable["AttackChecks.ExternalPing"] == "0" ) then
        inputTable["AttackChecks6.ExternalPing"] = "0"
    end

    DBTable = "AttackChecks6"
    valid = fw.config(inputTable, rowid, operation)

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "FW_AC_CONFIG_FAILED"
    end
end

-- attackChecks config
function attackChecks.configGet ()
    local outTable = {}
    local attackChecksConfig = db.getRow ("AttackChecks","_ROWID_","1")
    outTable = util.tableAppend (outTable, attackChecksConfig)
    local icsaConfig = db.getRow ("IcsaSettings","_ROWID_","1")
    outTable = util.tableAppend (outTable, icsaConfig)
    local dosAttacksConfig = db.getRow ("FwDosAttackSettings","_ROWID_","1")
    outTable = util.tableAppend (outTable, dosAttacksConfig)

    if (outTable == nil) then
        outTable = {}
    end
    return outTable  
end


