#!/pfrm2.0/bin/lua 

-- bwLimitMax.lua 
-- Vaibhav 
-- TeamF1
-- 07/04/08
--
-- Modification History
-- 07aug08 vpp Chaged the types of PortNumber and VlanId fields in
--             trafficSelector table.
-- 04july08 vpp written
--
-- Description
-- The script will see the current speed at the interface on which the profile
-- is being added, every 3 secs. And accordingly update the
-- BandWidthProfileSpeed table and reinstall the qdiscs and class with new
-- speed.
-- 
--

--************* Requires *************
require "teamf1lualib/util"
require "teamf1lualib/db"


--************* Initial Code *************
db.connect(arg[1])
util.setDebugStatus(true)

--************* Logic *************

-- speed variable for getting speed.
local speed
local logicalWanId
local physicalWanId
local status
local OldWan2Speed
local OldWan1Speed

while (1) do
    ret = db.getRowsWhere ("BandWidthProfileStatus", "rowId != 0");
    for key,value in pairs (ret) do
        status = value ["BandWidthProfileStatus.Status"]
    end 
    if (status == "1") then 
        ret = db.getRowsWhere ("BandWidthProfile", "rowId != 0");        
        for key,value in pairs (ret) do
            logicalWanId = value ["BandWidthProfile.WANID"]
            local boardName = db.getAttribute ("unitName","_ROWID_","1","unitName")
            ret = db.getRowsWhere ("networkInterface", "LogicalIfName == '" .. logicalWanId .."'");
            for key, value1 in pairs (ret) do
                physicalWanId = value1 ["networkInterface.interfaceName"]

                if ((boardName == "RVS5000" or boardName == "WRVS5000") and logicalWanId == "WAN2") then
                    local file = assert (io.open("/tmp/portSpeed.4", "r"))
                    local speedValueOld = file:read(1)
                    assert (file:close())
                    
                    os.execute ("switchConfig /dev/bcm53980 duplex get 4")
                    local file = assert (io.open("/tmp/portSpeed.4", "r"))
                    local speedValue = file:read(1)
                    assert (file:close())

                    if (speedValue == speedValueOld) then
                    else
                        if (speedValue == "1") then
                            db.setAttributeWhere ("BandWidthProfileSpeed", "rowId != 0", "Wan2Speed", "10Mb/s");
                        elseif (speedValue == "2") then
                            db.setAttributeWhere ("BandWidthProfileSpeed", "rowId != 0", "Wan2Speed", "100Mb/s");
                        elseif (speedValue == "3") then
                            db.setAttributeWhere ("BandWidthProfileSpeed", "rowId != 0", "Wan2Speed", "1000Mb/s");
                        end
                        db.setAttributeWhere ("BandWidthProfileStatus", "rowId != 0" , "Status", 0);
                        os.execute ("sleep 1")
                        db.setAttributeWhere ("BandWidthProfileStatus", "rowId != 0" , "Status", 1);
                    end            
                else
                   local pfile = io.popen("/pfrm2.0/bin/ethtool" .. " " ..physicalWanId .. "|grep Speed | awk '{print $2}'" )
                    speed = pfile:read ("*a")
                    pfile:close()
                    -- remove new line character
                    speed = string.gsub (speed, "\n", "")              
            
                    table = db.getRowsWhere ("BandWidthProfileSpeed", "rowId != 0");
                    for k,value2 in pairs(table) do        
                        OldWan1Speed = value2 ["BandWidthProfileSpeed.Wan1Speed"]
                        OldWan2Speed = value2 ["BandWidthProfileSpeed.Wan2Speed"] 
                        
                        if (logicalWanId == "WAN1") then
                            if (OldWan1Speed == speed ) then
                            else
                                db.setAttributeWhere ("BandWidthProfileSpeed", "rowId != 0", "Wan1Speed", speed);
                                db.setAttributeWhere ("BandWidthProfileStatus", "rowId != 0" , "Status", 0);
                                os.execute ("sleep 1")
                                db.setAttributeWhere ("BandWidthProfileStatus", "rowId != 0" , "Status", 1);
                            end
                        elseif (logicalWanId == "WAN2") then
                            if (OldWan2Speed == speed ) then
                            else
                                db.setAttributeWhere ("BandWidthProfileSpeed", "rowId != 0", "Wan2Speed", speed);
                                db.setAttributeWhere ("BandWidthProfileStatus", "rowId != 0" , "Status", 0);
                                os.execute ("sleep 1")
                                db.setAttributeWhere ("BandWidthProfileStatus", "rowId != 0" , "Status", 1);
                            end
                        end
                    end
                end
            end 
        end 
    end
    os.execute ("sleep 3")                     
end



