-- ddnsCLI.lua 
-- Bhanu R
-- TeamF1
-- 09/19/08
--
-- Modification History
-- 19sep08 rbh written
--
-- Description
-- CLISH DDNS LUA routines
--

require "teamf1lualib/ddns"
--
--
function ddnsGet (args)
    local resultTab = {}
    local ddnsTable = nil

    local ddnsService = db.getAttribute ("ddns", "_ROWID_", 1 , "ddnsService")
    if (ddnsService == "0" ) then 
        print ("\n" .. "Dynamic DNS service currently disabled")
    else
        
        printLabel ("Dynamic DNS Service currently enabled.")
        ddnsTable = db.getRow ("ddns", "_ROWID_",1)
        resTab.insertField (resultTab, "Host Name: ",
                                      ddnsTable["ddns.hostname"] or "")
        resTab.insertField (resultTab, "Username: ",
                                      ddnsTable["ddns.username"] or "")
        resTab.insertField (resultTab, "Time Period: ",
                                      ddnsTable["ddns.timePeriod"] or "")
        resTab.insertField (resultTab, "Wild Flag: ",
                                      ddnsTable["ddns.wildflag"] or "")

        resTab.print (resultTab, 0)
    end
end

--
-- This routine saves the modified LAN configuration information.
function ddnsCfgSave(configRow)	 
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "ddns"

    errorFlag, statusCode = ddns.config (configRow, 1, "edit")
    if (statusCode == "STATUS_OK") then 
        errorFlag = "OK"		   
        db.save()
    else
    	statusCode = "DDNS_CONFIG_FAILED"
    end

    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage           	 
end

--
-- This routine reads in the current DDNS configuration information
-- into a configuration object.
function ddnsCfgInit(args)
    local rowId = 1

    local configRow = db.getRow("ddns","_ROWID_","rowId")
    if configRow == nil then
       return rowId, {}
    end
    rowId = configRow["ddns._ROWID_"]       
    return rowId, configRow
end

--
-- This routine validates the DDNS configuration information.
function ddnsCfgInputVal(configRow)
    if (configRow["ddns.ddnsService"] == "1") then  
        if (configRow["ddns.hostname"] == nil ) then
            printCLIError ("Invalid Hostname")
            return false
        end
        if (configRow["ddns.username"] == nil ) then
            printCLIError ("Invalid Username")
            return false
        end
        if (configRow["ddns.password"] == nil ) then
            printCLIError ("Invalid Password")
            return false
        end
        return true
    end
end

