-- dhcpcCLI.lua
-- Mohammad Rafi
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 24Sep08,rfi written
--
-- Description
-- CLISH dhcpc LUA routines

require "teamf1lualib/dhcpc"

--
-- get the field values from the dbase table
function DhcpcConfigGet ()
    local resultTab = {}
    
    local row = db.getRow ("Dhcpc", "_ROWID_", 1)
    resTab.insertField (resultTab, "Get DNS Automatically from ISP", row["Dhcpc.GetDnsFromIsp"])
    resTab.insertField (resultTab, "Primary DNS Server", row["Dhcpc.PrimaryDns"] or "")
    resTab.insertField (resultTab, "Secondary DNS Server", row["Dhcpc.SecondaryDns"] or "")
    
    printLabel ("DHCPC configuration")
    resTab.print (resultTab, 0)
end

--
-- This routine save UPnP configuration
function dhcpcConfigSave (configRow)
    local errorFlag = "ERROR"
    
    -- Write configuration to database
    errorFlag = dhcpc.config (configRow,configRow["Dhcpc._ROWID_"], "edit")
    if (errorFlag) then
        db.setAttribute ("NimfConf", "_ROWID_", "1","IfStatus","1")
        errorFlag = "OK"
        db.save()
    end

    return errorFlag
end

-- This routine takes in one argument that is the value of the
-- primary key for the object table.
function dhcpcConfigInit (args)
    local configRow = {}
    local rowId = 1 -- dhcpc table has only one row

    configRow = db.getRow("Dhcpc", "Dhcpc._ROWID_", rowId)
    return rowId, configRow
end

