--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### Mar 12, 2008
#### File: dmz.lua
#### Description: dmz Setup functions
#### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package DMZ Setup Configurations
dmz = {}

--************* Functions *************
-- Dmz Setup config
function dmz.config (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end

	db.beginTransaction() --begin transaction
	local valid = false

    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            valid = db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            valid = db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
            valid = false
        end
    end
    
	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "DMZ_CONFIG_FAILED"
	end
end
