--[[
#### Adarsh Uppula
#### TeamF1
#### www.TeamF1.com
#### June 29, 2007

#### File: ethernet.lua
#### Description: ethernet functions

#### Revisions:
None
]]--


--************* Requires *************


--************* Initial Code *************

--package ethernet
ethernet = {}

--************* Functions *************

-- ethernet config
function ethernet.ethernet_config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
 
    if (ethernet.config (inputTable, rowid, operation)) then
        return "OK", "STATUS_OK"
    else
        return "ERROR", "ETHERNET_PORT_CONFIG_FAILED"
    end
end

-- ethernet config
function ethernet.config (inputTable, rowid, operation)
    -- validate
    if (ethernet.inputvalidate(inputTable, operation)) then
        if (operation == "add") then
            return db.insert("ethernet", inputTable)
        elseif (operation == "edit") then
            return db.update("ethernet", inputTable, rowid)
        elseif (operation == "delete") then
            return nil
        end
    end
    return false
end

-- ethernet inputvalidate
function ethernet.inputvalidate (inputTable, operation)
    if (true) then
        return db.typeAndRangeValidate(inputTable)
    end
    return false
end

function ethernet.import (configTable)
    for i,v in ipairs (configTable) do
        v = util.addPrefix (v, "ethernet.");
        ethernet.config (v, -1, "add")
    end
end

function ethernet.export ()
    return db.getTable ("ethernet", false)
end

if (config.register) then
   config.register("ethernet", ethernet.import, ethernet.export)
end
