--[[
#### Adarsh Uppula
#### TeamF1
#### www.TeamF1.com
#### June 29, 2007

#### File: firewall.lua
#### Description: firewall functions

#### Revisions:
None
]]--


--************* Requires *************
--require "teamf1lualib/httpsMgmt"
--************* Initial Code *************

--package firewall 
--firewall = {}
telnetAccessMgmt = {}
fwAccessMgmt = {}

--table packages
blockSites = {}

--************* Functions *************

-- userdb config
function blockSites.blockSites_config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    db.beginTransaction() --begin transaction
    local valid = false
    
    -- config users
    rowid = db.getAttribute("blockSites", "keyword", 
                            inputTable["blockSites.keyword"], "_ROWID_")
    valid = blockSites.config(inputTable, rowid, operation)
    
    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "USERDB_CONFIG_FAILED"

    end
end

-- radius config
function blockSites.config (inputTable, rowid, operation)
    -- validate
        if (operation == "add") then
            return db.insert("blockSites", inputTable)
        elseif (operation == "edit") then
            return db.update("blockSites", inputTable, rowid)
        elseif (operation == "delete") then
            return db.delete("blockSites", inputTable)
        end
    return false
end

function telnetAccessMgmt.config (inputTable, rowid, operation)
	
	local accessMgmtTable = {}
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	db.beginTransaction() --begin transaction
--        print (" Crossed DB")
	local valid = false
	-- validate
	if (operation == "add") then
		return nil
	elseif (operation == "edit") then
--        print (" Came to Edit operation")
		accessMgmtTable["accessMgmt.accessMgmtEnable"]=inputTable["telnet.telnetEnable"]

--        print ("Sathya values" .. accessMgmtTable["accessMgmt.accessMgmtEnable"])
		accessMgmtTable["accessMgmt.serviceType"]="1"
		accessMgmtTable["accessMgmt.accessMgmtIP1"]=inputTable["telnet.telnetIP1"]
		accessMgmtTable["accessMgmt.accessMgmtIP2"]=inputTable["telnet.telnetIP2"]
	        accessMgmtTable["accessMgmt.accessType"]=inputTable["telnet.telnetAccessType"]

                accessMgmtTable["accessMgmt.port"]=inputTable["telnet.telnetPort"]
		valid =  db.update("accessMgmt", accessMgmtTable, "1")
	elseif (operation == "delete") then
		return nil
	end

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "Operation Succeeded"
	else
		db.rollback()
		return "ERROR", "ACCESSMGMT_CONFIG_FAILED"
	end

end

-- Function added to configure accessMgmt table
-- httpsMgmt config
function fwAccessMgmt.config (inputTable, rowid, operation)
        -- if not allowed to edit
        if (ACCESS_LEVEL ~= 0) then
            return "ACCESS_DENIED", "Administrator Privileges Are Required"
        end
        db.beginTransaction() --begin transaction
        local valid = false
        -- validate
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then
            inputTable["accessMgmt.serviceType"]="0"
            valid = db.update("accessMgmt", inputTable, "0")
        else
            return nil 
        end

        -- return
        if (valid) then
            db.commitTransaction(true)
            return "OK", "Operation Succeeded"
        else
            db.rollback()
            return "ERROR", "ACCESSMGMT_CONFIG_FAILED"
        end
end

-- Function added to configure Remote SNMP Option
function fwAccessMgmt.remoteSNMPConfig (inputTable, rowid, operation)
        -- if not allowed to edit
        if (ACCESS_LEVEL ~= 0) then
            return "ACCESS_DENIED", "Administrator Privileges Are Required"
        end
        db.beginTransaction() --begin transaction
        local valid = false

        -- validate
        if (operation == "add") then
            valid = db.insert("RemoteSnmp", inputTable)
        elseif (operation == "edit") then
            valid = db.update("RemoteSnmp", inputTable, "1")
        else
            return nil
        end

        -- return
        if (valid) then
            db.commitTransaction(true)
            return "OK", "Operation Succeeded"
        else
            db.rollback()
            return "ERROR", "Remote SNMP Configuration Failed"
        end
end
