--[[
#### Vivek Dutt Sharma.
#### TeamF1
#### www.TeamF1.com
#### November 26, 2009
#### File: firmware.lua
#### Description: Firmware version checks
#### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package firmConf
firmConf = {}
firmStatusConf={}

--************* Functions *************

-- Firmware config
function firmConf.config (inputTable, rowid, operation)
    -- validate
    local valid = false
    local STATUS_AVAILABLE = 1
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then 
        	local firmStatusTable={}
        	 firmStatusTable["FirmStatus.StatusAvailable"] = STATUS_AVAILABLE        	      	
            valid = db.update("FirmConf", inputTable, rowid) 
            if(valid) then 
	        valid = db.update("FirmStatus",firmStatusTable,rowid)
	        end
	    -- return
    	    if (valid) then
        	db.commitTransaction()
        	return "OK", "STATUS_OK"
            else
        	db.rollback()
        	return "ERROR", "Operation Failed"
            end
        elseif (operation == "delete") then
            return nil
        end
    end
    return false
end

function firmStatusConf.config (inputTable, rowid, operation)
    -- validate
    local valid = false
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then
            valid = db.update("(FirmStatus", inputTable, rowid)
	    -- return
    	    if (valid) then
        	db.commitTransaction()
        	return "OK", "STATUS_OK"
            else
        	db.rollback()
        	return "ERROR", "FIRMSTATUS_CONFIG_FAILED"
            end
        elseif (operation == "delete") then
            return nil
        end
    end
    return false
end


