-- ipModeCLI.lua
-- Samer Sayeed  
-- TeamF1
-- www.TeamF1.com

-- Modification History
-- 31jan09,ss   modified ipModeConfig routine to reboot device only when configurations are changed.
-- 26dec08,ss   written

-- Description
-- CLI interface set and get routines

require "teamf1lualib/nimfView"

function ipModeConfig(configRow)
    errorFlag = "ERROR"
    statusCode = ""
    statusMessage = ""
    local triesMax = 5 -- hard-coded
    local triesCur = 0
    local confirm = ""
    local reboot = "0"
    local message = "An IP Mode change will cause the device to re-boot.\n"

    local ipMode = db.getAttribute("networkInfo", "networkInfo._ROWID_","1", "netWorkMode")
    if (ipMode ~= configRow["networkInfo.netWorkMode"]) then
        printCLIError (message)
        while (confirm ~= "Y" and confirm ~= "N" and confirm ~= "y" and confirm ~= "n" and triesCur < triesMax) do
	    printCLIError ("Are you sure you want to proceed [Y/N]?")
	    confirm = io.stdin:read'*l'
	    triesCur = triesCur + 1
        end
        if (confirm == "N" or confirm == "n" or (triesCur == triesMax)) then
            errorFlag = "ERROR"
            statusMessage = "Action Cancelled"
            return errorFlag, statusMessage
        elseif(confirm == "Y" or confirm == "y") then reboot = "1" end
    end
    
    errorFlag, statusCode = nimfView.ipModeConfig (configRow, "1", "edit");
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    if (reboot == "1") then utilCLIReboot() end
    return errorFlag, statusMessage
end

function ipModeVal(configRow)
    return true
end

function ipModeInit(args)
        local row = 1
        local configRow = {}
        configRow = db.getRow("networkInfo", "_ROWID_", "1")
	if (configRow == nil) then
	    configRow = db.getDefaults(true, "networkInfo")
	end
        return row, configRow
end

function ipModeInfoGet()
    printLabel ("IP MODE")
    row = db.getRow("networkInfo", "networkInfo._ROWID_",1)
--  The networknfo table should have only one entry
     
    if (row["networkInfo.netWorkMode"] == "1") then
       print( " IPv4 only mode : Enabled")
    elseif (row["networkInfo.netWorkMode"] ~= "1") then 
       print( " IPv4 only mode : Disabled")
    end
    if (row["networkInfo.netWorkMode"] == "3") then
       print( " IPv4/IPv6 mode : Enabled")
    elseif (row["networkInfo.netWorkMode"] ~= "3") then 
       print( " IPv4/IPv6 mode : Disabled")    
    end
end
