--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### June 17, 2008

#### File: ips.lua
#### Description: IPS functions

#### Revisions:
None
]]--

--************* Requires *************

--************* Initial Code *************
--package ips
ips = {}
--************* Functions *************
-- ids config
function ips.configUpdate (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return false
        elseif (operation == "edit") then
            return db.update(DBTable,inputTable,rowid)
        elseif (operation == "delete") then
            return false
        end
    end
end

function ips.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
    local valid = false

    DBTable = "IPSConfig"
    valid = ips.configUpdate (inputTable, rowid, operation)

    if (valid) then
        DBTable = "IPSNetworkSegments"
        local lanWanRow = db.getRowWhere ("IPSNetworkSegments","FromZoneType = 'SECURE' and ToZoneType = 'INSECURE'")
        if (lanWanRow ~= nil) then
            lanWanRow["IPSNetworkSegments.ipsEnable"] = inputTable["IPSNetworkSegments.ipsEnable1"]
            valid = ips.configUpdate (lanWanRow, lanWanRow["IPSNetworkSegments._ROWID_"], operation)
            if (valid and inputTable["IPSNetworkSegments.ipsEnable2"] ~= nil) then
                local dmzWanRow = db.getRowWhere ("IPSNetworkSegments","FromZoneType = 'PUBLIC' and ToZoneType = 'INSECURE'")
                if (dmzWanRow ~= nil) then
                    dmzWanRow["IPSNetworkSegments.ipsEnable"] = inputTable["IPSNetworkSegments.ipsEnable2"]
                    valid = ips.configUpdate (dmzWanRow, dmzWanRow["IPSNetworkSegments._ROWID_"], operation)
                else
                    db.rollback()
                    return "ERROR", "IPS_CONFIG_FAILED"
                end
            end
        else
            db.rollback()
            return "ERROR", "IPS_CONFIG_FAILED"
        end
		
    end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "IPS_CONFIG_FAILED"
    end
end

function ips.configGet ()
    local ipsConfig = db.getRow("IPSConfig","_ROWID_", "1")
    if (ipsConfig == nil) then
        ipsConfig = {}
    end
    local lanWanRow = db.getRowWhere ("IPSNetworkSegments","FromZoneType = 'SECURE' and ToZoneType = 'INSECURE'")
    if (lanWanRow ~= nil) then
        ipsConfig["IPSNetworkSegments.ipsEnable1"] = lanWanRow["IPSNetworkSegments.ipsEnable"] or ''
    end
    local dmzWanRow = db.getRowWhere ("IPSNetworkSegments","FromZoneType = 'PUBLIC' and ToZoneType = 'INSECURE'")
    if (dmzWanRow ~= nil) then
        ipsConfig["IPSNetworkSegments.ipsEnable2"] = dmzWanRow["IPSNetworkSegments.ipsEnable"] or ''
    end
    
    local ipsStatus = db.getRow("IPSStatus","_ROWID_", "1")
    if (ipsStatus ~= nil) then
        ipsConfig["IPSStatus.numRules"] = ipsStatus["IPSStatus.numRules"]
        ipsConfig["IPSStatus.numAlerts"] = ipsStatus["IPSStatus.numAlerts"]
        ipsConfig["IPSStatus.numDrops"] = ipsStatus["IPSStatus.numDrops"] + ipsStatus["IPSStatus.numRejects"];
    end

    return ipsConfig
end
