--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### Aug 11, 2009
#### File: l2tpServer.lua
#### Description: l2tpServer functions
#### Revisions:
]]--


--table packages
l2tpServer = {}

--************* Functions *************
-- l2tpServer config
function l2tpServer.config (inputTable, rowid, operation)
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
           return db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
           return db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
           return db.delete(DBTable, inputTable)
        end
    else
        return false
    end
end


function l2tpServer.serverConfig (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	
	db.beginTransaction() --begin transaction
	local valid = false

    valid = l2tpServer.config (inputTable, rowid, operation)

    -- return
	if (valid) then
		db.commitTransaction()
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "L2TP_SERVER_CONFIG_FAILED"
	end
end


-- L2TP User config
function l2tpServer.userConfig (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	
	db.beginTransaction() --begin transaction
	local valid = false
	
	if (operation == "add") then
        local defaultTable=db.getDefaults(true,"USERDBUsers")
        inputTable["USERDBUsers.GroupName"]=defaultTable["USERDBUsers.GroupName"]
        inputTable["USERDBUsers.UserTimeOut"]=defaultTable["USERDBUsers.UserTimeOut"]
        inputTable["USERDBUsers.groupid"]=1--defaultTable["USERDBUsers.groupid"]
        inputTable["USERDBUsers.DenyLogin"]=defaultTable["USERDBUsers.DenyLogin"]
        inputTable["USERDBUsers.DenyLoginFromWan"]=defaultTable["USERDBUsers.DenyLoginFromWan"]
        inputTable["USERDBUsers.LoginFromIP"]=defaultTable["USERDBUsers.LoginFromIP"]
        inputTable["USERDBUsers.LoginFromBrowser"]=defaultTable["USERDBUsers.LoginFromBrowser"]        
    end
    if (operation == "edit") then
        if (util.isAllMasked (inputTable["USERDBUsers.Password"])) then
            inputTable["USERDBUsers.Password"] = db.getAttribute ("USERDBUsers", "_ROWID_", rowid, "password")
        end
    end
    valid = l2tpServer.config (inputTable, rowid, operation)

    -- return
	if (valid) then
		db.commitTransaction()
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "L2TP_OP_FAILED"
	end
end

function l2tpServer.delete(rowIds)

	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end

	db.beginTransaction() --begin transactions
    local valid = true
    local errStr = "STATUS_OK"

    for k,v in pairs(rowIds) do
        local inTable = {}
        inTable["USERDBUsers._ROWID_"] = v;
        valid = l2tpServer.config(inTable, "-1", "delete")
        if (valid == false) then
            errStr = "L2TP_DELETE_FAILED"
            break
        end
    end

    if (valid ~= false) then
        errStr = "L2TP_DELETED"
    end

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", errStr
	else
		db.rollback()
		return "ERROR", errStr
	end
end


