-- l2tpdCLI.lua
-- Ravindranath
-- TeamF1
-- www.TeamF1.com

-- Modification History
-- 08mar10,rac Added
require "teamf1lualib/l2tpServer"

function l2tpServerCfgInit(args)
	configRow = db.getRow ("Xl2tpServerIPRange", "_ROWID_", "1")
	return 1,configRow
end

function l2tpServerCfgSave(configRow)
	local errorFlag="ERROR"
	local statusCode=""
	local statusMessage=""
	DBTable="Xl2tpServerIPRange"
	errorFlag, statusCode = l2tpServer.serverConfig (configRow, "1", "edit")
	    if (errorFlag == "OK") then db.save() end
		statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
	return errorFlag,statusMessage
end

function l2tpServerInputVal(configRow)
	
	if (configRow["Xl2tpServerIPRange.Xl2tpdEnable"] == "1")then
		if (configRow["Xl2tpServerIPRange.StartIPAddress"] == nil or configRow["Xl2tpServerIPRange.StartIPAddress"] == "" or configRow["Xl2tpServerIPRange.StartIPAddress"] == "0.0.0.0")then
			printCLIError("Invalid l2tp server start address range")
			return false
		end
	if (configRow["Xl2tpServerIPRange.EndIPAddress"] == nil or configRow["Xl2tpServerIPRange.EndIPAddress"] == "" or configRow["Xl2tpServerIPRange.EndIPAddress"] == "0.0.0.0")then
			printCLIError("Invalid l2tp server  end address range")
			return false
		end

	end
	return true
end
function l2tpdtGet()
	local state
	local resultTab={}
	configRow = db.getRow ("Xl2tpServerIPRange", "_ROWID_", "1")
		printLabel("L2TP Server Configuration")
		if (configRow["Xl2tpServerIPRange.Xl2tpdEnable"] == "0")then
			state="Disabled"
		else
			state="Enabled"
		end 
		resTab.insertField (resultTab,"L2TP Server Status",state)
		resTab.insertField (resultTab,"L2TP Starting IP Address",configRow["Xl2tpServerIPRange.StartIPAddress"] or '')
		resTab.insertField (resultTab,"L2TP server Ending IP Address",configRow["Xl2tpServerIPRange.EndIPAddress"] or '')
		resTab.print (resultTab,0)
end

function l2tpdtclientGet()
	local resultTab={}
	local l2tpSvrEnabled = db.getAttribute ("Xl2tpServerIPRange", "_ROWID_", "1", "l2tpdEnable") or '0'
	printLabel("List of L2TP Active Users")
	if (l2tpSvrEnabled == "1") then
		local i = 0
		local table = db.getTable("Xl2tpActiveUsers")
		for k,v in pairs(table) do
			i = i + 1							
			local row = table[i]							
				resTab.insertField (resultTab,"User Name",row["Xl2tpActiveUsers.userName"] or '')
				resTab.insertField (resultTab,"Remote IP",row["Xl2tpActiveUsers.RemoteIP"] or '')
				resTab.insertField (resultTab,"L2TP IP",row["Xl2tpActiveUsers.Xl2tpIP"] or '')
		end
		resTab.print (resultTab,0)
	end
end
