--[[
#### Hussain Vali
#### TeamF1
#### www.TeamF1.com
#### Mar 28, 2008

#### File: lanGroups.lua
#### Description: Lan Groups functions

#### Revisions:
None
]]--


--************* Requires *************

--************* Initial Code *************

lanGroups = {}
lanHost = {}

--************* Functions *************

-- lan Groups config
function lanGroups.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    db.beginTransaction() --begin transaction
    local valid = false

	-- validate
	if (lanGroups.inputvalidate(inputTable, operation)) then
        if (operation == "add") then
            if (checkValidGroupName (inputTable["LanGroup.GroupName"])) then
                valid = db.insert("LanGroup", inputTable)
            else
                db.rollback()
                return "ERROR", "GROUPS_NAME_ALREADY_EXIXSTS"
            end
        elseif (operation == "edit") then
            valid = false
        elseif (operation == "delete") then
            for k,v in pairs(inputTable) do
                local groupName = db.getAttribute("LanGroup", "LanGroup._ROWID_", v, "GroupName")
                local inUseRows = db.existsRowWhere("BlockSites", "KeywordBlockingTo = '" .. groupName .. "'")
                if (inUseRows) then
                    db.rollback()
		            return "ERROR", "GROUPNAME_BLOCKED_KEYWORD_MAP_IN_USE"
                end
                local usingRows = db.getRowsWhere("LanHost", "GroupName = '" .. groupName .. "'")
                if (usingRows ~= nil) then
                    for l,m in pairs(usingRows) do
                        valid = lanHost.config (m, "-1", "delete")
                        if (valid) then
                        else
                            db.rollback()
    		                return "ERROR", "LAN_HOST_CONFIG_FAILED"
                        end
                    end
                end
            end
            valid = db.delete("LanGroup", inputTable)
        end
	end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "LAN_GROUPS_CONFIG_FAILED"
    end
end

-- lan Groups inputvalidate
function lanGroups.inputvalidate (inputTable, operation)
	if (true) then
		return db.typeAndRangeValidate(inputTable)
	end
	return false
end

function checkValidGroupName (grpName)
	local table = db.getTable ("LanGroup")
	local i = 0
	for k,v in pairs(table) do
		i = i + 1
		local row = table[i]
        if (string.lower (grpName) == string.lower (row["LanGroup.GroupName"])) then
            return false
        end
    end
    return true
end

function lanHost.config (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	
	db.beginTransaction() --begin transaction
	local valid = false
    
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            valid = db.insert("LanHost", inputTable)
        elseif (operation == "edit") then
            valid = db.update("LanHost", inputTable, rowid)
        elseif (operation == "delete") then
            valid = db.delete("LanHost", inputTable)
        end
    end

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "LAN_HOST_CONFIG_FAILED"
	end
end
