--[[
#### Hussain Vali
#### TeamF1
#### www.TeamF1.com
#### July 03, 2008
#### File: logConfig.lua
#### Description: logging functions
#### Revisions:
]]--

--************* Initial Code *************

--package logging
logConfig = {}
log = {}

--************* Functions *************
-- services config
function logConfig.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
    	return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
	local valid = false

    DBTable = "FirewallLogs"
    valid = log.config(inputTable, rowid, operation)
    if(valid) then
        DBTable = "OtherSystemLogs"
        valid = log.config(inputTable, rowid, operation)
    end

    if(valid and inputTable["logConfig.information"] ~= nil) then
        DBTable = "logConfig"
        local logConfigRow = db.getRowWhere ("logConfig", "facility='Local1-UTM'")
        if (logConfigRow ~= nil) then
            logConfigRow["logConfig.information"] = inputTable["logConfig.information"]
            valid = log.config(logConfigRow, logConfigRow["logConfig._ROWID_"], "edit")
        else
            valid = false
        end
    end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "LOGGING_CONFIG_FAILED"
    end
end

function logConfig.configGet ()
    local outTable = {}
    local firewallGet = db.getRow("FirewallLogs","_ROWID_", "1")
    outTable = util.tableAppend (outTable, firewallGet)
    local otherSysGet = db.getRow("OtherSystemLogs","_ROWID_", "1")
    outTable = util.tableAppend (outTable, otherSysGet)

    if (outTable == nil) then
        outTable = {}
    end
    
    local logConfigRow = db.getRowWhere ("logConfig", "facility='Local1-UTM'")
    if (logConfigRow ~= nil) then
        outTable["logConfig.information"] = logConfigRow["logConfig.information"]
    end

    return outTable
end

-- log config
function log.config (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return false
        elseif (operation == "edit") then
            return db.update(DBTable,inputTable,rowid)
        elseif (operation == "delete") then
            return false
        end
    else
        return false
    end
end

function logConfig.ipv6LogConfig (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
    	return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
	local valid = false

    valid = log.config(inputTable, rowid, operation)

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "LOGGING_CONFIG_FAILED"
    end
end
