--[[
#### Hussain Vali
#### TeamF1
#### www.TeamF1.com
#### July 02, 2007

#### File: login.lua
#### Description: Login functions.

#### Revisions:
None
]]--


--************* Requires *************

require "teamf1lualib/db"
require "sslvpnLuaLib"
require "timeLib"

--************* Initial Code *************

--package login
login = {}
--************* Functions *************
--Authenticate with given account data and account table.
--Returns false if account with matching info not exists.
--if account with matching info exists its call login function.
function login.login (tableInput)
	local username = tableInput["USERDBUsers.UserName"]
	local password = tableInput["USERDBUsers.Password"]
	local userAgent = tableInput["Login.userAgent"]
    local userConfig = db.getRow ("USERDBUsers","UserName",username)
    local status = false
    if (userConfig ~= nil) then
	local userType = db.getAttribute ("USERDBUsers", "UserName", username, "UserType")
        local groupName = db.getAttribute ("USERDBUsers", "UserName", username, "GroupName")
        local domainName = db.getAttribute ("USERDBGroups","GroupName",groupName,"DomainName")
        local domainName = db.getAttribute ("USERDBGroups","GroupName",groupName,"DomainName")
        local portalName = db.getAttribute ("USERDBDomains","DomainName",domainName,"PortalLayoutName")
        if (Page == SSL_PORTAL_LOGIN_PAGE) then
		local selectedPortalName = tableInput["Login.PortalName"]
            if (selectedPortalName == nil) then
                return 3, "Failed to find Portal Information"
            elseif (selectedPortalName ~= portalName) then
		if(userType == "3") then 
			return 3, "Admin User authentication Failed."
		elseif(userType == "4") then 
			return 3,"Guest User authentication Failed."
		elseif(userType == "0") then
                 	return 3, "USERDBUsers authentication Failed. Use the correct SSL portal URL to login."
  
		end
            end
        else
            local defaultPortalName = db.getAttribute ("SSLVPNPortalLayout","DefaultPortal","2","PortalLayoutName")
            if (defaultPortalName == nil) then
                defaultPortalName = db.getAttribute ("SSLVPNPortalLayout","DefaultPortal","1","PortalLayoutName")
            end
            if (defaultPortalName ~= portalName) then
                return 3, "User authentication Failed. Only default portal's users should be allowed to login."
            end
        end
        local status, errMsg = sslvpnLuaLib.sslLoginPolicyVerify (username, SAPI.Request.servervariable("REMOTE_ADDR"), SAPI.Request.servervariable("SERVER_ADDR"), userAgent)
        if (status == -1) then
            return 3, errMsg
        end
	local httpReferer = login.parseReferer (os.getenv("HTTP_REFERER"))
        local loginState, uniqueVal, errorMsg, prev = sslvpnLuaLib.sslLogin (username, password, domainName, SAPI.Request.servervariable("REMOTE_ADDR"), SAPI.Request.servervariable("SERVER_ADDR"), userAgent, SAPI.Request.servervariable("URL"), httpReferer)
        if (loginState == -1) then
		if(userType == "3") then
            		return -1, "Invalid Password for Admin User."
		elseif(userType == "4") then
            		return -1, "Invalid Password for Guest User."

		elseif(userType == "0") then
			return -1, "Invalid Password for USERDBUsers."

		end
        elseif (loginState == 0) then
            cgilua.cookies.set("TeamF1Login", uniqueVal)            
            ACCESS_LEVEL = prev
            return 0,"OK",nil,uniqueVal
        elseif (loginState == -2) then
            return 1,errorMsg,tableInput
        elseif (loginState == -4) then
            cgilua.cookies.set("TeamF1Login", uniqueVal)            
            ACCESS_LEVEL = prev
            return 2,errorMsg
        else
            return 3,errorMsg
        end
    end

	--- check for rows
    if(status == false) then
       statusCode = "LOGIN_INVALID_PASSWORD"
    end
	return -1, statusCode
end

function login.loginxml (tableInput)
	local username = tableInput["USERDBUsers.UserName"]
	local password = tableInput["USERDBUsers.Password"]
	local userAgent = tableInput["Login.userAgent"]
    local userConfig = db.getRow ("USERDBUsers","UserName",username)
    local status = false
    if (userConfig ~= nil) then
	local userType = db.getAttribute ("USERDBUsers", "UserName", username, "UserType")
        local groupName = db.getAttribute ("USERDBUsers", "UserName", username, "GroupName")
        local domainName = db.getAttribute ("USERDBGroups","GroupName",groupName,"DomainName")
        local domainName = db.getAttribute ("USERDBGroups","GroupName",groupName,"DomainName")
        local portalName = db.getAttribute ("USERDBDomains","DomainName",domainName,"PortalLayoutName")
        if (Page == SSL_PORTAL_LOGIN_PAGE) then
		local selectedPortalName = tableInput["Login.PortalName"]
            if (selectedPortalName == nil) then
                return 3, "Failed to find Portal Information"
            elseif (selectedPortalName ~= portalName) then
		if(userType == "3") then 
			return 3, "Admin User authentication Failed."
		elseif(userType == "4") then 
			return 3,"Guest User authentication Failed."
		elseif(userType == "0") then
                 	return 3, "USERDBUsers authentication Failed. Use the correct SSL portal URL to login."
  
		end
            end
        else
            local defaultPortalName = db.getAttribute ("SSLVPNPortalLayout","DefaultPortal","2","PortalLayoutName")
            if (defaultPortalName == nil) then
                defaultPortalName = db.getAttribute ("SSLVPNPortalLayout","DefaultPortal","1","PortalLayoutName")
            end
            if (defaultPortalName ~= portalName) then
                return 3, "User authentication Failed. Only default portal's users should be allowed to login."
            end
        end
        local status, errMsg = sslvpnLuaLib.sslLoginPolicyVerify (username, SAPI.Request.servervariable("REMOTE_ADDR"), SAPI.Request.servervariable("SERVER_ADDR"), userAgent)
        if (status == -1) then
            return 3, errMsg
        end
	local httpReferer = login.parseReferer (os.getenv("HTTP_REFERER"))
        local loginState, uniqueVal, errorMsg, prev = sslvpnLuaLib.sslLogin (username, password, domainName, SAPI.Request.servervariable("REMOTE_ADDR"), SAPI.Request.servervariable("SERVER_ADDR"), userAgent, SAPI.Request.servervariable("URL"), httpReferer)
        if (loginState == -1) then
		if(userType == "3") then
            		return -1, "Invalid Password for Admin User."
		elseif(userType == "4") then
            		return -1, "Invalid Password for Guest User."

		elseif(userType == "0") then
			return -1, "Invalid Password for USERDBUsers."

		end
        elseif (loginState == 0) then
            --cgilua.cookies.set("TeamF1Login", uniqueVal)            
            ACCESS_LEVEL = prev
            return 0,"OK",nil,uniqueVal
        elseif (loginState == -2) then
            return 1,errorMsg,tableInput
        elseif (loginState == -4) then
            cgilua.cookies.set("TeamF1Login", uniqueVal)            
            ACCESS_LEVEL = prev
            return 2,errorMsg
        else
            return 3,errorMsg
        end
    end

	--- check for rows
    if(status == false) then
       statusCode = "LOGIN_INVALID_PASSWORD"
    end
	return -1, statusCode
end

-- Function for forced login
function login.forcedLogin (tableInput)
	local username = tableInput["USERDBUsers.UserName"]
	local password = tableInput["USERDBUsers.Password"]
	local userAgent = tableInput["Login.userAgent"]
    local userConfig = db.getRow ("USERDBUsers","UserName",username)
    local status = false
    if (userConfig ~= nil) then
        local groupName = db.getAttribute ("USERDBUsers", "UserName", username, "GroupName")
        local domainName = db.getAttribute ("USERDBGroups","GroupName",groupName,"DomainName")
        local status, errMsg = sslvpnLuaLib.sslLoginPolicyVerify (username, SAPI.Request.servervariable("REMOTE_ADDR"), SAPI.Request.servervariable("SERVER_ADDR"), userAgent)
        if (status == -1) then
            return 3, errMsg
        end
	local httpReferer = login.parseReferer (os.getenv("HTTP_REFERER"))
        local loginState, uniqueVal, errorMsg, prev = sslvpnLuaLib.sslForcedLogin (username, password, domainName, SAPI.Request.servervariable("REMOTE_ADDR"), SAPI.Request.servervariable("SERVER_ADDR"), userAgent, SAPI.Request.servervariable("URL"), httpReferer)
        if (loginState == -1) then
            return -1, "LOGIN_INVALID_PASSWORD"
        elseif (loginState == 0) then
            cgilua.cookies.set("TeamF1Login", uniqueVal)            
            ACCESS_LEVEL = prev
            return 0
        elseif (loginState == -4) then
            cgilua.cookies.set("TeamF1Login", uniqueVal)            
            ACCESS_LEVEL = prev
            return 2, errorMsg
        else
            return 3, errorMsg
        end
    end

	--- check for rows
    if(result == false) then
       statusCode = "LOGIN_INVALID_PASSWORD"
    end
	return -1, statusCode
end

-- Revalidate current login before proceeding.
-- Returns 0 if login ok, 1 if no cookie
-- 2 if cookie but no session, 3 if cookie but
-- expired session, and 4 if only authenticated, not logged in.
function login.revalidate (cookieVal, ipaddr)
	-- if no cookie, go to login page
    if (cookieVal == nil) then
		util.appendDebugOut("PLEASE LOGIN - NOT LOGGED IN YET! - no cookie<br>")
		return "NO_COOKIE"
	else
		local wherePart = "LoginAddress = '" .. ipaddr .. "' AND Cookie = '" .. cookieVal .. "'"
		local row = db.getRowWhere("SSLVPNActiveUsers", wherePart)
        local status,upTime = timeLib.uptime()

		-- if no matching session
		if (row == nil) then
			util.appendDebugOut("PLEASE RELOGIN - LOGIN EXPIRED! - someone else killed your expired session<br>")
			statusMessage = db.getAttribute("stringsMap", "stringId", "LOGIN_SESSION_EXPIRED", LANGUAGE) or "NO_SESSION"
			return "NO_SESSION"
		-- logged in, so reset time
		else
            local status, errMsg, priv = sslvpnLuaLib.sslLoginSessionValidate(cookieVal, ipaddr)
            -- if expired login
            if (status == -1) then
    			util.appendDebugOut("PLEASE RELOGIN - LOGIN EXPIRED! - you waited too long<br>")
	    		statusMessage = db.getAttribute("stringsMap", "stringId", "LOGIN_SESSION_EXPIRED", LANGUAGE)
		    	return "EXPIRED_SESSION"                
            end
			util.appendDebugOut("YOU ARE ALREADY LOGGED IN!<br>")
			db.setAttributeWhere("SSLVPNActiveUsers", wherePart, "LastAccessTime", upTime)
			-- set access level
			ACCESS_LEVEL = priv
			return "OK"
		end
	end
end

-- Log out current user. Deletes session.
function login.logout (cookieVal, ipaddr)
	if (cookieVal ~= nil) then
		local wherePart = "LoginAddress = '" .. ipaddr .. "' AND Cookie = '" .. cookieVal .. "'"
		-- delete session
        local status =  sslvpnLuaLib.sslLogout(cookieVal)
        -- set prive levels
        ACCESS_LEVEL = 1 -- setting as GUEST
        -- delete activeUser's Table Entry
		db.deleteRowWhere("SSLVPNActiveUsers", wherePart)
        -- Clean the Cookie
        cgilua.cookies.set("TeamF1Login", cgilua.cookies.get("TeamF1Login"), {expires=-1})
		return 0 --success
	else
		return 1
	end
end

-- Log out current user. Deletes session.
function login.logoutxml (cookieVal, ipaddr)
	if (cookieVal ~= nil) then
		local wherePart = "LoginAddress = '" .. ipaddr .. "' AND Cookie = '" .. cookieVal .. "'"
		-- delete session
        local status =  sslvpnLuaLib.sslLogout(cookieVal)
        -- set prive levels
        ACCESS_LEVEL = 1 -- setting as GUEST
        -- delete activeUser's Table Entry
		db.deleteRowWhere("SSLVPNActiveUsers", wherePart)
        -- Clean the Cookie
        --cgilua.cookies.set("TeamF1Login", cgilua.cookies.get("TeamF1Login"), {expires=-1})
		return 0 --success
	else
		return 1
	end
end

-- validate referer value for restricted pages
function login.refererValidation (cookieVal, ipaddr, refererVal)
    if (cookieVal ~= nil and ipaddr ~= nil) then	
        local wherePart = "LoginAddress = '" .. ipaddr .. "' AND Cookie = '" .. cookieVal .. "'"
        local row = db.getRowWhere("SSLVPNActiveUsers", wherePart)

        if (row == nil) then
            return true
        elseif(row["SSLVPNActiveUsers.RefererValue"] ~= nil and row["SSLVPNActiveUsers.RefererValue"] ~= refererVal) then
            return false
        end
    end
    return true
end

-- parse the http referer value
function login.parseReferer (refererVal)
    local refValue = ""
    -- splitting referer val to get the ipaddress/domain name
    -- https://networkName:portNumb/ or http://networkName/
    local splitRefVal = util.split(refererVal,"//")
    if (splitRefVal ~= false) then
        if (splitRefVal[2] ~= nil) then
            local networkName = util.split(splitRefVal[2], "/")
            refValue = networkName[1] or ''
        end
    end

    return refValue
end
