--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### July 08, 2008

#### File: multiLan.lua
#### Description: Multi LAN functions

#### Revisions:
None
]]--


--************* Requires *************

--************* Initial Code *************
--package multiLan
multiLan = {}
--************* Functions *************
-- multiLan config
function multiLan.Config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    
    db.beginTransaction() --begin transaction
    local valid = false

    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
             valid = db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            valid = db.update(DBTable,inputTable,rowid)
        elseif (operation == "delete") then
            valid = db.delete(DBTable, inputTable)
        end
    end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        if (operation == "delete") then
            return "ERROR", "MULTI_CONFIG_DELETE_FAILED"
        else
            return "ERROR", "MULTI_CONFIG_FAILED"            
        end
    end
end

-- ipv6 multiLan config
function multiLan.ipv6Config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    
    db.beginTransaction() --begin transaction
    local valid = false

    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
             valid = db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            valid = db.update(DBTable,inputTable,rowid)
        elseif (operation == "delete") then
            valid = db.delete(DBTable, inputTable)
        end
    end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        if (operation == "delete") then
            return "ERROR", "IPV6_MULTI_CONFIG_DELETE_FAILED"
        else
            return "ERROR", "IPV6_MULTI_CONFIG_FAILED"            
        end
    end
end
