-- securityCLI.lua
-- Neelima
-- TeamF1
-- 20/09/08
-- 
-- Modification History
-- 04mar10,db   modified for to add transparent mode support
-- 14feb09,ss   did modifications for spr#10747 
-- 27dec08,ss   did modifications for rmi
-- 20sep08,nlm, written
--
-- Description
-- CLISH NAT LUA routines
--
-- Required Libraries
require "teamf1lualib/fwView"



-- This function displays the current NAT configuration
function NATInfoGet (args)
    local resultTab = {}
    printLabel (" Routing Mode between WAN and LAN ")
    row = db.getRow("NatTable", "NatTable._ROWID_",1)
--  The NatTable table should have only one entry
    
    if (row["NatTable.Enable"] == "0") then
       print( " NAT is Disabled")
       print( " Classical Routing is Enabled")
    elseif (row["NatTable.Enable"] == "1") then
       print( " NAT is Enabled")
    elseif (row["NatTable.Enable"] == "5") then
       print( " Transparent Routing is Enabled")
    end
end

-- This routine saves the modified NAT Configuration Information
function natCfgSave(configRow)
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    local triesMax = 5 -- hard-coded
    local triesCur = 0
    local confirm = ""
    local configSave = "0"
    local natMessage = "Enabling NAT will revert all DMZ and inbound firewall settings to defaults.\n"
    local crMessage = "Enabling Classical Routing will revert all DMZ and inbound firewall settings to defaults.\n"
    DBTable = "NatTable"

    if (configRow["NatTable.Enable"] == "0") then
        printCLIError (crMessage)
    elseif (configRow["NatTable.Enable"] == "1") then
        printCLIError (natMessage)
    end
    while (confirm ~= "Y" and confirm ~= "N" and confirm ~= "y" and confirm ~= "n" and triesCur < triesMax) do
	    printCLIError ("Are you sure you want to proceed? [Y/N]?")
	    confirm = io.stdin:read'*l'
	    triesCur = triesCur + 1
    end
    if (confirm == "N" or confirm == "n" or (triesCur == triesMax)) then
            errorFlag = "ERROR"
            statusMessage = "Action Cancelled"
            return errorFlag, statusMessage
    elseif(confirm == "Y" or confirm == "y") then configSave = "1" end
    
    if (configSave) then
    errorFlag, statusCode = fwView.nwModeConfig(configRow, "1", "edit")
    if (errorFlag == "OK") then
        db.save()
    end
    end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

-- This routine reads in the current NAT information into a configuration object
function natCfgInit(args)
    local rowId = 1
    local configRow = db.getRow("NatTable","_ROWID_",rowId)
    
    if configRow == nil then 
       return rowId, {}
    end
    rowId = configRow["NatTable._ROWID_"]
    return rowId, configRow
end

    
