--[[
#### Chaitanya Dandamudi
#### TeamF1
#### www.TeamF1.com
#### October 18, 2007

#### File: net-snmp.lua
#### Description: snmp functions

#### Revisions:01b, 06may09,til integrated snmpv3 configuration support
None
]]--


--************* Requires *************
--************* Initial Code *************

--package snmp
snmp = {}

--************* Functions *************
-- snmp config
function snmp.config (inputTable, rowid, operation, tableName)
        -- validate
        if (snmp.inputvalidate(inputTable, operation)) then
                if (operation == "add") then
                        return db.insert(tableName,inputTable)
                elseif (operation == "edit") then
                        return db.update(tableName, inputTable, rowid)
                elseif (operation == "delete") then
                        return db.delete(tableName,inputTable)
                end
        end

      return false
end

-- snmp inputvalidate
function snmp.inputvalidate (inputTable, operation)
        if (true) then
                return db.typeAndRangeValidate(inputTable)
        end
        return false
end


-- system configuration
function snmp.system_config (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	local valid = false
	-- config system
	valid = snmp.config(inputTable, rowid, operation, "system")
	
	-- return
	if (valid) then
		return "OK", "STATUS_OK"
	else
		return "ERROR", "SYS_CONFIG_FAILED"
	end
end

-- snmp trap configuration
function snmp.snmpTrap_config (inputTable, rowid, operation)
        -- if not allowed to edit
        if (ACCESS_LEVEL ~= 0) then
            return "ACCESS_DENIED", "ADMIN_REQD"
        end
        local valid = false
        -- config snmpTrap
        valid = snmp.config(inputTable, rowid, operation, "snmpTrap")

        -- return
        if (valid) then
            return "OK", "STATUS_OK"
        else
            return "ERROR", "SNMP_TRAPS_CONFIG_FAILED"
        end
end

--snmp access control configuration
function snmp.snmpAccessControl_config(inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~=0) then
	    return "ACCESS_DENIED", "ADMIN_REQD"
	end

	local valid= false
	--config snmpAccessControl
	if(operation == "edit" or operation == "add") then
		local where = "ipAddr = '" .. inputTable["snmpAccessControl.ipAddr"] .. "' and " .."subnetMask = '" .. inputTable["snmpAccessControl.subnetMask"] .."'"
    	if(db.existsRowWhere("snmpAccessControl", where)) then
    		local snmp_rowid =  db.existsRowWhere("snmpAccessControl", where)   	           	
    		if(snmp_rowid ~= rowid) then
    			return "ERROR", "SNMP_ACCESS_CONTROL_CONFIG_FAILED"
    		end
    	end
    end        
	valid= snmp.config(inputTable, rowid, operation, "snmpAccessControl")
      
	--return
	if (valid) then
	   
	    return "OK", "STATUS_OK"
	else
	    
	    return "ERROR", "SNMP_ACCESS_CONTROL_CONFIG_FAILED"
	end
end

--snmpv3 configuration
function snmp.snmpv3Users_config(inputTable, rowid, operation)
	--if not allowed to edit
	if(ACCESS_LEVEL ~=0)then
	   return "ACCESS_DENIED", "ADMIN_REQD"
	end
	
	local valid = false
	--config snmpv3Users
	valid = snmp.config(inputTable, rowid, operation, "snmpv3Users")
      
	--return
	if(valid) then
	   
	   return "OK", "STATUS_OK"
	else
	   
	   return "ERROR", "SNMPV3_USERS_CONFIG_FAILED"
	end
end

function snmp.import (configTable, defaultConfigTable)

    if (configTable == nil) then
        configTable = defaultConfigTable
    else
        if (configTable.trap ~= nil and configTable.accessControl == nil) then
            configTable.trap = defaultConfigTable.trap
	    configTable.accessControl =  defaultConfigTable.accessControl	
        end
        
        if (configTable.v3Users == nil) then
            configTable.v3Users = defaultConfigTable.v3Users
        end
    end

	for i,v in ipairs (configTable.trap) do	
        v = util.addPrefix (v, "snmpTrap.");
        snmp.snmpTrap_config (v, -1, "add");
    end

    for i,v in ipairs (configTable.accessControl) do
        v = util.addPrefix (v,"snmpAccessControl.")
        snmp.snmpAccessControl_config (v, -1, "add")
    end

    for i,v in ipairs (configTable.v3Users) do
        v = util.addPrefix (v, "snmpv3Users.")
        snmp.snmpv3Users_config (v,-1,"add")
    end
end

function snmp.export ()
    local snmpConfig = {}
    snmpConfig["trap"] =  db.getTable ("snmpTrap", false)
    snmpConfig["accessControl"] = db.getTable ("snmpAccessControl",false)
    snmpConfig["v3Users"] = db.getTable ("snmpv3Users",false)

    return snmpConfig
end

if (config.register) then
   config.register("snmp", snmp.import, snmp.export)
end
