-- nimfCLI.lua
-- Mohammad Rafi
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 22Mar10,rac Modified nimfCfgInputValWan2 and nimfCfgInputVal to support multiple ppope profiles enable/disable
-- 04Mar10,db  Added Wan Port Setup related routines 
-- 24Feb10,rac Modified to support PPppoeProfiles 
-- 11Feb10,db  Modified to support two Wan's
-- 20Feb09,ss  fixed spr#10840.
-- 31Jan09,ss  added nimfCfgInputVal routine.
-- 23Jan09,ss  modified ipv4 wan set and get routines.
-- 24Sep08,rfi written
--
-- Description
-- CLISH nimf LUA routines

require "teamf1lualib/ifStatic"
require "teamf1lualib/dhcpc"
require "teamf1lualib/pppoe"
require "teamf1lualib/pptp"
require "teamf1lualib/l2tp"
require "teamf1lualib/nimf"
require "teamf1lualib/wanPort"
require "teamf1lualib/nimfView"
require "teamf1lualib/vlanConfig"



function wanSetupGet()
    local resultTab = {}   
    configRow = nimfView.wanConfigurationGet ("WAN1")
    local ConnectionType = configRow ["Wan.IspType"]
    if (ConnectionType == "1") then
        resTab.insertField (resultTab, "STATIC Configuration","")
        resTab.insertField (resultTab, "Internet (IP) Address Source","Use Static IP Address")
        resTab.insertField (resultTab, "IP Address", configRow["Wan.IpAddr"]or"")
        resTab.insertField (resultTab, "IP Subnet Mask", configRow["Wan.SnetMask"]or"")
        resTab.insertField (resultTab, "Gateway IP Address", configRow["Wan.GwIpAddr"]or"")
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
    end
       
    if (ConnectionType == "0") then
        resTab.insertField (resultTab, "Dynamic IP (DHCP) Configuration","")
        resTab.insertField (resultTab, "Internet (IP) Address","Get Dynamically From ISP")
        if(configRow["Wan.IsDNSDyn"] == "0") then
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
        else
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end
        if(configRow["Wan.MacAddr"] == "0") then
        resTab.insertField (resultTab, "MAC Address Source","Use Default Address")
        elseif (configRow["Wan.MacAddr"] == "1") then
        resTab.insertField (resultTab, "MAC Address Source","Clone your PC's MAC Address")
        elseif (configRow["Wan.MacAddr"] == "2") then
        resTab.insertField (resultTab, "MAC Address Source","Use this MAC Address")
        resTab.insertField (resultTab, "MAC Address", configRow["Wan.MacAddr"]or"")
        end
        resTab.insertField (resultTab, "HostName",configRow["Wan.HostName"]or"")

    end

    if (ConnectionType == "2") then
        resTab.insertField (resultTab, "Pppoe Configuration","")
        local i=0
        local table = db.getRows ("PppoeProfile","LogicalIfName","WAN1")
        if (table ~= nil and table ~= {}) then
        for k,v in pairs(table) do
        i = i + 1
        local row = table[i]
        resTab.insertField (resultTab, "Profile"..row["PppoeProfile._ROWID_"], row["PppoeProfile.ProfileName"]or"")
		if(row["PppoeProfile.Status"] == "1") then
            resTab.insertField (resultTab, "Profile" ..row["PppoeProfile._ROWID_"].." Status", "Enabled")
        else
            resTab.insertField (resultTab, "Profile" ..row["PppoeProfile._ROWID_"].." Status", "Disabled")
		end
	end
    end
    end

    if (ConnectionType == "3") then
        resTab.insertField (resultTab, "Pptp Configuration","")
        resTab.insertField (resultTab, "Username", configRow["Wan.LoginName"]or"")
        resTab.insertField (resultTab, "Password", util.mask(configRow["Wan.LoginPassword"])or"")
        resTab.insertField (resultTab, "My IP Address", configRow["Wan.MyIpAddr"]or"")
        resTab.insertField (resultTab, "Server IP Address", configRow["Wan.SvrIpAddr"]or"")
        resTab.insertField (resultTab, "MMPE EncryptionAddress", configRow["Wan.MppeEncryptSupport"]or"")
        resTab.insertField (resultTab, "Split Tunnel", configRow["Wan.SplitTunnel"]or"")
        if (configRow["Wan.IdleTimeOutFlag"] == "0") then
          resTab.insertField (resultTab, "Connectivity Type", "Keep Connected")
        elseif (configRow["Wan.IdleTimeOutFlag"] == "1") then
          resTab.insertField (resultTab, "Connectivity Type", "Idle Time")
          resTab.insertField (resultTab, "Idle Time (in minutes)", configRow["Wan.IdleTime"])
        end
        if(configRow["Wan.IsDNSDyn"] == "0") then
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
        else
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end

    end
    
   if (ConnectionType == "4") then
        resTab.insertField (resultTab, "L2tp Configuration","")
        resTab.insertField (resultTab, "Username", configRow["Wan.LoginName"]or"")
        resTab.insertField (resultTab, "Password", util.mask(configRow["Wan.LoginPassword"])or"")
        resTab.insertField (resultTab, "My IP Address", configRow["Wan.MyIpAddr"]or"")
        resTab.insertField (resultTab, "Server IP Address", configRow["Wan.SvrIpAddr"]or"")
        resTab.insertField (resultTab, "Split Tunnel", configRow["Wan.SplitTunnel"]or"")
        if (configRow["Wan.IdleTimeOutFlag"] == "0") then
          resTab.insertField (resultTab, "Connectivity Type", "Keep Connected")
        elseif (configRow["Wan.IdleTimeOutFlag"] == "1") then
          resTab.insertField (resultTab, "Connectivity Type", "Idle Time")
          resTab.insertField (resultTab, "Idle Time (in minutes)", configRow["Wan.IdleTime"])
        end
        if(configRow["Wan.IsDNSDyn"] == "0") then
        resTab.insertField (resultTab, "Domain_Name_Servers(DNS)Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
        else
        resTab.insertField (resultTab, "Domain_Name_Servers(DNS)Source","Get Dynamically From ISP")
        end

    end
    printLabel ("WAN1 Setup")
    resTab.print (resultTab, 0)
end

--
-- get the field values from the dbase table
function wanStatusGet()
    --[[
    local resultTab = {}   
    local ConnectionType = db.getAttribute ("NimfConf", "AddressFamily", 2, "ConnectionType")

    if (ConnectionType == "ifStatic") then
        ConnectionType = "STATIC"
    elseif (ConnectionType == "pppoe") then
        ConnectionType = "PPPOE"
    elseif (ConnectionType == "dhcpc") then
        ConnectionType = "Dynamic IP (DHCP)"
    elseif (ConnectionType == "pptp") then
        ConnectionType = "PPTP"
    elseif (ConnectionType == "l2tp") then
        ConnectionType = "L2TP"
    end

    statRow = db.getRowWhere ("NimfStatus", "LogicalIfName = 'WAN1' and AddressFamily=2")
    resTab.insertField (resultTab, "Connection Time", statRow["NimfStatus.WanUpTime"]or"")
    resTab.insertField (resultTab, "Connection Type", ConnectionType)
    resTab.insertField (resultTab, "Connection State", statRow["NimfStatus.Nimfstatus"]or"")

    if (ConnectionType == "Dynamic IP (DHCP)") then
        statRow = db.getRowWhere ("DhcpStatus", "LogicalIfName='WAN1'")
        resTab.insertField (resultTab, "DHCP Server", statRow["DhcpStatus.DhcpServerIp"]or"")
        resTab.insertField (resultTab, "Lease Obtained", statRow["DhcpStatus.LeaseObtained"]or"")
        resTab.insertField (resultTab, "Lease Duration", statRow["DhcpStatus.LeaseTime"])
    end

    statRow = db.getRowWhere ("ipAddressTable", "LogicalIfName='WAN1' and addressFamily=2")
    resTab.insertField (resultTab, "IP Address", statRow["ipAddressTable.ipAddress"]or"")
    resTab.insertField (resultTab, "Subnet Mask", statRow["ipAddressTable.subnetMask"]or"")
    statRow = db.getRowWhere ("defaultRouters", "LogicalIfName='WAN1' and addressFamily=2")
    resTab.insertField (resultTab, "Gateway", statRow["defaultRouters.nextHopGateway"]or"")
    statRow = db.getRowWhere ("resolverConfig", "LogicalIfName='WAN1' and addressFamily=2")
    resTab.insertField (resultTab, "Primary DNS Server", statRow["resolverConfig.nameserver1"]or"")
    resTab.insertField (resultTab, "Secondary DNS Server", statRow["resolverConfig.nameserver2"]or"")
]]--
     local resultTab = {}  
    -- run program to NIMF Status and update DB
	local prog = db.getAttribute("environment", "name", "NIMFSTATUS_PROGRAM", "value")
	if (prog ~= nil) then
		util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN1 2"))
        util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN2 2"))
    end
    prog = db.getAttribute("environment", "name", "LINKSTATUS_PROGRAM", "value")
	if (prog ~= nil) then
		util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN1"))
        util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN2"))
        util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " DMZ"))
	end
	
	-- If IP Mode is IPv4/IPv6 then we need to call this binary.
	local ipMode = db.getAttribute ("networkInfo", "_ROWID_", "1", "netWorkMode") or '0'
	if (ipMode == "3") then
	    prog = db.getAttribute("environment", "name", "IPV6_GW_UPDATE", "value")
		if (prog ~= nil) then
			util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME))
		end
	end

    logIfName = "WAN1"
						addressFamily = "2"
           				configRow = nimfView.wanStatusGetWrap (logIfName,addressFamily)
						local wanOp = configRow["Wan.operation"] or ''
					    local where = "LogicalIfName = 'WAN1' and addressFamily = 2"						
					    local wanv4Config = db.getRowWhere ("NimfConf", where)					    
						local wanRows = db.getRowsWhere ("ipAddressTable", where)						
					    local nsRows = db.getRows("resolverConfig", "LogicalIfName", "WAN1")
					    local gwRows = db.getRows("defaultRouters", "LogicalIfName", "WAN1")
					    local wanIntName = db.getAttribute ("networkInterface", "LogicalIfName", "WAN1", "interfaceName")
					    local wanState = db.getAttribute ("networkInterface", "LogicalIfName", "WAN1", "IfStatus") or ''
					    local wanMacAddr = ""
					    local natEnabled = ""    
					    local connetionType4 = ""					    
					    local connetionStatus4 = ""				           
			            local linkStatus4 = ""
					
						-- Getting MAC Address of the WAN Interface
						if (wanIntName ~= nil) then	
							wanMacAddr = db.getAttribute ("ethernet", "interfaceName", wanIntName, "macAddress") or ''
						end
					
						-- Getting Connection Type of the WAN(ipv4) Interface
					    if (wanv4Config["NimfConf.ConnectionType"] ~= nil) then
					        if (wanv4Config["NimfConf.ConnectionType"] == "dhcpc") then
					            connetionType4 = "Dynamic IP (DHCP)"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "ifStatic") then
					            connetionType4 = "STATIC"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "pppoe") then
					            connetionType4 = "PPPOE"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "pptp") then
					            connetionType4 = "PPTP"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "l2tp") then
					            connetionType4 = "L2TP"
					        end
					    end						                                  
					
						-- Getting Connection State of the WAN(ipv4) Interface
					    local nimfStatusConfig = db.getRowWhere("NimfStatus", where)
					    if (nimfStatusConfig ~= nil) then
					    	connetionStatus4 = nimfStatusConfig["NimfStatus.Nimfstatus"] or ""
					    end			
			            local nimfStatusConfig = db.getRowWhere("NimfStatus", where)
			            if (nimfStatusConfig ~= nil) then
					    	linkStatus4 = nimfStatusConfig["NimfStatus.Linkstatus"] or ""
					    end    
					
						-- Getting NAT Mode Status.
					    if (db.getAttribute("NatTable", "_ROWID_", "1", "Enable") == "1") then
					    	natEnabled = "Enabled"
					    else
					    	natEnabled = "Disabled"
					    end
    
    resTab.insertField (resultTab, "WAN1 Status (Ipv4)", "")
    resTab.insertField (resultTab, "MAC Address", wanMacAddr or "")
    local ipAddrStr = ""
					local i = 0
					if(wanRows) then
					    for k,v in pairs(wanRows) do
						    i = i + 1
						    local row = wanRows[i]
						    ipAddrStr = ipAddrStr .. row["ipAddressTable.ipAddress"] .. " / " .. row["ipAddressTable.subnetMask"]
					        if(i ~= #wanRows) then
					        	ipAddrStr = ipAddrStr .. ", "
					        end
					    end
					end
    
    resTab.insertField (resultTab, "IPv4 Address", ipAddrStr or "")
    if (wanState == "1") then
							wanState = "UP"
						elseif (wanState == "2") then
							wanState = "UP(IPv6)"
						elseif (wanState == "3") then
							wanState = "UP(IPv4 and IPv6)"
						elseif (wanState == "0") then
							wanState = "DOWN"
						end
    resTab.insertField (resultTab, "Wan State", wanState or "")

    resTab.insertField (resultTab, "NAT (IPv4 only)", natEnabled or "")
    resTab.insertField (resultTab, "IPv4 Connection Type", connetionType4 or "")
    resTab.insertField (resultTab, "IPv4 Connection State", connetionStatus4 or "")
    resTab.insertField (resultTab, "Link State", linkStatus4 or "")

    local wanMode = ""
					local wmodeConfig = db.getRow("WanMode", "_ROWID_", "1")
					if (wmodeConfig ~= nil) then
						local wan = ""
						if (wmodeConfig["WanMode.Wanmode"] == "2") then
					    	wan = wmodeConfig["WanMode.FailoverPriLogicalIfName"]
					    else
					    	wan = wmodeConfig["WanMode.DedicatedLogicalIfName"]
					    end
					                                	
						if (wan ~= nil) then
							if (wan == "WAN1") then
								wan = ": Dedicated WAN"
							elseif (wan == "WAN2") then
								wan = ": Secondary WAN"
							end
						else
							wan = ""
						end
						
						if (wmodeConfig["WanMode.Wanmode"] == "2") then
							wanMode = "Auto-Rollover using WAN port" .. wan
						elseif (wmodeConfig["WanMode.Wanmode"] == "1") then
							wanMode = "Load Balancing - Round Robin"
						elseif (wmodeConfig["WanMode.Wanmode"] == "3") then
							wanMode = "Load Balancing - SpillOver"
						elseif (wmodeConfig["WanMode.Wanmode"] == "0") then
							wanMode = "Use only single WAN port" .. wan
						end
					end
    
    resTab.insertField (resultTab, "WAN Mode", wanMode or "")
    local gwIps = ""
						if(gwRows) then
							local i = 0
					        for k,v in pairs(gwRows) do
								i = i + 1        
					              local row = gwRows[i]
					              if (row["defaultRouters.nextHopGateway"] ~= nil and row["defaultRouters.nextHopGateway"] ~= "") then
					              	if (gwIps == "") then
					              		gwIps = gwIps .. row["defaultRouters.nextHopGateway"]
					              	else
					              		gwIps = gwIps
					              	end
					              end               
					         end
						end
    resTab.insertField (resultTab, "Gateway", gwIps or "")

    local priDNSIps = ""
						if(nsRows) then
							local i = 0
					        for k,v in pairs(nsRows) do
								i = i + 1        
					              local row = nsRows[i]
					              if (row["resolverConfig.nameserver1"] ~= nil and row["resolverConfig.nameserver1"] ~= "") then
					              	if (priDNSIps == "") then
					              		priDNSIps = priDNSIps .. row["resolverConfig.nameserver1"]
					              	else
					              		priDNSIps = priDNSIps
					              	end
					              end              
					         end
						end
    resTab.insertField (resultTab, "Primary DNS", priDNSIps or "")
    local secDNSIps = ""
						if(nsRows) then
							local i = 0
					        for k,v in pairs(nsRows) do
								i = i + 1        
					              local row = nsRows[i]
					              if (row["resolverConfig.nameserver2"] ~= nil and row["resolverConfig.nameserver2"] ~= "") then
					              	if (secDNSIps == "") then
					              		secDNSIps = secDNSIps .. row["resolverConfig.nameserver2"]
					              	else
					              		secDNSIps = secDNSIps
					              	end
					              end              
					         end
						end
    resTab.insertField (resultTab, "Secondary DNS", secDNSIps or "")


    printLabel ("WAN1 Status")
    resTab.print (resultTab, 0)
end

--
-- This routine save WAN configuration
function nimfCfgSave (configRow)
    	local errorFlag = "OK"
   		configRow["NimfConf.LogicalIfName"] = "WAN1"
   		errorFlag, statusCode = nimfView.wanConfigSet(configRow, "1", "edit")
		-- save db if no error
		if (errorFlag == "OK") then db.save() end
        return errorFlag
end

-- This routine takes in one argument that is the value of the
-- primary key for the object table.
function nimfCfgInit (args)
    local configRow = {}
    configRow = nimfView.wanConfigurationGet ("WAN1")
    
    configRow ["Wan.Secret"] = ''
    configRow ["Wan.SecDnsIpAddr"] = ''
    configRow ["Wan.MyIpAddr"] = ''
    configRow ["Wan.HostName"] = ''
    configRow ["PppoeProfile.profile2"]="0"
    configRow ["PppoeProfile.profile1"]="0"
    --[[ print (configRow ["NimfConf._ROWID_"], configRow["NimfConf.AddressFamily"], 
           configRow["NimfConf.ConnectionType"]) ]]--
    return 1, configRow
end

-- this routine validates the nimf input configuration
function nimfCfgInputVal (configRow)
	local i = 0
	local rowid1=0
	local rowid2=0
	local index1=""
	local index2=""

    if (configRow ["Wan.IspType"] == "1") then
        configRow["Wan.MppeEncryptSupport"]="0"
   		configRow["Wan.SplitTunnel"]="0"
        if ((configRow["Wan.IpAddr"] == "" or configRow["Wan.IpAddr"] == nil) or (configRow["Wan.IpAddr"] ~=nil and configRow["Wan.IpAddr"] == "0.0.0.0")) then
            printCLIError("Invalid static Address\n")
            return false
        end
        if ((configRow["Wan.SnetMask"] == "" or configRow["Wan.SnetMask"] == nil) or (configRow["Wan.SnetMask"] ~=nil and configRow["Wan.SnetMask"] == "0.0.0.0")) then
            printCLIError("Enter valid subnet mask\n")
            return false
        end
        if ((configRow["Wan.GwIpAddr"] == "" or configRow["Wan.GwIpAddr"] == nil) or (configRow["Wan.GwIpAddr"] ~=nil and configRow["Wan.GwIpAddr"] == "0.0.0.0")) then
            printCLIError("Enter valid gateway Address\n")
            return false
        end
        if ((configRow["Wan.PriDnsIpAddr"] == "" or configRow["Wan.PriDnsIpAddr"] == nil) or (configRow["Wan.PriDnsIpAddr"] ~=nil and configRow["Wan.PriDnsIpAddr"] == "0.0.0.0")) then
            printCLIError("Enter valid primary dns address\n")
            return false
        end
        if (configRow["Wan.SecDnsIpAddr"] ~=nil and configRow["Wan.SecDnsIpAddr"] == "0.0.0.0") then
            printCLIError("Enter valid secondary dns address\n")
            return false
        end
    end
       
    if (configRow ["Wan.IspType"] == "0") then
        configRow["Wan.MppeEncryptSupport"]="0"
   		configRow["Wan.SplitTunnel"]="0"
        if(configRow["Wan.IsDNSDyn"] == "0") then
            if ((configRow["Wan.PriDnsIpAddr"] == "" or configRow["Wan.PriDnsIpAddr"] == nil) or (configRow["Wan.PriDnsIpAddr"] ~=nil and configRow["Wan.PriDnsIpAddr"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                return false
            end
            if (configRow["Wan.SecDnsIpAddr"] ~=nil and configRow["Wan.SecDnsIpAddr"] == "0.0.0.0") then
                printCLIError("Enter valid secondary dns address\n")
                return false
            end
        end

    if(configRow["Wan.UseMac"] == "2")then
        if (configRow["Wan.MacAddr"] == "" or configRow["Wan.MacAddr"] == nil) then
            printCLIError ("Enter valid mac address\n")
            return false
        end
    end

    end

    if (configRow ["Wan.IspType"] == "2") then
    local table=db.getRows("PppoeProfile","LogicalIfName","WAN1")
	if(#table == 0) then
		printCLIError("No Pppoe profiles created")
		return false
	end
	for k,v in pairs(table) do
		i=i+1
		local row=table[i]
		if (i==1)then
			rowid1=row["PppoeProfile._ROWID_"]
		end
		if (i==2)then
			rowid2=row["PppoeProfile._ROWID_"]
		end		

	end
	if (i == 2 and configRow ["PppoeProfile.profile1"] == "0" and configRow ["PppoeProfile.profile2"] == "0") then
		printCLIError("No profiles are selected")
		return false
	end
	if (i == 2 and configRow ["PppoeProfile.profile1"] == "0" and configRow ["PppoeProfile.profile2"] == "1") then
		printCLIError("Only second Profile cannot be enbled, make sure the first profile also is enabled")
		return false
	end
	if (i == 1 and configRow ["PppoeProfile.profile1"] == "0") then
	        printCLIError("Profile is not enabled") 
		return false
	end
	if (i == 1) then
		index1="Wan.PppoeProfileName_"..rowid1
		configRow[index1]="1"
	elseif(i == 2)then
		index1="Wan.PppoeProfileName_"..rowid1
		index2="Wan.PppoeProfileName_"..rowid2
		configRow[index1]="1"
		configRow[index2]=configRow ["PppoeProfile.profile2"]
	end
	configRow["Wan.MppeEncryptSupport"]="0"
   		configRow["Wan.SplitTunnel"]="0"
        if (configRow ["NimfConf.RequireLogin"] == "0") then
            printCLIError("Enable Require Login field\n")
            return false
        elseif (configRow ["NimfConf.RequireLogin"] == "1") then
            if ((configRow["Pppoe.UserName"] == nil or configRow["Pppoe.UserName"] == "") or (configRow["Pppoe.Password"] == nil or configRow["Pppoe.Password"] == "")) then
                    printCLIError("Invalid username/password\n")
                    return false
            end
            if (configRow["Pppoe.IdleTimeOutFlag"] == "1") then
                if (configRow["Pppoe.IdleTimeOutValue"] == nil or configRow["Pppoe.IdleTimeOutValue"] == "") then
                    printCLIError("Enter valid idle timeout value\n")
                    return false
                end
            end
        end
    end

    if (configRow ["Wan.IspType"] == "3") then
        if ((configRow["Wan.LoginName"] == nil or configRow["Wan.LoginName"] == "") or (configRow["Wan.LoginPassword"] == nil or configRow["Wan.LoginPassword"] == "")) then
                    printCLIError("Invalid username/password\n")
                    return false
            end
            if (configRow["Wan.IdleTimeOutFlag"] == "1") then
                if (configRow["Wan.IdleTime"] == nil or configRow["Wan.IdleTime"] == "") then
                    printCLIError("Enter valid idle timeout value\n")
                    return false
                end
            end
            if (configRow["Wan.MyIpAddr"] ~= nil and configRow["Wan.MyIpAddr"] == "0.0.0.0") then
                    printCLIError("myIpAddress: Enter valid IP address assigned by the ISP to make a connection with the ISP server\n")
                    return false
            end
            if ((configRow["Wan.SvrIpAddr"] == "" or configRow["Wan.SvrIpAddr"] == nil)  or (configRow["Wan.SvrIpAddr"] == "0.0.0.0" and configRow["Wan.SvrIpAddr"] ~= nil))then
                    printCLIError("Enter valid IP address of the L2TP server\n")
                    return false
            end
    end

     if (configRow ["Wan.IspType"] == "4") then
   		configRow["Wan.MppeEncryptSupport"]="0"
        if ((configRow["Wan.LoginName"] == nil or configRow["Wan.LoginName"] == "") or (configRow["Wan.LoginPassword"] == nil or configRow["Wan.LoginPassword"] == "")) then
                    printCLIError("Invalid username/password\n")
                    return false
            end
            if (configRow["Wan.IdleTimeOutFlag"] == "1") then
                if (configRow["Wan.IdleTime"] == nil or configRow["Wan.IdleTime"] == "") then
                    printCLIError("Enter valid idle timeout value\n")
                    return false
                end
            end
            if (configRow["Wan.MyIpAddr"] ~= nil and configRow["Wan.MyIpAddr"] == "0.0.0.0") then
                    printCLIError("myIpAddress: Enter valid IP address assigned by the ISP to make a connection with the ISP server\n")
                    return false
            end
            if ((configRow["Wan.SvrIpAddr"] == "" or configRow["Wan.SvrIpAddr"] == nil)  or (configRow["Wan.SvrIpAddr"] == "0.0.0.0" and configRow["Wan.SvrIpAddr"] ~= nil))then
                    printCLIError("Enter valid IP address of the L2TP server\n")
                    return false
            end
    end
end

function wanSetupGetWan2()
    local resultTab = {}   
    configRow = nimfView.wanConfigurationGet ("WAN2")
    local ConnectionType = configRow ["Wan.IspType"]
    if (ConnectionType == "1") then
        resTab.insertField (resultTab, "STATIC Configuration","")
        resTab.insertField (resultTab, "Internet (IP) Address Source","Use Static IP Address")
        resTab.insertField (resultTab, "IP Address", configRow["Wan.IpAddr"]or"")
        resTab.insertField (resultTab, "IP Subnet Mask", configRow["Wan.SnetMask"]or"")
        resTab.insertField (resultTab, "Gateway IP Address", configRow["Wan.GwIpAddr"]or"")
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
    end
       
    if (ConnectionType == "0") then
        resTab.insertField (resultTab, "Dynamic IP (DHCP) Configuration","")
        resTab.insertField (resultTab, "Internet (IP) Address","Get Dynamically From ISP")
        if(configRow["Wan.IsDNSDyn"] == "0") then
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
        else
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end
        if(configRow["Wan.MacAddr"] == "0") then
        resTab.insertField (resultTab, "MAC Address Source","Use Default Address")
        elseif (configRow["Wan.MacAddr"] == "1") then
        resTab.insertField (resultTab, "MAC Address Source","Clone your PC's MAC Address")
        elseif (configRow["Wan.MacAddr"] == "2") then
        resTab.insertField (resultTab, "MAC Address Source","Use this MAC Address")
        resTab.insertField (resultTab, "MAC Address", configRow["Wan.MacAddr"]or"")
        end
        resTab.insertField (resultTab, "HostName",configRow["Wan.HostName"]or"")

    end

    if (ConnectionType == "2") then
        resTab.insertField (resultTab, "Pppoe Configuration","")
        local i=0
        local table = db.getRows ("PppoeProfile","LogicalIfName","WAN2")
        if (table ~= nil and table ~= {}) then
            for k,v in pairs(table) do
                i = i + 1
                local row = table[i]
                resTab.insertField (resultTab, "Profile"..row["PppoeProfile._ROWID_"], row["PppoeProfile.ProfileName"]or"")
		    if(row["PppoeProfile.Status"] == "1") then
            resTab.insertField (resultTab, "Profile" ..row["PppoeProfile._ROWID_"].." Status", "Enabled")
            else
            resTab.insertField (resultTab, "Profile" ..row["PppoeProfile._ROWID_"].." Status", "Enabled")
		    end
    	    end
        end
    end

    if (ConnectionType == "3") then
        resTab.insertField (resultTab, "Pptp Configuration","")
        resTab.insertField (resultTab, "Username", configRow["Wan.LoginName"]or"")
        resTab.insertField (resultTab, "Password", util.mask(configRow["Wan.LoginPassword"])or"")
        resTab.insertField (resultTab, "My IP Address", configRow["Wan.MyIpAddr"]or"")
        resTab.insertField (resultTab, "Server IP Address", configRow["Wan.SvrIpAddr"]or"")
        resTab.insertField (resultTab, "MMPE EncryptionAddress", configRow["Wan.MppeEncryptSupport"]or"")
        resTab.insertField (resultTab, "Split Tunnel", configRow["Wan.SplitTunnel"]or"")
        if (configRow["Wan.IdleTimeOutFlag"] == "0") then
          resTab.insertField (resultTab, "Connectivity Type", "Keep Connected")
        elseif (configRow["Wan.IdleTimeOutFlag"] == "1") then
          resTab.insertField (resultTab, "Connectivity Type", "Idle Time")
          resTab.insertField (resultTab, "Idle Time (in minutes)", configRow["Wan.IdleTime"])
        end
        if(configRow["Wan.IsDNSDyn"] == "0") then
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
        else
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end

    end
    
   if (ConnectionType == "4") then
        resTab.insertField (resultTab, "L2tp Configuration","")
        resTab.insertField (resultTab, "Username", configRow["Wan.LoginName"]or"")
        resTab.insertField (resultTab, "Password", util.mask(configRow["Wan.LoginPassword"])or"")
        resTab.insertField (resultTab, "My IP Address", configRow["Wan.MyIpAddr"]or"")
        resTab.insertField (resultTab, "Server IP Address", configRow["Wan.SvrIpAddr"]or"")
        resTab.insertField (resultTab, "Split Tunnel", configRow["Wan.SplitTunnel"]or"")
        if (configRow["Wan.IdleTimeOutFlag"] == "0") then
          resTab.insertField (resultTab, "Connectivity Type", "Keep Connected")
        elseif (configRow["Wan.IdleTimeOutFlag"] == "1") then
          resTab.insertField (resultTab, "Connectivity Type", "Idle Time")
          resTab.insertField (resultTab, "Idle Time (in minutes)", configRow["Wan.IdleTime"])
        end
        if(configRow["Wan.IsDNSDyn"] == "0") then
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
        else
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end

    end
    if (ConnectionType == "5") then
        resTab.insertField (resultTab, "ThreeG Configuration","")
        resTab.insertField (resultTab, "Username", configRow["Wan.UserName"]or"")
        resTab.insertField (resultTab, "Password", util.mask(configRow["Wan.Password"])or"")
        resTab.insertField (resultTab, "Dial Number", configRow["Wan.DialNumber"]or"")
        if (configRow["Wan.AuthMethod"] == "0") then
         resTab.insertField (resultTab, "AuthMethod", "NONE")
        elseif (configRow["Wan.AuthMethod"] == "1") then
         resTab.insertField (resultTab, "AuthMethod", "PAP")
        elseif (configRow["Wan.AuthMethod"] == "2") then
         resTab.insertField (resultTab, "AuthMethod", "CHAP")
        end
       resTab.insertField (resultTab, "APN", configRow["Wan.APN"]or"")
        if (configRow["Wan.IdleTimeOutFlag"] == "0") then
          resTab.insertField (resultTab, "Connectivity Type", "Keep Connected")
        elseif (configRow["Wan.IdleTimeOutFlag"] == "1") then
          resTab.insertField (resultTab, "Connectivity Type", "Idle Time")
          resTab.insertField (resultTab, "Idle Time (in minutes)", configRow["Wan.IdleTime"])
        end
        if(configRow["Wan.IsDNSDyn"] == "0") then
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Use these DNS Servers")
        resTab.insertField (resultTab, "Primary DNS Server", configRow["Wan.PriDnsIpAddr"]or"")
        resTab.insertField (resultTab, "Secondary DNS Server", configRow["Wan.SecDnsIpAddr"]or"")
        else
        resTab.insertField (resultTab, "Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end

    end

    printLabel ("WAN2 Setup")
    resTab.print (resultTab, 0)
end

--
-- get the field values from the dbase table
function wanStatusGetWan2()
    --[[
    local resultTab = {}   
    local ConnectionType = db.getAttribute ("NimfConf", "AddressFamily", 2, "ConnectionType")

    if (ConnectionType == "ifStatic") then
        ConnectionType = "STATIC"
    elseif (ConnectionType == "pppoe") then
        ConnectionType = "PPPOE"
    elseif (ConnectionType == "dhcpc") then
        ConnectionType = "Dynamic IP (DHCP)"
    elseif (ConnectionType == "pptp") then
        ConnectionType = "PPTP"
    elseif (ConnectionType == "l2tp") then
        ConnectionType = "L2TP"
    end

    statRow = db.getRowWhere ("NimfStatus", "LogicalIfName = 'WAN2' and AddressFamily=2")
    resTab.insertField (resultTab, "Connection Time", statRow["NimfStatus.WanUpTime"]or"")
    resTab.insertField (resultTab, "Connection Type", ConnectionType)
    resTab.insertField (resultTab, "Connection State", statRow["NimfStatus.Nimfstatus"]or"")

    if (ConnectionType == "Dynamic IP (DHCP)") then
        statRow = db.getRowWhere ("DhcpStatus", "LogicalIfName='WAN2'")
        resTab.insertField (resultTab, "DHCP Server", statRow["DhcpStatus.DhcpServerIp"]or"")
        resTab.insertField (resultTab, "Lease Obtained", statRow["DhcpStatus.LeaseObtained"]or"")
        resTab.insertField (resultTab, "Lease Duration", statRow["DhcpStatus.LeaseTime"])
    end

    statRow = db.getRowWhere ("ipAddressTable", "LogicalIfName='WAN2' and addressFamily=2")
    resTab.insertField (resultTab, "IP Address", statRow["ipAddressTable.ipAddress"]or"")
    resTab.insertField (resultTab, "Subnet Mask", statRow["ipAddressTable.subnetMask"]or"")
    statRow = db.getRowWhere ("defaultRouters", "LogicalIfName='WAN2' and addressFamily=2")
    resTab.insertField (resultTab, "Gateway", statRow["defaultRouters.nextHopGateway"]or"")
    statRow = db.getRowWhere ("resolverConfig", "LogicalIfName='WAN2' and addressFamily=2")
    resTab.insertField (resultTab, "Primary DNS Server", statRow["resolverConfig.nameserver1"]or"")
    resTab.insertField (resultTab, "Secondary DNS Server", statRow["resolverConfig.nameserver2"]or"")
]]--
     local resultTab = {}  
    -- run program to NIMF Status and update DB
	local prog = db.getAttribute("environment", "name", "NIMFSTATUS_PROGRAM", "value")
	if (prog ~= nil) then
		util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN2 2"))
        util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN2 2"))
    end
    prog = db.getAttribute("environment", "name", "LINKSTATUS_PROGRAM", "value")
	if (prog ~= nil) then
		util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN2"))
        util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " WAN2"))
        util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME .. " DMZ"))
	end
	
	-- If IP Mode is IPv4/IPv6 then we need to call this binary.
	local ipMode = db.getAttribute ("networkInfo", "_ROWID_", "1", "netWorkMode") or '0'
	if (ipMode == "3") then
	    prog = db.getAttribute("environment", "name", "IPV6_GW_UPDATE", "value")
		if (prog ~= nil) then
			util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. DB_FILE_NAME))
		end
	end

    logIfName = "WAN2"
						addressFamily = "2"
           				configRow = nimfView.wanStatusGetWrap (logIfName,addressFamily)
						local wanOp = configRow["Wan.operation"] or ''
					    local where = "LogicalIfName = 'WAN2' and addressFamily = 2"						
					    local wanv4Config = db.getRowWhere ("NimfConf", where)					    
						local wanRows = db.getRowsWhere ("ipAddressTable", where)						
					    local nsRows = db.getRows("resolverConfig", "LogicalIfName", "WAN2")
					    local gwRows = db.getRows("defaultRouters", "LogicalIfName", "WAN2")
					    local wanIntName = db.getAttribute ("networkInterface", "LogicalIfName", "WAN2", "interfaceName")
					    local wanState = db.getAttribute ("networkInterface", "LogicalIfName", "WAN2", "IfStatus") or ''
					    local wanMacAddr = ""
					    local natEnabled = ""    
					    local connetionType4 = ""					    
					    local connetionStatus4 = ""				           
			            local linkStatus4 = ""
					
						-- Getting MAC Address of the WAN Interface
						if (wanIntName ~= nil) then	
							wanMacAddr = db.getAttribute ("ethernet", "interfaceName", wanIntName, "macAddress") or ''
						end
					
						-- Getting Connection Type of the WAN(ipv4) Interface
					    if (wanv4Config["NimfConf.ConnectionType"] ~= nil) then
					        if (wanv4Config["NimfConf.ConnectionType"] == "dhcpc") then
					            connetionType4 = "Dynamic IP (DHCP)"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "ifStatic") then
					            connetionType4 = "STATIC"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "pppoe") then
					            connetionType4 = "PPPOE"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "pptp") then
					            connetionType4 = "PPTP"
					        elseif (wanv4Config["NimfConf.ConnectionType"] == "l2tp") then
					            connetionType4 = "L2TP"
					        end
					    end						                                  
					
						-- Getting Connection State of the WAN(ipv4) Interface
					    local nimfStatusConfig = db.getRowWhere("NimfStatus", where)
					    if (nimfStatusConfig ~= nil) then
					    	connetionStatus4 = nimfStatusConfig["NimfStatus.Nimfstatus"] or ""
					    end			
			            local nimfStatusConfig = db.getRowWhere("NimfStatus", where)
			            if (nimfStatusConfig ~= nil) then
					    	linkStatus4 = nimfStatusConfig["NimfStatus.Linkstatus"] or ""
					    end    
					
						-- Getting NAT Mode Status.
					    if (db.getAttribute("NatTable", "_ROWID_", "1", "Enable") == "1") then
					    	natEnabled = "Enabled"
					    else
					    	natEnabled = "Disabled"
					    end
    
    resTab.insertField (resultTab, "WAN2 Status (Ipv4)", "")
    resTab.insertField (resultTab, "MAC Address", wanMacAddr or "")
    local ipAddrStr = ""
					local i = 0
					if(wanRows) then
					    for k,v in pairs(wanRows) do
						    i = i + 1
						    local row = wanRows[i]
						    ipAddrStr = ipAddrStr .. row["ipAddressTable.ipAddress"] .. " / " .. row["ipAddressTable.subnetMask"]
					        if(i ~= #wanRows) then
					        	ipAddrStr = ipAddrStr .. ", "
					        end
					    end
					end
    
    resTab.insertField (resultTab, "IPv4 Address", ipAddrStr or "")
    if (wanState == "1") then
							wanState = "UP"
						elseif (wanState == "2") then
							wanState = "UP(IPv6)"
						elseif (wanState == "3") then
							wanState = "UP(IPv4 and IPv6)"
						elseif (wanState == "0") then
							wanState = "DOWN"
						end
    resTab.insertField (resultTab, "Wan State", wanState or "")

    resTab.insertField (resultTab, "NAT (IPv4 only)", natEnabled or "")
    resTab.insertField (resultTab, "IPv4 Connection Type", connetionType4 or "")
    resTab.insertField (resultTab, "IPv4 Connection State", connetionStatus4 or "")
    resTab.insertField (resultTab, "Link State", linkStatus4 or "")

    local wanMode = ""
					local wmodeConfig = db.getRow("WanMode", "_ROWID_", "1")
					if (wmodeConfig ~= nil) then
						local wan = ""
						if (wmodeConfig["WanMode.Wanmode"] == "2") then
					    	wan = wmodeConfig["WanMode.FailoverPriLogicalIfName"]
					    else
					    	wan = wmodeConfig["WanMode.DedicatedLogicalIfName"]
					    end
					                                	
						if (wan ~= nil) then
							if (wan == "WAN2") then
								wan = ": Dedicated WAN"
							elseif (wan == "WAN2") then
								wan = ": Secondary WAN"
							end
						else
							wan = ""
						end
						
						if (wmodeConfig["WanMode.Wanmode"] == "2") then
							wanMode = "Auto-Rollover using WAN port" .. wan
						elseif (wmodeConfig["WanMode.Wanmode"] == "1") then
							wanMode = "Load Balancing - Round Robin"
						elseif (wmodeConfig["WanMode.Wanmode"] == "3") then
							wanMode = "Load Balancing - SpillOver"
						elseif (wmodeConfig["WanMode.Wanmode"] == "0") then
							wanMode = "Use only single WAN port" .. wan
						end
					end
    
    resTab.insertField (resultTab, "WAN Mode", wanMode or "")
    local gwIps = ""
						if(gwRows) then
							local i = 0
					        for k,v in pairs(gwRows) do
								i = i + 1        
					              local row = gwRows[i]
					              if (row["defaultRouters.nextHopGateway"] ~= nil and row["defaultRouters.nextHopGateway"] ~= "") then
					              	if (gwIps == "") then
					              		gwIps = gwIps .. row["defaultRouters.nextHopGateway"]
					              	else
					              		gwIps = gwIps
					              	end
					              end               
					         end
						end
    resTab.insertField (resultTab, "Gateway", gwIps or "")

    local priDNSIps = ""
						if(nsRows) then
							local i = 0
					        for k,v in pairs(nsRows) do
								i = i + 1        
					              local row = nsRows[i]
					              if (row["resolverConfig.nameserver1"] ~= nil and row["resolverConfig.nameserver1"] ~= "") then
					              	if (priDNSIps == "") then
					              		priDNSIps = priDNSIps .. row["resolverConfig.nameserver1"]
					              	else
					              		priDNSIps = priDNSIps
					              	end
					              end              
					         end
						end
    resTab.insertField (resultTab, "Primary DNS", priDNSIps or "")
    local secDNSIps = ""
						if(nsRows) then
							local i = 0
					        for k,v in pairs(nsRows) do
								i = i + 1        
					              local row = nsRows[i]
					              if (row["resolverConfig.nameserver2"] ~= nil and row["resolverConfig.nameserver2"] ~= "") then
					              	if (secDNSIps == "") then
					              		secDNSIps = secDNSIps .. row["resolverConfig.nameserver2"]
					              	else
					              		secDNSIps = secDNSIps
					              	end
					              end              
					         end
						end
    resTab.insertField (resultTab, "Secondary DNS", secDNSIps or "")


    printLabel ("WAN2 Status")
    resTab.print (resultTab, 0)
end

--
-- This routine save WAN configuration
function nimfCfgSaveWan2 (configRow)
    	local errorFlag = "OK"

   		configRow["NimfConf.LogicalIfName"] = "WAN2"
   		errorFlag, statusCode = nimfView.wanConfigSet(configRow, "1", "edit")
		-- save db if no error
		if (errorFlag == "OK") then db.save() end
        return errorFlag
end

-- This routine takes in one argument that is the value of the
-- primary key for the object table.
function nimfCfgInitWan2 (args)
    local configRow = {}
    configRow = nimfView.wanConfigurationGet ("WAN2")
    
    configRow ["Wan.Secret"] = ''
    configRow ["Wan.SecDnsIpAddr"] = ''
    configRow ["Wan.MyIpAddr"] = ''
    configRow ["Wan.HostName"] = ''
    configRow ["Wan.UserName"] = ''
    configRow ["Wan.Password"] = ''
    configRow ["Wan.APN"] = ''
    configRow ["PppoeProfile.profile2"]="0"
    configRow ["PppoeProfile.profile1"]="0"


    --[[ print (configRow ["NimfConf._ROWID_"], configRow["NimfConf.AddressFamily"], 
           configRow["NimfConf.ConnectionType"]) ]]--
    return 1, configRow
end

-- this routine validates the nimf input configuration
function nimfCfgInputValWan2 (configRow)
	local i = 0
	local rowid1=0
	local rowid2=0
	local index1=""
	local index2=""
    if (configRow ["Wan.IspType"] == "1") then
        configRow["Wan.MppeEncryptSupport"]="0"
   		configRow["Wan.SplitTunnel"]="0"
        if ((configRow["Wan.IpAddr"] == "" or configRow["Wan.IpAddr"] == nil) or (configRow["Wan.IpAddr"] ~=nil and configRow["Wan.IpAddr"] == "0.0.0.0")) then
            printCLIError("Invalid static Address\n")
            return false
        end
        if ((configRow["Wan.SnetMask"] == "" or configRow["Wan.SnetMask"] == nil) or (configRow["Wan.SnetMask"] ~=nil and configRow["Wan.SnetMask"] == "0.0.0.0")) then
            printCLIError("Enter valid subnet mask\n")
            return false
        end
        if ((configRow["Wan.GwIpAddr"] == "" or configRow["Wan.GwIpAddr"] == nil) or (configRow["Wan.GwIpAddr"] ~=nil and configRow["Wan.GwIpAddr"] == "0.0.0.0")) then
            printCLIError("Enter valid gateway Address\n")
            return false
        end
        if ((configRow["Wan.PriDnsIpAddr"] == "" or configRow["Wan.PriDnsIpAddr"] == nil) or (configRow["Wan.PriDnsIpAddr"] ~=nil and configRow["Wan.PriDnsIpAddr"] == "0.0.0.0")) then
            printCLIError("Enter valid primary dns address\n")
            return false
        end
        if (configRow["Wan.SecDnsIpAddr"] ~=nil and configRow["Wan.SecDnsIpAddr"] == "0.0.0.0") then
            printCLIError("Enter valid secondary dns address\n")
            return false
        end
    end
       
    if (configRow ["Wan.IspType"] == "0") then
        configRow["Wan.MppeEncryptSupport"]="0"
   		configRow["Wan.SplitTunnel"]="0"
        if(configRow["Wan.IsDNSDyn"] == "0") then
            if ((configRow["Wan.PriDnsIpAddr"] == "" or configRow["Wan.PriDnsIpAddr"] == nil) or (configRow["Wan.PriDnsIpAddr"] ~=nil and configRow["Wan.PriDnsIpAddr"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                return false
            end
            if (configRow["Wan.SecDnsIpAddr"] ~=nil and configRow["Wan.SecDnsIpAddr"] == "0.0.0.0") then
                printCLIError("Enter valid secondary dns address\n")
                return false
            end
        end

    if(configRow["Wan.UseMac"] == "2")then
        if (configRow["Wan.MacAddr"] == "" or configRow["Wan.MacAddr"] == nil) then
            printCLIError ("Enter valid mac address\n")
            return false
        end
    end

    end

    if (configRow ["Wan.IspType"] == "2") then
    local table=db.getRows("PppoeProfile","LogicalIfName","WAN2")
	if(#table == 0) then
		printCLIError("No Pppoe profiles created")
		return false
	end
	for k,v in pairs(table) do
		i=i+1
		local row=table[i]
		if (i==1)then
			rowid1=row["PppoeProfile._ROWID_"]
		end
		if (i==2)then
			rowid2=row["PppoeProfile._ROWID_"]
			
		end	
	end
	if (i == 2 and configRow ["PppoeProfile.profile1"] == "0" and configRow ["PppoeProfile.profile2"] == "0") then
		printCLIError("No profiles are selected")
		return false
	end
	if (i == 2 and configRow ["PppoeProfile.profile1"] == "0" and configRow ["PppoeProfile.profile2"] == "1") then
		printCLIError("Only second Profile cannot be enbled, make sure the first profile also is enabled")
		return false
	end
	if (i == 1 and configRow ["PppoeProfile.profile1"] == "0") then
	        printCLIError("Profile is not enabled") 
		return false
	end
	if (i == 1) then
		index1="Wan.PppoeProfileName_"..rowid1
		configRow[index1]="1"
	elseif(i == 2)then
		index1="Wan.PppoeProfileName_"..rowid1
		index2="Wan.PppoeProfileName_"..rowid2
		configRow[index1]="1"
		configRow[index2]=configRow ["PppoeProfile.profile2"]
	end

        configRow["Wan.MppeEncryptSupport"]="0"
   		configRow["Wan.SplitTunnel"]="0"
        if (configRow ["NimfConf.RequireLogin"] == "0") then
            printCLIError("Enable Require Login field\n")
            return false
        elseif (configRow ["NimfConf.RequireLogin"] == "1") then
            if ((configRow["Pppoe.UserName"] == nil or configRow["Pppoe.UserName"] == "") or (configRow["Pppoe.Password"] == nil or configRow["Pppoe.Password"] == "")) then
                    printCLIError("Invalid username/password\n")
                    return false
            end
            if (configRow["Pppoe.IdleTimeOutFlag"] == "1") then
                if (configRow["Pppoe.IdleTimeOutValue"] == nil or configRow["Pppoe.IdleTimeOutValue"] == "") then
                    printCLIError("Enter valid idle timeout value\n")
                    return false
                end
            end
        end
        
    end

    if (configRow ["Wan.IspType"] == "3") then
        if ((configRow["Wan.LoginName"] == nil or configRow["Wan.LoginName"] == "") or (configRow["Wan.LoginPassword"] == nil or configRow["Wan.LoginPassword"] == "")) then
                    printCLIError("Invalid username/password\n")
                    return false
            end
            if (configRow["Wan.IdleTimeOutFlag"] == "1") then
                if (configRow["Wan.IdleTime"] == nil or configRow["Wan.IdleTime"] == "") then
                    printCLIError("Enter valid idle timeout value\n")
                    return false
                end
            end
            if (configRow["Wan.MyIpAddr"] ~= nil and configRow["Wan.MyIpAddr"] == "0.0.0.0") then
                    printCLIError("myIpAddress: Enter valid IP address assigned by the ISP to make a connection with the ISP server\n")
                    return false
            end
            if ((configRow["Wan.SvrIpAddr"] == "" or configRow["Wan.SvrIpAddr"] == nil)  or (configRow["Wan.SvrIpAddr"] == "0.0.0.0" and configRow["Wan.SvrIpAddr"] ~= nil))then
                    printCLIError("Enter valid IP address of the L2TP server\n")
                    return false
            end
             if(configRow["Wan.IsDNSDyn"] == "0") then
            if ((configRow["Wan.PriDnsIpAddr"] == "" or configRow["Wan.PriDnsIpAddr"] == nil) or (configRow["Wan.PriDnsIpAddr"] ~=nil and configRow["Wan.PriDnsIpAddr"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                return false
            end
            if (configRow["Wan.SecDnsIpAddr"] ~=nil and configRow["Wan.SecDnsIpAddr"] == "0.0.0.0") then
                printCLIError("Enter valid secondary dns address\n")
                return false
            end
        end

    end

     if (configRow ["Wan.IspType"] == "4") then
   		configRow["Wan.MppeEncryptSupport"]="0"
        if ((configRow["Wan.LoginName"] == nil or configRow["Wan.LoginName"] == "") or (configRow["Wan.LoginPassword"] == nil or configRow["Wan.LoginPassword"] == "")) then
                    printCLIError("Invalid username/password\n")
                    return false
            end
            if (configRow["Wan.IdleTimeOutFlag"] == "1") then
                if (configRow["Wan.IdleTime"] == nil or configRow["Wan.IdleTime"] == "") then
                    printCLIError("Enter valid idle timeout value\n")
                    return false
                end
            end
            if (configRow["Wan.MyIpAddr"] ~= nil and configRow["Wan.MyIpAddr"] == "0.0.0.0") then
                    printCLIError("myIpAddress: Enter valid IP address assigned by the ISP to make a connection with the ISP server\n")
                    return false
            end
            if ((configRow["Wan.SvrIpAddr"] == "" or configRow["Wan.SvrIpAddr"] == nil)  or (configRow["Wan.SvrIpAddr"] == "0.0.0.0" and configRow["Wan.SvrIpAddr"] ~= nil))then
                    printCLIError("Enter valid IP address of the L2TP server\n")
                    return false
            end
             if(configRow["Wan.IsDNSDyn"] == "0") then
            if ((configRow["Wan.PriDnsIpAddr"] == "" or configRow["Wan.PriDnsIpAddr"] == nil) or (configRow["Wan.PriDnsIpAddr"] ~=nil and configRow["Wan.PriDnsIpAddr"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                return false
            end
            if (configRow["Wan.SecDnsIpAddr"] ~=nil and configRow["Wan.SecDnsIpAddr"] == "0.0.0.0") then
                printCLIError("Enter valid secondary dns address\n")
                return false
            end
        end

    end

    if (configRow ["Wan.IspType"] == "5") then
   		configRow["Wan.MppeEncryptSupport"]="0"
      	configRow["Wan.SplitTunnel"]="0"
        if (configRow["Wan.DialNumber"] == nil or configRow["Wan.DialNumber"] == "" ) then
                    printCLIError("Please enter a valid DailNumber\n")
                    return false
            end
            if (configRow["Wan.IdleTimeOutFlag"] == "1") then
                if (configRow["Wan.IdleTime"] == nil or configRow["Wan.IdleTime"] == "") then
                    printCLIError("Enter valid idle timeout value\n")
                    return false
                end
            end
            if(configRow["Wan.IsDNSDyn"] == "0") then
                if ((configRow["Wan.PriDnsIpAddr"] == "" or configRow["Wan.PriDnsIpAddr"] == nil) or (configRow["Wan.PriDnsIpAddr"] ~=nil and configRow["Wan.PriDnsIpAddr"] == "0.0.0.0")) then
                    printCLIError("Enter valid primary dns address\n")
                    return false
                end
                if (configRow["Wan.SecDnsIpAddr"] ~=nil and configRow["Wan.SecDnsIpAddr"] == "0.0.0.0") then
                    printCLIError("Enter valid secondary dns address\n")
                    return false
                end
            end
        end
end
-- This routin sets the WanMode configuration
function nimfCfgSaveMode (configRow)
  	local errorFlag = "OK"

    if(configRow["WanMode.WanMode"] == "1")then
		if(configRow["WanMode.LoadBal"] == "1" or configRow["WanMode.LoadBal"] == "3") then
			configRow["WanMode.Wanmode"] = configRow["WanMode.LoadBal"]
		end		
	end	
	errorFlag, statusCode = nimfView.wanModeConfig (configRow,"1","add")
	-- save db if no error
    if (errorFlag == "OK") then db.save() end
	if (errorFlag == "OK") then
    	errorFlag, statusCode = nimfView.wanMode6Config (configRow,"2","add")
	
	    -- save db if no error
        if (errorFlag == "OK") then db.save() end
   	end
   return errorFlag
end

-- This routine takes in one argument that is the value of the
-- primary key for the object table.
function nimfCfgInitMode (args)
    local configRow = {}

    configRow = db.getRow("WanMode", "_ROWID_", "1")
	if(configRow["WanMode.Wanmode"] == "3") then
		configRow["WanMode.Wanmode"] = "1" -- to check when spill over is selected
        configRow["WanMode.LoadBal"] = "3"
    elseif (configRow["WanMode.Wanmode"] == "1") then
        configRow["WanMode.LoadBal"] = "1"
	end  
	if(configRow==nil) then
		configRow={}
	end
    return 1, configRow
end

-- this routine validates the wanmode input configuration
function nimfCfgInputValMode (configRow)
    if (configRow ["WanMode.Wanmode"] == "" or configRow ["WanMode.Wanmode"] == nil) then
    printCLIError("Please enter the WAN Mode\n")
    end

    if (configRow ["WanMode.Wanmode"] == "0") then
        configRow["WanMode.FailureDetectionMeth"]="0"
         if (configRow["WanMode.DedicatedLogicalIfName"] == "" or configRow["WanMode.DedicatedLogicalIfName"] == nil) then
            printCLIError("Invalid WAN Type for Single WAN Mode\n")
            return false
        end
    end
     if (configRow ["WanMode.Wanmode"] == "1") then
   	     
        if (configRow ["WanMode.LoadBal"] == "" or configRow ["WanMode.LoadBal"] == nil) then
        printCLIError("Invalid LOAD Balnacing Algo Type\n")
        return false
        end
         if ((configRow["WanMode.FailureDetectionMeth"] == "" or configRow["WanMode.FailureDetectionMeth"] == nil)) then
            printCLIError("Enter valid Failure Detection Method\n")
            return false
        end
        if (configRow["WanMode.FailureDetectionMeth"] == "2") then
            if ((configRow["WanFailure.DnsIp"] == "" or configRow["WanFailure.DnsIp"] == nil) or (configRow["WanFailure.DnsIp"] ~=nil and configRow["WanFailure.DnsIp"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN1 DNS Address\n")
            return false
            end
             if ((configRow["WanFailure.DnsIp1"] == "" or configRow["WanFailure.DnsIp1"] == nil) or (configRow["WanFailure.DnsIp1"] ~=nil and configRow["WanFailure.DnsIp1"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN2 DNS Address\n")
            return false
            end

        elseif (configRow["WanMode.FailureDetectionMeth"] == "3") then
                if ((configRow["WanFailure.PingIp"] == "" or configRow["WanFailure.PingIp"] == nil) or (configRow["WanFailure.PingIp"] ~=nil and configRow["WanFailure.PingIp"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN1 PING Address\n")
            return false
            end
             if ((configRow["WanFailure.PingIp1"] == "" or configRow["WanFailure.PingIp1"] == nil) or (configRow["WanFailure.PingIp1"] ~=nil and configRow["WanFailure.PingIp1"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN2 PING Address\n")
            return false
            end

        end
        if ((configRow["WanMode.RetryTime"] == "" or configRow["WanMode.RetryTime"] == nil)) then
            printCLIError("Enter valid Retry time\n")
            return false
        end
        if ((configRow["WanMode.RetryAttempts"] == "" or configRow["WanMode.RetryAttempts"] == nil)) then
            printCLIError("Enter valid Retry Attempts\n")
            return false
        end
       end
       if (configRow ["WanMode.Wanmode"] == "2") then

            if (configRow["WanMode.FailoverPriLogicalIfName"] == "" or configRow["WanMode.FailoverPriLogicalIfName"] == nil) then
            printCLIError("Invalid WAN Type for Auto Rollover WAN Mode\n")
            return false
        end

   	     if ((configRow["WanMode.FailureDetectionMeth"] == "" or configRow["WanMode.FailureDetectionMeth"] == nil or configRow["WanMode.FailureDetectionMeth"] == "0")) then
            printCLIError("Enter valid Failure Detection Method\n")
            return false
        end
        if (configRow["WanMode.FailureDetectionMeth"] == "2") then
            if (configRow["WanMode.FailoverPriLogicalIfName"] == "WAN1") then
            if ((configRow["WanFailure.DnsIp"] == "" or configRow["WanFailure.DnsIp"] == nil) or (configRow["WanFailure.DnsIp"] ~=nil and configRow["WanFailure.DnsIp"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN1 DNS Address\n")
            return false
            end
        end
        if (configRow["WanMode.FailoverPriLogicalIfName"] == "WAN2") then
             if ((configRow["WanFailure.DnsIp1"] == "" or configRow["WanFailure.DnsIp1"] == nil) or (configRow["WanFailure.DnsIp1"] ~=nil and configRow["WanFailure.DnsIp1"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN2 DNS Address\n")
            return false
            end
        end

        elseif (configRow["WanMode.FailureDetectionMeth"] == "3") then
            if (configRow["WanMode.FailoverPriLogicalIfName"] == "WAN1") then
                if ((configRow["WanFailure.PingIp"] == "" or configRow["WanFailure.PingIp"] == nil) or (configRow["WanFailure.PingIp"] ~=nil and configRow["WanFailure.PingIp"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN1 PING Address\n")
            return false
            end
        end
        if (configRow["WanMode.FailoverPriLogicalIfName"] == "WAN2") then
             if ((configRow["WanFailure.PingIp1"] == "" or configRow["WanFailure.PingIp1"] == nil) or (configRow["WanFailure.PingIp1"] ~=nil and configRow["WanFailure.PingIp1"] == "0.0.0.0")) then
            printCLIError("Enter valid WAN2 PING Address\n")
            return false
            end
        end
        end
        if ((configRow["WanMode.RetryTime"] == "" or configRow["WanMode.RetryTime"] == nil)) then
            printCLIError("Enter valid Retry time\n")
            return false
        end
        if ((configRow["WanMode.RetryAttempts"] == "" or configRow["WanMode.RetryAttempts"] == nil)) then
            printCLIError("Enter valid Retry Attempts\n")
            return false
        end
       end

end

function wanSetupGetMode()
    local resultTab = {}   

    configRow = db.getRow("WanMode", "_ROWID_", "1")
	configRow["WanMode.LoadBal"] = "1"
	if(configRow["WanMode.Wanmode"] == "3") then
		configRow["WanMode.LoadBal"] = "3"
		configRow["WanMode.Wanmode"] = "1" -- to check when spill over is selected
	end  
	if(configRow==nil) then
		configRow={}
	end
    dnsip=db.getAttribute("WanFailure","LogicalIfName","WAN1","DnsIp")
	dnsip1=db.getAttribute("WanFailure","LogicalIfName","WAN2","DnsIp")
	pingip=db.getAttribute("WanFailure","LogicalIfName","WAN1","PingIp")
	pingip1=db.getAttribute("WanFailure","LogicalIfName","WAN2","PingIp")


    resTab.insertField (resultTab, "WAN Mode Configuration","")
    if (configRow["WanMode.Wanmode"] == "0") then
     if (configRow["WanMode.DedicatedLogicalIfName"] == "WAN1") then
         resTab.insertField (resultTab, "WAN Mode","Single Wan Port Using WAN1")
     else
         resTab.insertField (resultTab, "WAN Mode","Single Wan Port Using WAN2")
     end
    elseif (configRow["WanMode.Wanmode"] == "1") then
        if (configRow["WanMode.LoadBal"] == "3") then
              resTab.insertField (resultTab, "WAN Mode","LOAD Balancing Using Spill Over Mode")
        else
              resTab.insertField (resultTab, "WAN Mode","LOAD Balancing Using RoundRobin")  
        end
    elseif (configRow["WanMode.Wanmode"] == "2") then
        if (configRow["WanMode.FailoverPriLogicalIfName"] == "WAN1") then
         resTab.insertField (resultTab, "WAN Mode","Auto Rollover on Wan Port Using WAN1")
     else
         resTab.insertField (resultTab, "WAN Mode","Auto Rollover on Wan Port Using WAN2")
     end
    end
    if (configRow ["WanMode.FailureDetectionMeth"] == "0") then
        resTab.insertField (resultTab, "WAN Failure Detection Method","None")
    elseif (configRow ["WanMode.FailureDetectionMeth"] == "1") then
        resTab.insertField (resultTab, "WAN Failure Detection Method","DNS lookup using WAN DNS Servers")
    elseif (configRow ["WanMode.FailureDetectionMeth"] == "2") then
        resTab.insertField (resultTab, "WAN Failure Detection Method","DNS lookup using DNS Servers")
        resTab.insertField (resultTab, "DNS for WAN1",dnsip)
        resTab.insertField (resultTab, "DNS for WAN2",dnsip1)
    elseif (configRow ["WanMode.FailureDetectionMeth"] == "3") then
        resTab.insertField (resultTab, "WAN Failure Detection Method","Ping these IP addresses")
          resTab.insertField (resultTab, "PING IP for WAN1",pingip)
        resTab.insertField (resultTab, "PING IP for WAN2",pingip1)

    end
    resTab.insertField (resultTab, "Retry Time", configRow["WanMode.RetryTime"]or"")
    resTab.insertField (resultTab, "Retry Attempts", configRow["WanMode.RetryAttempts"]or"")
    printLabel ("WAN MODE Setup")
    resTab.print (resultTab, 0)
end

--Pppoe Profiles
function wan1PppoeCfgInit (args)
    local configRow = {}
    --configRow ["PppoeProfile.ProfileName"] = args[1]
    --configRow ["PppoeProfile.LogicalIfName"] = "WAN1"

    configRow = db.getRow("PppoeProfile", "ProfileName = '"..args[1].."' and LogicalIfName", "WAN1")

    if (configRow == nil) then
        configRow = db.getDefaults(true, "PppoeProfile")
        configRow["PppoeProfile.Status"] = "0"
        configRow ["PppoeProfile.ProfileName"] = args[1]
        configRow ["PppoeProfile.LogicalIfName"] = "WAN1"
        configRow ["PppoeProfile.IdleTimeOutValue"] = "0"
	configRow ["PppoeProfile.UserName"]="dummy"
	configRow ["PppoeProfile.Password"]="dummy"
	configRow ["PppoeProfile.AuthOpt"]="1"
    end
    return configRow["PppoeProfile._ROWID_"], configRow
end
function wan1PppoeCfgEditInit (args)
    local configRow = {}

    configRow = db.getRow("PppoeProfile", "ProfileName = '"..args[1].."' and LogicalIfName", "WAN1")

    if (configRow == nil) then
	printCLIError("Profile doesnt exist")
	return -1,{} 
    end
        
    return configRow["PppoeProfile._ROWID_"], configRow
end

function wan1PppoeCfgSave (configRow)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "PppoeProfile"
    
    RowId = configRow["PppoeProfile._ROWID_"]

    if (RowId == "-1" or RowId == nil) then
        --print (util.tableToString (configRow))
        errorFlag, statusCode = pppoe.profileConfig(configRow,"-1", "add")
 	else
 	    if (util.isAllMasked (configRow["PppoeProfile.Password"])) then
 	        configRow["PppoeProfile.Password"] = db.getAttribute ("PppoeProfile","_ROWID_",RowId,"Password")
 	    end
 	    errorFlag, statusCode = pppoe.profileConfig(configRow, RowId, "edit")
 	end
 	     
 	-- save db if no error
 	if (errorFlag == "OK") then db.save() end
 	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    return errorFlag, statusMessage
end

function wan1PppoeCfgDel (configRow)
    errorFlag = "ERROR"
    statusCode = ""
    statusMessage = ""
    DBTable = "PppoeProfile"
    local i=0
    local table = db.getRows ("PppoeProfile","LogicalIfName","WAN1")
    if (configRow["PppoeProfile._ROWID_"] ~= nil and table ~= nil and table ~= {}) then
        for k,v in pairs(table) do
        i = i + 1
        local row = table[i]
		if(configRow["PppoeProfile._ROWID_"] < row["PppoeProfile._ROWID_"]) then
			statusMessage="This profile is not allowed to delete unless the other profile is deleted"
			return errorFlag, statusMessage
		end
	end	
    end
    rows = {}
    rows["rowid"] = configRow["PppoeProfile._ROWID_"]
    if (rows) then
        errorFlag, statusCode = pppoe.profileConfig (rows, "-1", "delete")
    end
	-- save db if no error
    if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function wan1PppoeCfgInputVal (configRow)

    local opFlag = true

    if(configRow == {}) then
	print("came")
	return false
    end
    
    if (configRow ["PppoeProfile.ProfileName"] == nil or configRow ["PppoeProfile.ProfileName"] == "") then
	printCLIError("Enter Valid Profile Name\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.UserName"] == nil or configRow ["PppoeProfile.UserName"] == "") then
	printCLIError("Enter Valid User Name\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.Password"] == nil or configRow ["PppoeProfile.Password"] == "") then
	printCLIError("Enter Valid Password\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.AuthOpt"] == nil or configRow ["PppoeProfile.AuthOpt"] == "") then
	printCLIError("Enter Valid Authentication Type\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.IdleTimeOutFlag"] == "1") then
        if (configRow ["PppoeProfile.IdleTimeOutValue"] == "" or configRow ["PppoeProfile.IdleTimeOutValue"] == nil) then
            	printCLIError("Enter Valid Idle Time Out value\n")
                opFlag = false
        end
    end

    if(configRow["PppoeProfile.GetDnsFromIsp"] == "0") then
            if ((configRow["PppoeProfile.PrimaryDns"] == "" or configRow["PppoeProfile.PrimaryDns"] == nil) or (configRow["PppoeProfile.PrimaryDns"] ~=nil and configRow["PppoeProfile.PrimaryDns"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                opFlag = false
            end
            if (configRow["PppoeProfile.SecondaryDns"] ~=nil and configRow["PppoeProfile.SecondaryDns"] == "0.0.0.0") then
                printCLIError("Enter valid secondary dns address\n")
                opFlag = false
            end
        end

    if(configRow[""] == "0") then
            if ((configRow["PppoeProfile.StaticIp"] == "" or configRow["PppoeProfile.StaticIp"] == nil) or (configRow["PppoeProfile.StaticIp"] ~=nil and configRow["PppoeProfile.StaticIp"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                opFlag = false
            end
             if ((configRow["PppoeProfile.NetMask"] == "" or configRow["PppoeProfile.NetMask"] == nil) or (configRow["PppoeProfile.NetMask"] ~=nil and configRow["PppoeProfile.NetMask"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                opFlag = false
            end
    end
    return opFlag
end

function wan1PppoeCfgGet (args)
    local resultTab = {}

    printLabel ("Wan1 PPPOE Profiles")
    print ("List of available Pppoe Profiles\n")
    local i = 0
    local status = ""
    local table = db.getRows ("PppoeProfile","LogicalIfName","WAN1")
    if (table == nil) then
        print ("PPPOE Profiles unavailable")
    else
        for k,v in pairs(table) do
        i = i + 1
        local row = table[i]
        if (i ~= nil) then
        printLabel ("Profile"..row["PppoeProfile._ROWID_"].." Configuration")
        print ( "ROW ID             ", row["PppoeProfile._ROWID_"]or "")
        print ( "Profile Name       ", row["PppoeProfile.ProfileName"]or "")
        print ( "UserName           ", row["PppoeProfile.UserName"]or "")
        print ( "Service            ", row["PppoeProfile.Service"]or "")
        print ( "Password           ", util.mask(row["PppoeProfile.Password"])or"")

        if(row["PppoeProfile.Status"] == "1")then
                status = "Enabled"
            elseif (row["PppoeProfile.Status"] == "0") then
                status = "Disabled"
            end
        print ( "Status             ", status)

        local authOpt=""
 	    if(row["PppoeProfile.AuthOpt"]=="1") then
            authOpt="Auto-negotiate"
        elseif(row["PppoeProfile.AuthOpt"]=="2") then
            authOpt="PAP"
        elseif(row["PppoeProfile.AuthOpt"]=="3") then
            authOpt="CHAP"
        elseif(row["PppoeProfile.AuthOpt"]=="4") then
            authOpt="MS-CHAP"
        else
            authOpt="MS-CHAPv2"
        end
        print ( "Authentication Type ", authOpt)

        if (row["PppoeProfile.IdleTimeOutFlag"] == "0") then
          print ("Connectivity Type ", "Keep Connected")
        elseif (row["PppoeProfile.IdleTimeOutFlag"] == "1") then
          print ("Connectivity Type ", "Idle Time")
          print ("Idle Time (in minutes)", row["PppoeProfile.IdleTimeOutValue"])
        end
          
         if(row["PppoeProfile.GetDnsFromIsp "] == "0") then
        print ("Domain Name Servers (DNS) Source","Use these DNS Servers")
        print ("Primary DNS Server", row["PppoeProfile.PrimaryDns"]or"")
		if (row["PppoeProfile.SecondaryDns"] ~= nil and row["PppoeProfile.SecondaryDns"] ~= "")then
        	print ("Secondary DNS Server", row["PppoeProfile.SecondaryDns"])
		end
        else
        print ("Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end
        if(row["PppoeProfile.GetIpFromIsp"] == "0") then
        print ("Internet (IP) Address","Use Static IP Address")
        print ("IP Address          ", row["PppoeProfile.StaticIp"]or"")
        print ("Subnet Mask         ", row["PppoeProfile.NetMask"]or"")
        else
        print ("Internet (IP) Address","Get IP Dynamically From ISP")
        end
        end
        end
   end
end

--Pppoe Profiles
function wan2PppoeCfgInit (args)
    local configRow = {}
    --configRow ["PppoeProfile.ProfileName"] = args[1]
    --configRow ["PppoeProfile.LogicalIfName"] = "WAN2"

    configRow = db.getRow("PppoeProfile", "ProfileName = '"..args[1].."' and LogicalIfName", "WAN2")

    if (configRow == nil) then
        configRow = db.getDefaults(true, "PppoeProfile")
        configRow["PppoeProfile.Status"] = "0"
        configRow ["PppoeProfile.ProfileName"] = args[1]
        configRow ["PppoeProfile.LogicalIfName"] = "WAN2"
        configRow ["PppoeProfile.IdleTimeOutValue"] = "0"
	configRow ["PppoeProfile.UserName"]="dummy"
	configRow ["PppoeProfile.Password"]="dummy"
	configRow ["PppoeProfile.AuthOpt"]="1"

    end
    return configRow["PppoeProfile._ROWID_"], configRow
end
function wan2PppoeCfgEditInit (args)
    local configRow = {}

    configRow = db.getRow("PppoeProfile", "ProfileName = '"..args[1].."' and LogicalIfName", "WAN2")

    if (configRow == nil) then
	printCLIError("Profile doesnt exist")
	return -1,{}
    end
    return configRow["PppoeProfile._ROWID_"], configRow
end
function wan2PppoeCfgSave (configRow)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "PppoeProfile"
    
    RowId = configRow["PppoeProfile._ROWID_"]

    if (RowId == "-1" or RowId == nil) then
        --print (util.tableToString (configRow))
        errorFlag, statusCode = pppoe.profileConfig(configRow,"-1", "add")
 	else
 	    if (util.isAllMasked (configRow["PppoeProfile.Password"])) then
 	        configRow["PppoeProfile.Password"] = db.getAttribute ("PppoeProfile","_ROWID_",RowId,"Password")
 	    end
 	    errorFlag, statusCode = pppoe.profileConfig(configRow, RowId, "edit")
    end
 	     
 	-- save db if no error
 	if (errorFlag == "OK") then db.save() end
 	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    return errorFlag, statusMessage
end

function wan2PppoeCfgDel (configRow)
    errorFlag = "ERROR="
    statusCode = ""
    statusMessage = ""
    DBTable = "PppoeProfile"
    local i=0
    local table = db.getRows ("PppoeProfile","LogicalIfName","WAN2")
    if (configRow["PppoeProfile._ROWID_"] ~= nil and table ~= nil and table ~= {}) then
        for k,v in pairs(table) do
        i = i + 1
        local row = table[i]
		if(configRow["PppoeProfile._ROWID_"] < row["PppoeProfile._ROWID_"]) then
			statusMessage="This profile is not allowed to delete unless the other profile is deleted"
			return errorFlag, statusMessage
		end
	end
    end
    rows = {}
    rows["rowid"] = configRow["PppoeProfile._ROWID_"]
    if (rows) then
        errorFlag, statusCode = pppoe.profileConfig (rows, "-1", "delete")
    end
	-- save db if no error
    if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function wan2PppoeCfgInputVal (configRow)
	
    local opFlag = true

    if(configRow == {}) then
	return false
    end

    if (configRow ["PppoeProfile.ProfileName"] == nil or configRow ["PppoeProfile.ProfileName"] == "") then
	printCLIError("Enter Valid Profile Name\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.UserName"] == nil or configRow ["PppoeProfile.UserName"] == "") then
	printCLIError("Enter Valid User Name\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.Password"] == nil or configRow ["PppoeProfile.Password"] == "") then
	printCLIError("Enter Valid Password\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.AuthOpt"] == nil or configRow ["PppoeProfile.AuthOpt"] == "") then
	printCLIError("Enter Valid Authentication Type\n")
	opFlag = false
    end

    if (configRow ["PppoeProfile.IdleTimeOutFlag"] == "1") then
        if (configRow ["PppoeProfile.IdleTimeOutValue"] == "" or configRow ["PppoeProfile.IdleTimeOutValue"] == nil) then
            	printCLIError("Enter Valid Idle Time Out value\n")
                opFlag = false
        end
    end

    if(configRow["PppoeProfile.GetDnsFromIsp"] == "0") then
            if ((configRow["PppoeProfile.PrimaryDns"] == "" or configRow["PppoeProfile.PrimaryDns"] == nil) or (configRow["PppoeProfile.PrimaryDns"] ~=nil and configRow["PppoeProfile.PrimaryDns"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                opFlag = false
            end
            if (configRow["PppoeProfile.SecondaryDns"] ~=nil and configRow["PppoeProfile.SecondaryDns"] == "0.0.0.0") then
                printCLIError("Enter valid secondary dns address\n")
                opFlag = false
            end
        end

    if(configRow[""] == "0") then
            if ((configRow["PppoeProfile.StaticIp"] == "" or configRow["PppoeProfile.StaticIp"] == nil) or (configRow["PppoeProfile.StaticIp"] ~=nil and configRow["PppoeProfile.StaticIp"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                opFlag = false
            end
             if ((configRow["PppoeProfile.NetMask"] == "" or configRow["PppoeProfile.NetMask"] == nil) or (configRow["PppoeProfile.NetMask"] ~=nil and configRow["PppoeProfile.NetMask"] == "0.0.0.0")) then
                printCLIError("Enter valid primary dns address\n")
                opFlag = false
            end
    end
    return opFlag
end

function wan2PppoeCfgGet (args)
    local resultTab = {}

    printLabel ("Wan2 PPPOE Profiles")
    print ("List of available Pppoe Profiles\n")
    local i = 0
    local status = ""
    local table = db.getRows ("PppoeProfile","LogicalIfName","WAN2")
    if (table == nil) then
        print ("PPPOE Profiles unavailable")
    else
        for k,v in pairs(table) do
        i = i + 1
        local row = table[i]
        if (i ~= nil) then
        printLabel ("Profile"..row["PppoeProfile._ROWID_"].." Configuration")
        print ( "ROW ID             ", row["PppoeProfile._ROWID_"]or "")
        print ( "Profile Name       ", row["PppoeProfile.ProfileName"]or "")
        print ( "UserName           ", row["PppoeProfile.UserName"]or "")
        print ( "Service            ", row["PppoeProfile.Service"]or "")
        print ( "Password           ", util.mask(row["PppoeProfile.Password"])or"")

        if(row["PppoeProfile.Status"] == "1")then
                status = "Enabled"
            elseif (row["PppoeProfile.Status"] == "0") then
                status = "Disabled"
            end
        print ( "Status             ", status)

        local authOpt=""
 	    if(row["PppoeProfile.AuthOpt"]=="1") then
            authOpt="Auto-negotiate"
        elseif(row["PppoeProfile.AuthOpt"]=="2") then
            authOpt="PAP"
        elseif(row["PppoeProfile.AuthOpt"]=="3") then
            authOpt="CHAP"
        elseif(row["PppoeProfile.AuthOpt"]=="4") then
            authOpt="MS-CHAP"
        else
            authOpt="MS-CHAPv2"
        end
        print ( "Authentication Type ", authOpt)

        if (row["PppoeProfile.IdleTimeOutFlag"] == "0") then
          print ("Connectivity Type ", "Keep Connected")
        elseif (row["PppoeProfile.IdleTimeOutFlag"] == "1") then
          print ("Connectivity Type ", "Idle Time")
          print ("Idle Time (in minutes)", row["PppoeProfile.IdleTimeOutValue"])
        end
          
         if(row["PppoeProfile.GetDnsFromIsp "] == "0") then
        print ("Domain Name Servers (DNS) Source","Use these DNS Servers")
        print ("Primary DNS Server", row["PppoeProfile.PrimaryDns"]or"")
		if (row["PppoeProfile.SecondaryDns"] ~= nil and row["PppoeProfile.SecondaryDns"] ~= "")then
        	print ("Secondary DNS Server", row["PppoeProfile.SecondaryDns"])
		end
        else
        print ("Domain Name Servers (DNS) Source","Get Dynamically From ISP")
        end
        if(row["PppoeProfile.GetIpFromIsp"] == "0") then
        print ("Internet (IP) Address","Use Static IP Address")
        print ("IP Address          ", row["PppoeProfile.StaticIp"]or"")
        print ("Subnet Mask         ", row["PppoeProfile.NetMask"]or"")
        else
        print ("Internet (IP) Address","Get IP Dynamically From ISP")
        end
        end
        end
   end
end

--
--wanPortCfgInit
--
function wanPortCfgInit (args)
    local configRow = {}

	local configRow2 = {}
	local configRow3 = {}
	configRow = wan.wanConfigGetWrap("WAN1")
	configRow2 = wan.wanConfigGetWrap("WAN2")
	configRow3 = db.getRow("AttackChecks","_ROWID_","1")
    configRow["AttackChecks.ExternalPing"] = configRow3["AttackChecks.ExternalPing"] 
    configRow ["Wan.DefMtu2"] = configRow2 ["Wan.DefMtu"] or ''
    configRow ["Wan.MtuSize2"] = configRow2 ["Wan.MtuSize"] or ''
    configRow ["Wan.portSpeed2"] = configRow2 ["Wan.portSpeed"] or ''

    return 1, configRow
end

--
--wanPortCfgSave
--
function wanPortCfgSave (configRow)
    
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "PppoeProfile"
    
    errorFlag, statusCode = wan.wanConfigSetWrap(configRow, "1", "edit")
	-- save db if no error
	if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

--
--wanPortCfgInputVal
--
function wanPortCfgInputVal (configRow)
   local opFlag = true

    if(configRow == {}) then
	return false
    end

    if (configRow ["AttackChecks.ExternalPing"] == "" or configRow ["AttackChecks.ExternalPing"] == nil) then
	printCLIError("Enter Valid External Ping Value\n")
	opFlag = false
    end
    if (configRow ["Wan.DefMtu"] == "" or configRow ["Wan.DefMtu"] == nil) then
	printCLIError("Enter Valid MTU Type for WAN1\n")
	opFlag = false
    end
    if (configRow ["Wan.DefMtu"] == "0") then
        if (configRow ["Wan.MtuSize"] == "" or configRow ["Wan.MtuSize"] == nil) then
            printCLIError("Enter Valid MTU SIZE for WAN1\n")
        	opFlag = false
        end
    end
    if (configRow ["Wan.portSpeed"] == "" or configRow ["Wan.portSpeed"] == nil) then
	printCLIError("Enter Valid Port Speed for WAN1\n")
	opFlag = false
    end

    if (configRow ["Wan.DefMtu2"] == "" or configRow ["Wan.DefMtu2"] == nil) then
	printCLIError("Enter Valid MTU Type for WAN2\n")
	opFlag = false
    end
    if (configRow ["Wan.DefMtu2"] == "0") then
        if (configRow ["Wan.MtuSize2"] == "" or configRow ["Wan.MtuSize2"] == nil) then
            printCLIError("Enter Valid MTU SIZE for WAN2\n")
        	opFlag = false
        end
    end
    if (configRow ["Wan.portSpeed2"] == "" or configRow ["Wan.portSpeed2"] == nil) then
	printCLIError("Enter Valid Port Speed for WAN2\n")
	opFlag = false
    end
    return opFlag
end

function wanPortCfgGet (args)

	local configRow1 = {} 
	local configRow2 = {}
	local configRow3 = {}
	configRow1 = wan.wanConfigGetWrap("WAN1")
	configRow2 = wan.wanConfigGetWrap("WAN2")
	configRow3 = db.getRow("AttackChecks","_ROWID_","1")

    printLabel ("WAN Port Setup")
    if (configRow3["AttackChecks.ExternalPing"] == 1) then
        print ( "Respond to Ping:", "Enabled")
    else
        print ( "Respond to Ping:", "Disabled")
    end
    printLabel ("WAN1 Port Setup")
    
    if (configRow1["Wan.DefMtu"] == "0") then
        print ( "MTU Type:", "Custom" )
        print ( "MTU Size:", configRow1["Wan.MtuSize"]or "")
    else
        print ( "MTU Type:", "Default" )
    end
    if (configRow1["Wan.portSpeed"] == "0") then
        print ( "Port Speed:", "Auto Sense")
    elseif (configRow1["Wan.portSpeed"] == "1") then
        print ( "Port Speed:", "10 BaseT Half Duplex")
    elseif (configRow1["Wan.portSpeed"] == "2") then
        print ( "Port Speed:", "10 BaseT Full Duplex")
    elseif (configRow1["Wan.portSpeed"] == "3") then
        print ( "Port Speed:", "100 BaseT Half Duplex")
    elseif (configRow1["Wan.portSpeed"] == "4") then
        print ( "Port Speed:", "100 BaseT Full Duplex")
    elseif (configRow1["Wan.portSpeed"] == "5") then
        print ( "Port Speed:", "1000 BaseT Half Duplex")
    elseif (configRow1["Wan.portSpeed"] == "6") then
        print ( "Port Speed:", "1000 BaseT Full Duplex")
    end

    printLabel ("WAN2 Port Setup")
    
    if (configRow2["Wan.DefMtu"] == "0") then
        print ( "MTU Type:", "Custom" )
        print ( "MTU Size:", configRow2["Wan.MtuSize"]or "")
    else
        print ( "MTU Type:", "Default" )
    end
    if (configRow2["Wan.portSpeed"] == "0") then
        print ( "Port Speed:", "Auto Sense")
    elseif (configRow2["Wan.portSpeed"] == "1") then
        print ( "Port Speed:", "10 BaseT Half Duplex")
    elseif (configRow2["Wan.portSpeed"] == "2") then
        print ( "Port Speed:", "10 BaseT Full Duplex")
    elseif (configRow2["Wan.portSpeed"] == "3") then
        print ( "Port Speed:", "100 BaseT Half Duplex")
    elseif (configRow2["Wan.portSpeed"] == "4") then
        print ( "Port Speed:", "100 BaseT Full Duplex")
    elseif (configRow2["Wan.portSpeed"] == "5") then
        print ( "Port Speed:", "1000 BaseT Half Duplex")
    elseif (configRow2["Wan.portSpeed"] == "6") then
        print ( "Port Speed:", "1000 BaseT Full Duplex")
    end
end


--
--wanPortCfgInit
--
function wanConfigPortCfgInit (args)
    
    local configRow = {}
    configRow = db.getRow("ConfigPort", "_ROWID_", "1")
	if (configRow == nil) then
	    configRow = db.getDefaults(true, "ConfigPort")
    end


    return 1, configRow
end

--
--wanPortCfgSave
--
function wanConfigPortCfgSave (configRow)
    
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "ConfigPort"

    -- Checking for OptionalWAN Configurations
	errorFlag, statusCode = nimfView.checkOptionWanTables (configRow)
	if (errorFlag == "OK") then

		-- Checking Configurable Port is using by traffic selectors or not
		-- in bandwidth profiles.
		errorFlag, statusCode = nimfView.configurablePortUsageCheck (configRow)
		    
		
		local oldPort = db.getAttribute ("ConfigPort", "_ROWID_", "1","LogicalIfName")
		if (errorFlag == "OK") then
			errorFlag, statusCode = nimfView.portModeConfig (configRow, "1", "edit");
		end
	
		-- updating vlan port mgmt tables.
		if (errorFlag == "OK") then
		    errorFlag, statusCode = vlanConfig.portMgmtUpdate (configRow)
		end
	
	
		-- save db if no error
	    if (errorFlag == "OK") then
	    db.save()
	   		local newPort = db.getAttribute ("ConfigPort", "_ROWID_", "1","LogicalIfName")
			-- check that oldPort not equal to newPort
	   		if (oldPort ~= newPort) then
				-- dummy update the corresponding tables based on old Port configuration   		
	   			if (oldPort == "WAN2") then
	   				local temp = db.getRowWhere ("NimfConf", "LogicalIfName = 'WAN2' and AddressFamily = 2")
	   				if (temp ~= nil) then
	   					db.setAttribute ("NimfConf", "_ROWID_", temp["NimfConf._ROWID_"], "LogicalIfName", temp["NimfConf.LogicalIfName"])
	                end
	   			elseif (oldPort == "LAN") then
	   				local temp = db.getRowWhere ("ifStatic", "LogicalIfName = 'LAN' and AddressFamily = 2")
	   				if (temp ~= nil) then
	   					db.setAttribute ("ifStatic", "_ROWID_", temp["ifStatic._ROWID_"], "LogicalIfName", temp["ifStatic.LogicalIfName"])
	                end
	   			elseif (oldPort == "DMZ") then
	   				local temp = db.getRowWhere ("ifStatic", "LogicalIfName = 'DMZ' and AddressFamily = 2")
	   				if (temp ~= nil) then
	   					db.setAttribute ("ifStatic", "_ROWID_", temp["ifStatic._ROWID_"], "LogicalIfName", temp["ifStatic.LogicalIfName"])
	   				end   				
	            end
	              			
	            -- run program to Disable/Enable the Vlan from the shell 
	            local prog = db.getAttribute("environment", "name", "CONFIG_PORT_UPDATE", "value")
	            if (prog ~= nil) then
		            util.appendDebugOut("Exec = " .. os.execute(prog .. " " .. oldPort .. " " .. newPort))
	        	end  			
	  			
				-- dummy update the corresponding tables based on new Port configuration
	   			if (newPort == "WAN2") then
	   				local temp = db.getRowWhere ("NimfConf", "LogicalIfName = 'WAN2' and AddressFamily = 2")
	   				if (temp ~= nil) then
	   					db.setAttribute ("NimfConf", "_ROWID_", temp["NimfConf._ROWID_"], "LogicalIfName", temp["NimfConf.LogicalIfName"])
	   				end   			
	   			elseif (newPort == "LAN") then
	   				local temp = db.getRowWhere ("ifStatic", "LogicalIfName = 'LAN' and AddressFamily = 2")
	   				if (temp ~= nil) then
	   					db.setAttribute ("ifStatic", "_ROWID_", temp["ifStatic._ROWID_"], "LogicalIfName", temp["ifStatic.LogicalIfName"])
	   				end
	   			elseif (newPort == "DMZ") then
	   				local temp = db.getRowWhere ("ifStatic", "LogicalIfName = 'DMZ' and AddressFamily = 2")
	   				if (temp ~= nil) then
	   					db.setAttribute ("ifStatic", "_ROWID_", temp["ifStatic._ROWID_"], "LogicalIfName", temp["ifStatic.LogicalIfName"])
	   				end   				
	   			end
	    	end
	    end
	end	    
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    return errorFlag, statusMessage
end

--
--wanPortCfgInputVal
--
function wanConfigPortCfgInputVal (configRow)
   local opFlag = true
    local wanModeConfig = db.getRow("WanMode", "_ROWID_", "1")
    if (wanModeConfig ~= nil) then
    	if (wanModeConfig["WanMode.Wanmode"] ~= nil and wanModeConfig["WanMode.Wanmode"] == "0") then
    		if (wanModeConfig["WanMode.DedicatedLogicalIfName"] ~= nil and wanModeConfig["WanMode.DedicatedLogicalIfName"] == "WAN1") then
    			--correct case
    		else
    		    opFlag = false
	            printCLIError("WAN Mode is not Dedicated WAN1. So you can't configure the configurable port\n")
    		end
   		else
    	    opFlag = false
	        printCLIError("WAN Mode is not Dedicated WAN1. So you can't configure the configurable port\n")
    	end
    end

    if(configRow == {}) then
	return false
    end

    if (configRow ["ConfigPort.LogicalIfName"] == "" or configRow ["ConfigPort.LogicalIfName"] == nil or (configRow ["ConfigPort.LogicalIfName"] ~= "WAN2" and configRow ["ConfigPort.LogicalIfName"] ~= "DMZ")) then
	printCLIError("Enter Valid Port Name\n")
	opFlag = false
    end
    return opFlag

end

function wanConfigPortCfgGet (args)
    local configRow = {}
    configRow = db.getRow("ConfigPort", "_ROWID_", "1")
	if (configRow == nil) then
	    configRow = db.getDefaults(true, "ConfigPort")
    end
    printLabel ("Configurable Port ")
    print ( "Port Selected :", configRow["ConfigPort.LogicalIfName"] or "")

end
