-- portManagementCLI.lua
-- Samer Sayeed
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 12jan09,ss written 
--
-- Description
-- CLI interface set and get routines

require "teamf1lualib/portMgmt"

function portManagementCfgSave(configRow)
    DBTable = "PortMgmt"
    errorFlag, statusCode = portMgmt.portMgmtConfig(configRow, "-1", "edit")
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end
   
function portManagementCfgInit(args)
    configRow = db.getRow ("PortMgmt", "PortName", args[1])
    if(configRow == nil)then
        print("Row doesnot exist\n")
        return -1, {} 
    end
    return configRow["PortMgmt._ROWID_"], configRow
end

function portManagementCfgInputVal(configRow)
    --if(configRow["PortMgmt.AutoNegEnable"] == "1" and configRow["PortMgmt.DuplexMode"] ~= nil and configRow["PortMgmt.PortSpeed"] ~= nil )then
     --   printCLIError ("Duplex Mode, Port speed shouldnt be configured when auto mode is enabled\n")
     --   return false
    --end
    return true
end

function portManagementCfgGet (configRow)
    local resultTab = {}
    local i = 0
    local table = db.getTable ("PortMgmt")

    printLabel("Port Management")
    print ("Port Management Settings\n")
    for k,v in pairs(table) do
	i = i + 1
	local row = table[i]
        if(row["PortMgmt.PortStatus"] == "0")then
            portStatus = "Disabled"
        elseif(row["PortMgmt.PortStatus"] == "1") then
            portStatus = "Enabled"
        end
        if(row["PortMgmt.AutoNegEnable"] == "1")then
            auto = "Enabled"
        elseif(row["PortMgmt.AutoNegEnable"] == "0")then
            auto = "Disabled"
        end
        if(row["PortMgmt.DuplexMode"] == "1")then
            mode = "Full"
        elseif(row["PortMgmt.DuplexMode"] == "0")then
            mode = "Half"
        end
        resTab.insertField (resultTab, "Port Name", row["PortMgmt.PortName"] or "")
        resTab.insertField (resultTab, "Status", portStatus or "")
        resTab.insertField (resultTab, "Auto",  auto or "" ) 
        resTab.insertField (resultTab, "Duplex",  mode or "")
        resTab.insertField (resultTab, "Speed", row["PortMgmt.PortSpeed"] or "")
    end
    resTab.print (resultTab, 0)
end 
