--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### Mar 14, 2008
#### File: pppoe.lua
#### Description: PPPOE Setup functions
#### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package PPPOE Configurations
pppoe = {}

--************* Functions *************
-- PPPOE config
function pppoe.config (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return db.insert("Pppoe", inputTable)
        elseif (operation == "edit") then
            return db.update("Pppoe", inputTable, rowid)
        elseif (operation == "delete") then
            return nil
        end
    end
    return false
end

function pppoe.profileConfig (inputTable, rowid, operation)
	local PPPOE_PROFILE_MAX_LIMIT = 2  -- limit specification for the pppoe profile	
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    
    -- Checking the limit for the number of profiles
    if(operation == "add") then
    	local wanRowCount = db.getAttribute("PppoeProfile",'LogicalIfName',inputTable["PppoeProfile.LogicalIfName"],"count(*)") or '0'
    	if(operation == "add" and tonumber(wanRowCount) >= PPPOE_PROFILE_MAX_LIMIT) then
        	return "ERROR", "PPPOE_PROFILES_LIMIT_ERROR"
    	end
	end
    
    db.beginTransaction() --begin transaction
    local valid = false

    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            valid = db.insert("PppoeProfile", inputTable)
        elseif (operation == "edit") then
            valid = db.update("PppoeProfile", inputTable, rowid)
        elseif (operation == "delete") then
            valid = db.delete("PppoeProfile", inputTable)
        end
    end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "PPPOE_PROFILE_CONFIG_FAILED"
    end
end
