-- pppoeCLI.lua
-- Mohammad Rafi
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 24Sep08,rfi written
--
-- Description
-- CLISH pppoe LUA routines

require "teamf1lualib/pppoe"

--
-- get the field values from the dbase table
function pppoeConfigGet ()
    local resultTab = {}
    
    local row = db.getRow ("Pppoe", "_ROWID_", 1)
    resTab.insertField (resultTab, "Username", row["Pppoe.UserName"])
    resTab.insertField (resultTab, "Password", row["Pppoe.Password"])
    resTab.insertField (resultTab, "Authentication Type", row["Pppoe.AuthType"])
    resTab.insertField (resultTab, "Service Name", row["Pppoe.Service"] or "")
    resTab.insertField (resultTab, "Enable Compression Negotiation", row["Pppoe.Compression"])
    resTab.insertField (resultTab, "Connection Mode", row["Pppoe.IdleTimeOutFlag"])
    resTab.insertField (resultTab, "Idle Timeout", row["Pppoe.IdleTimeOutValue"])
    resTab.insertField (resultTab, "IP Address", row["Pppoe.StaticIp"])
    resTab.insertField (resultTab, "IP Subnet Mask", row["Pppoe.NetMask"])
    resTab.insertField (resultTab, "Get Automatically from ISP", row["Pppoe.GetIpFromIsp"])
    resTab.insertField (resultTab, "Use These DNS Servers", row["Pppoe.GetDnsFromIsp"] )
    resTab.insertField (resultTab, "Primary DNS Server", row["Pppoe.PrimaryDns"] or "")
    resTab.insertField (resultTab, "Secondary DNS Server", row["Pppoe.SecondaryDns"] or "")
    
    printLabel ("PPPOE configuration")
    resTab.print (resultTab, 0)
end

--
-- This routine save PPPOE configuration
function pppoeConfigSave (configRow)
    local errorFlag = "ERROR"
    
    -- Write configuration to database
    errorFlag = pppoe.config (configRow,configRow["Pppoe._ROWID_"], "edit")
    if (errorFlag) then
        db.setAttribute ("NimfConf", "_ROWID_", "1","IfStatus","1")
        errorFlag = "OK"
        db.save()
    end
    
    return errorFlag
end

-- This routine takes in one argument that is the value of the
-- primary key for the object table.
function pppoeConfigInit (args)
    local configRow = {}
    local rowId = 1 -- pppoe table has only one row

    configRow = db.getRow("Pppoe", "Pppoe._ROWID_", rowId)
    return rowId, configRow
end

