--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### Aug 11, 2009
#### File: pptpServer.lua
#### Description: pptpServer functions
#### Revisions:
]]--


--table packages
pptpServer = {}

--************* Functions *************
-- pptpServer config
function pptpServer.config (inputTable, rowid, operation)
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
           return db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
           return db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
           return db.delete(DBTable, inputTable)
        end
    else
        return false
    end
end

-- PPTP User config
function pptpServer.userConfig (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	
	db.beginTransaction() --begin transaction
	local valid = false

    if (operation == "edit") then
        if (util.isAllMasked (inputTable["pptpServerUsers.password"])) then
            inputTable["pptpServerUsers.password"] = db.getAttribute ("pptpServerUsers", "_ROWID_", rowid, "password")
        end
    end
    valid = pptpServer.config (inputTable, rowid, operation)

    -- return
	if (valid) then
		db.commitTransaction()
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "PPTP_USER_CONFIG_FAILED"
	end
end

-- Enable / Disable PPTP Users
function pptpServer.userStatusChange (rowIds, operation)
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end

	db.beginTransaction() --begin transactions
    local valid = false
    local enableFlag = "1"
    if (operation == "enable") then
        enableFlag = "1"
    else
        enableFlag = "0"
    end

    for k,v in pairs(rowIds) do
        local inTable = {}
        inTable["pptpServerUsers.enableConnection"] = enableFlag;
        valid = pptpServer.config (inTable, v, "edit")
        if (not valid) then
            break
        end
    end

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "PPTP_USER_CONFIG_FAILED"
	end
end

--PPTP Server Config
function pptpServer.serverConfig (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	
	db.beginTransaction() --begin transaction
	local valid = false

    valid = pptpServer.config (inputTable, rowid, operation)

    -- return
	if (valid) then
		db.commitTransaction()
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "PPTP_SERVER_CONFIG_FAILED"
	end
end
