--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### May 16, 2008
#### File: protocolBinding.lua
#### Description: protocolBinding functions
#### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package Firewall Rules Configurations
protocolBinding = {}

--************* Functions *************
-- Protocol Binding Config
function protocolBinding.config (inputTable, rowid, operation)
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transactions
    local valid = false

    if (db.typeAndRangeValidate(inputTable)) then
      	if (operation == "add") then
        	valid = db.insert("ProtocolBinding", inputTable)
       	elseif (operation == "edit") then
        	valid = db.update("ProtocolBinding", inputTable, rowid)
       	elseif (operation == "delete") then
        	valid = false
       	end
    end

    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "PB_RULE_CONFIG_FAILED"
    end
end

-- Modify Protcol Binding Rules (Enable/Disable/Delete)
function protocolBinding.modifyRules (rowIds, operation)
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transactions
    local valid = true
    local errStr = "STATUS_OK"

    if (operation == "enable") then
        for k,v in pairs(rowIds) do
            local inTable = {}
            inTable["ProtocolBinding.Enabled"] = "1";
            valid = db.update("ProtocolBinding", inTable, v)
            if (valid == false) then
                errStr = "PB_RULES_ENABLED_FAILED"
                break
            end
        end

        if (valid) then
            errStr = "PB_RULES_ENABLED"       
        end
    elseif (operation == "disable") then
        for k,v in pairs(rowIds) do
            local inTable = {}
            inTable["ProtocolBinding.Enabled"] = "0";
            valid = db.update("ProtocolBinding", inTable, v)
            if (valid == false) then
                errStr = "PB_RULES_DISABLED_FAILED"
                break
            end
        end
        if (valid) then
            errStr = "PB_RULES_DISABLED"
        end
    else
        for k,v in pairs(rowIds) do
            local inTable = {}
            inTable["ProtocolBinding._ROWID_"] = v;
            valid = db.delete("ProtocolBinding", inTable)
            if (valid == false) then
                errStr = "PB_RULES_DELETE_FAILED"
                break
            end
        end
        if (valid) then
            errStr = "PB_RULES_DELETED"
        end
    end

    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", errStr
    else
        db.rollback()
        return "ERROR", errStr
    end
end
