--[[
#### Abhinendra Babu. T
#### TeamF1
#### www.TeamF1.com
#### June 18, 2008
#### File: radvd.lua
#### Description: RADVD Functions
### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package bwProfiles
radvd = {}
radvdPrefix = {}

--************* Functions *************
-- RADVD Profiles Configuration
function radvd.config (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            return db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
            return db.delete(DBTable, inputTable)
        end
    end
    return false
end

-- RADVD Profiles Configuration
function radvd.profileConfig (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
    local valid = false
    
    valid = radvd.config(inputTable, rowid, operation)
       	
    -- return
    if (valid) then
    	db.commitTransaction(true)
    	return "OK", "STATUS_OK"
    else
    	db.rollback()
	return "ERROR", "RADVD_CONFIG_FAILED"    	
    end
end

-- RADVD Prefix Configuration
function radvdPrefix.config (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            return db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
            return db.delete(DBTable, inputTable)
        end
    end
    return false
end

-- RADVD Prefix Configuration
function radvdPrefix.profileConfig (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
    local valid = false
    
    valid = radvdPrefix.config(inputTable, rowid, operation)

    -- return
    if (valid) then
    	db.commitTransaction(true)
    	return "OK", "STATUS_OK"
    else
    	db.rollback()
	return "ERROR", "RADVD_PREFIX_CONFIG_FAILED"    	
    end
end

-- RADVD Prefix Deletion
function radvdPrefix.deleteProfiles (rowIds)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
    local valid = false

    -- delete routes
    for k,v in pairs(rowIds) do
        local inTable = {}
        inTable["radvdLANPrefixPool._ROWID_"] = v;
	valid = db.delete("radvdLANPrefixPool" , inTable)
	if (not valid) then
	    break
	end
    end

    -- return
    if (valid) then
        db.commitTransaction(true)
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "RADVD_PREFIX_DELETE_FAILED"
    end
end
