--[[
#### 
#### TeamF1
#### www.TeamF1.com
#### Mar 11, 2008
#### File: rip.lua
#### Description: RIP configuration functions
#### Revisions:
]]--

--************* Requires *************

--************* Initial Code *************

--package RIP Configuration
rip = {}

--************* Functions *************
-- RIP Configuration
function rip.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
    	return "ACCESS_DENIED", "ADMIN_REQD"
    end

    -- Date Formatting
    if(inputTable["Rip.AuthenticationType"] == "1") then
        local dateRange = {"FirstKeyFrom","FirstKeyTo","SecondKeyFrom","SecondKeyTo"}
    	for k,v in pairs(dateRange) do
            local dateFormat = inputTable["Rip." .. v .. "3"] .. "/" .. inputTable["Rip." .. v .. "1"] .. "/" .. inputTable['Rip.' .. v .. '2']
            dateFormat = dateFormat .. "@" .. inputTable['Rip.'.. v .. '4'] .. ":" .. inputTable['Rip.'.. v .. '5'] .. ":" .. inputTable['Rip.'.. v .. '6']
    	    inputTable['Rip.' .. v] =  dateFormat
	    end
    end
		
    db.beginTransaction() --begin transaction
    local valid = false

    local Rowid = db.existsRow ("Rip", "_ROWID_", rowid)
    if(Rowid) then
 	    valid = rip.dbconfig(inputTable, rowid, "edit")
    else
    	valid = rip.dbconfig(inputTable, rowid, "add")
    end

    if(valid) then
 	    db.commitTransaction(true)
    	return "OK", "STATUS_OK"
    else
	    db.rollback()
    	return "ERROR", "RIP_CONFIG_FAILED"
    end
end

function rip.dbconfig(inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
        	return db.insert("Rip", inputTable)
        elseif (operation == "edit") then
        	return db.update("Rip", inputTable, rowid)
        elseif (operation == "delete") then
   	        return db.delete("Rip", inputTable)
        end
    else
        return false
    end
end
