--[[
#### Sat
#### TeamF1
#### www.TeamF1.com
#### Jan 22, 2008

#### File: tcpdump.lua
#### Description: tcpdump functions

#### Revisions:
None
]]--


--************* Requires *************

--************* Initial Code *************
--package tcpdump
tcpdump = {}

--************* Functions *************
-- tcpdump config
function tcpdump.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
    local valid = false

    if (inputTable ["tcpdump.tcpdumpEnabled"] == "1" ) then
        if(inputTable["tcpdump.LogicalIfName"] == "WAN1" or inputTable["tcpdump.LogicalIfName"] == "LAN") then        	
            local ret = db.getRowsWhere ("networkInterface", "LogicalIfName= '" .. inputTable["tcpdump.LogicalIfName"].. "'")            
            for key,value1 in pairs (ret) do
                local WanInterface = value1 ["networkInterface.LogicalIfName"]
                if (WanInterface == "LAN") then
                    break
                else 
                	local status = db.getRowsWhere ("nimfStatus", "LogicalIfName = '" .. WanInterface .. "'")
                    for key2,value2 in pairs (status) do
                        local WanStatus = value2 ["nimfStatus.Linkstatus"]
                        if (WanStatus == "LINK UP") then 
                            break
                        else
                            db.rollback()
                            return "ERROR", "TCPDUMP_IFACE_DOWN"
                        end
                    end            
                end
            end
        else
            if(inputTable["tcpdump.LogicalIfName"] == "WAN2") then
            	local ConfigPort = db.getAttribute ("ConfigPort", "_ROWID_", 1, "LogicalIfName")
            	local status = db.getRowsWhere ("nimfStatus", "LogicalIfName = '" .. ConfigPort .. "'")
            	local connectionTypeRow = db.getRowWhere("NimfConf", "LogicalIfName = '".. ConfigPort .."' and AddressFamily = 2")
            	local connectionType = ""
           		if(connectionTypeRow ~= nil) then
        	    	connectionType = connectionTypeRow["NimfConf.ConnectionType"]
        		end
            	if(ConfigPort == "DMZ" or (ConfigPort == "WAN2" and connectionType ~= "threeg")) then
            		for key2,value2 in pairs (status) do
            			local WanStatus = value2 ["nimfStatus.Linkstatus"]
            			if (WanStatus == "LINK UP") then 
            				break
            			else
            				db.rollback()
            				return "ERROR", "TCPDUMP_IFACE_DOWN"
            			end
            		end       		
        	end
            end	
    	end
    end
    -- validate
    if (true) then
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then
            valid = tcpdump.update_config(inputTable,rowid)
        elseif (operation == "delete") then
            return nil
        end
    end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "TCPDUMP_CONFIG_FAILED"
    end
end

-- Updating Configurations
function tcpdump.update_config (inputTable,rowid)
    -- updating TCPDUMP Configurations
    valid = db.update("tcpdump",inputTable,rowid)
    return valid
end

