--[[
#### Adarsh Uppula
#### TeamF1
#### www.TeamF1.com
#### June 29, 2007

#### File: time.lua
#### Description: time functions

#### Revisions:
01a 04Jun09 shv, Added function to configure manual time settings.
]]--


--************* Requires *************

require "timeLib"

--************* Initial Code *************

--package time
time = {}

--table packages
ntp = {}

--************* Functions *************

-- time setTimeAndDate
function time.setTimeAndDate(inputTable)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	if (db.typeAndRangeValidate(inputTable)) then
		--call C function
		local result = timeLib.setTimeAndDate(inputTable["ntp.month"], inputTable["ntp.date"], inputTable["ntp.year"], inputTable["ntp.hours"], inputTable["ntp.minutes"], inputTable["ntp.seconds"])
		return "OK", "STATUS_OK"
	else
		return "ERROR", "TIME_STATUS_TIMEDATE_FAILED"
	end
end

-- time config
function time.ntp_config (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	db.beginTransaction() --begin transaction
	local valid = false
	
	-- config users
	valid = ntp.config(inputTable, rowid, operation)
	
	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "TIME_STATUS_NTP_FAILED"
	end
end

-- ntp config
function ntp.config (inputTable, rowid, operation)
	-- validate
	if (ntp.inputvalidate(inputTable, operation)) then
		if (operation == "add") then
			return db.insert("ntp", inputTable)
		elseif (operation == "edit") then
			return db.update("ntp", inputTable, rowid)
		elseif (operation == "delete") then
			return db.delete("ntp", inputTable)
		end
	end
	return false
end

-- ntp inputvalidate
function ntp.inputvalidate (inputTable, operation)
	if (true) then
		return db.typeAndRangeValidate(inputTable)
	end
	return false
end

-- time config
function time.manualTimeConfig (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end

    db.beginTransaction() --begin transaction
	local valid = false
	
	-- time config
	if (db.typeAndRangeValidate(inputTable)) then
		if (operation == "add") then
			valid = db.insert(DBTable, inputTable)
		elseif (operation == "edit") then
			valid = db.update(DBTable, inputTable, rowid)
		elseif (operation == "delete") then
			valid = db.delete(DBTable, inputTable)
		end
	end
	
	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "MANUAL_TIME_CONFIG_FAILED"
	end
end
