--[[
#### Hussain vali.
#### TeamF1
#### www.TeamF1.com
#### Feb 11, 2010
#### File: usb.lua
#### Description: USB Setup functions

#### Revisions:
None
]]--

--************* Requires *************

--************* Initial Code *************

--package USB Configurations
usb = {}

--************* Functions *************
-- ddnsServer config
function usb.config (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return db.insert(DBTable, inputTable)
        elseif (operation == "edit") then
            return db.update(DBTable, inputTable, rowid)
        elseif (operation == "delete") then
            return db.delete(DBTable, inputTable)
        end
    end
end

-- dns server config
function usb.usbConfig (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end

	db.beginTransaction() --begin transaction
	local valid = false

    valid = usb.config (inputTable, rowid, operation)

	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "USB_CONFIG_FAILED"
	end
end

