-- usbCLI.lua
-- Dorababu Moturi
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 04Mar10,db written
--
-- Description
-- CLISH usb LUA routines
--

require "teamf1lualib/usb"

--
--usb1CfgInit
--
function usb1CfgInit (args)

    configRow = db.getRow("USB", "usbNum", "0")

	if (configRow == nil) then 
        configRow = {}
        configRow["USB._ROWID_"] = "-1"
    end

	configRowId = configRow["USB._ROWID_"]

    return configRowId, configRow
end

--
--usb1CfgSave
--
function usb1CfgSave (configRow)
    
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "USB"
    local RowId = configRow["USB._ROWID_"]

    if (RowId == "-1") then
		configRow["USB.usbNum"] = "0"
		if (configRow["USB.USBStatus"] == "0") then configRow["USB.USBType"] = "4" end
	    errorFlag, statusCode = usb.usbConfig(configRow, RowId, "add")
	else
	    errorFlag, statusCode = usb.usbConfig(configRow, RowId, "edit")
	end

    if (errorFlag == "OK") then db.save() end

   	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    return errorFlag, statusMessage
end

--
--usb1CfgInputVal
--
function usb1CfgInputVal (configRow)
    
    if (configRow ["USB.USBStatus"] == "" or configRow ["USB.USBStatus"] == nil) then
    	printCLIError("Enter Valid Enable Value\n")
        return false
    end
    if (configRow ["USB.USBStatus"] == "1") then
        if (configRow ["USB.USBType"] == "" or configRow ["USB.USBType"] == nil) then
	        printCLIError("Enter Valid USB Type\n")
            return false
        end
    end
    return true
end

--
--usbCfgGet
--
function usbCfgGet (usbNumber)
    local configRow = {}
    if (usbNumber == "USB1") then
        configRow = db.getRow("USB", "usbNum", "0")
    elseif (usbNumber == "USB2") then
        configRow = db.getRow("USB", "usbNum", "1")
    end
	if (configRow == nil) then 
        print ( usbNumber.." is Not Enabled")
    else
        printLabel (usbNumber.." Configuration ")
        if (configRow ["USB.USBStatus"] == "0") then
            print ( usbNumber.." Status Disabled")
        elseif (configRow ["USB.USBStatus"] == "1") then
            print ( usbNumber.." Status Enabled")
        end
        if (configRow ["USB.USBType"] == "3") then
            print ( usbNumber.." Device Type : 3G USB Adapter")
        elseif (configRow ["USB.USBType"] == "4") then
            print ( usbNumber.." Device Type : USB Disc")
        end
    end
end

--
--usb2CfgInit
--
function usb2CfgInit (args)

    configRow = db.getRow("USB", "usbNum", "1")

	if (configRow == nil) then 
        configRow = {}
        configRow["USB._ROWID_"] = "-1"
    end

	configRowId = configRow["USB._ROWID_"]

    return configRowId, configRow
end

--
--usb2CfgSave
--
function usb2CfgSave (configRow)
    
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "USB"
    local RowId = configRow["USB._ROWID_"]

    if (RowId == "-1") then
		configRow["USB.usbNum"] = "1"
		if (configRow["USB.USBStatus"] == "0") then configRow["USB.USBType"] = "4" end
	    errorFlag, statusCode = usb.usbConfig(configRow, RowId, "add")
	else
	    errorFlag, statusCode = usb.usbConfig(configRow, RowId, "edit")
	end

    if (errorFlag == "OK") then db.save() end

   	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    return errorFlag, statusMessage
end

--
--usb2CfgInputVal
--
function usb2CfgInputVal (configRow)
    
    if (configRow ["USB.USBStatus"] == "" or configRow ["USB.USBStatus"] == nil) then
    	printCLIError("Enter Valid Enable Value\n")
        return false
    end
    if (configRow ["USB.USBStatus"] == "1") then
        if (configRow ["USB.USBType"] == "" or configRow ["USB.USBType"] == nil) then
	        printCLIError("Enter Valid USB Type\n")
            return false
        end
    end
    return true
end


