--[[
#### Adarsh Uppula
#### TeamF1
#### www.TeamF1.com
#### June 29, 2007

#### File: userdb.lua
#### Description: userdb functions

#### Revisions:
None
]]--


--************* Requires *************

--************* Initial Code *************

--package userdb
userdb = {}

--table packages
users = {}

--************* Functions *************

-- userdb config
function userdb.users_config (inputTable, rowid, operation)
	-- if not allowed to edit
	if (ACCESS_LEVEL ~= 0) then
		return "ACCESS_DENIED", "ADMIN_REQD"
	end
	db.beginTransaction() --begin transaction
	local valid = false
	
	-- config users
	rowid = db.getAttribute("users", "groupname", inputTable["users.groupname"], "_ROWID_")
	valid = users.config(inputTable, rowid, operation)
	
	-- return
	if (valid) then
		db.commitTransaction(true)
		return "OK", "STATUS_OK"
	else
		db.rollback()
		return "ERROR", "USERDB_CONFIG_FAILED"

	end
end

-- radius config
function users.config (inputTable, rowid, operation)
	-- validate
	if (users.inputvalidate(inputTable, operation)) then
		if (operation == "add") then
			return db.insert("users", inputTable)
		elseif (operation == "edit") then
			return db.update("users", inputTable, rowid)
		elseif (operation == "delete") then
			return db.delete("users", inputTable)
		end
	end
	return false
end

-- users inputvalidate
function users.inputvalidate (inputTable, operation)
	if (true) then
		local valid = db.typeAndRangeValidate(inputTable)
		if valid then
			-- if loginTimeout not given
			if (not inputTable["users.loginTimeout"]) then
				local correctOldPwd = db.getAttribute("users", "users.groupname", inputTable["users.groupname"], "password")
				if (inputTable["users.oldpassword"] ~= correctOldPwd) then
					return false
				end
			end
			return true
		else
			return false
		end
	end
	return false
end
