-- vipsecureCLI.lua
-- Samer Sayeed
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 08mar10,rac added/modifed the file to comply with the latest changes
-- 31jan09,ss  did modifications in ipsecVpnPolicyCfgInputVal() routine 
-- 29nov08,ss  written 
--
-- Description
-- CLI interface set and get routines
require "teamf1lualib/vipSecure"
require "teamf1lualib/ipSec"
require "teamf1lualib/dhcpOverIpSec"
function ipsecVpnPolicyCfgInit(args)
        local configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])
        local configRowIke={}
        local configRowVpn={}
        if (configRow == nil)then
                configRowIke = db.getDefaults(true, "IpsecIKEPolicy")
                configRowVpn = db.getDefaults(true, "IpsecIKEPolicy")
                configRowVpn["IpsecVPNPolicy.VPNPolicyName"]=args[1]
                configRowIke["IpsecVPNPolicy.VPNPolicyName"]=args[1]
                RowId="-1"
        else
                RowId=configRow["IpsecVPNPolicy._ROWID_"]
                local ikeName = db.getAttribute ("IpsecVPNPolicy","_ROWID_",RowId,"IKEPolicyName")
                configRowVpn = db.getRow("IpsecVPNPolicy", "_ROWID_", RowId)
                if(configRowVpn["IpsecVPNPolicy.PolicyType"] == "1") then
                        local ikeRowId = db.getAttribute ("IpsecIKEPolicy","IKEPolicyName",ikeName,"_ROWID_")
                        configRowIke = db.getRow("IpsecIKEPolicy", "_ROWID_", ikeRowId)
                                util.tableAppend(configRowVpn,configRowIke)
                else
                        configRowIke["test"] ="-1"
                end
                if(configRowVpn["IpsecVPNPolicy.PFSKeyGroup"] ~= "0") then
                        configRowVpn["IpsecVPNPolicy.PFSKeyGroup1"] = configRowVpn["IpsecVPNPolicy.PFSKeyGroup"]
                        configRowVpn["IpsecVPNPolicy.PFSKeyGroup"] = "1"
                else
                        configRowVpn["IpsecVPNPolicy.PFSKeyGroup1"] = "2"
                end
        end
                return 1,configRowVpn

end
function ipsecVpnPolicyCfgSave(configRow)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	errorFlag, statusCode =ipsec.ipsecPolicyConfig (configRow)
	-- save db if no error
	if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
	return errorFlag,statusMessage
   

end
function ipsecVpnPolicyCfgInputVal(configRow)
	local valid=true

	if (configRow["IpsecVPNPolicy.RemoteEndPoint"] == nil or configRow["IpsecVPNPolicy.RemoteEndPoint"] == "" or configRow["IpsecVPNPolicy.RemoteEndPoint"] == "0.0.0.0")then
		printCLIError("Invalid address. Plese specify valid  FQDN for remote end point")
		return false
	end

	if (configRow["IpsecVPNPolicy.TunnelOrTransport"] == "0" and configRow["IpsecVPNPolicy.Rollover"] == "1")then
			printCLIError("Cannot use transpor mode when dhcp is enabled setting back to Tunnel mode")
			return false
			
	end
	if (configRow["IpsecVPNPolicy.TunnelOrTransport"] == "1") then
		if (configRow["IpsecVPNPolicy.Rollover"] == "1" and configRow["IpsecVPNPolicy.PolicyType"] == "2")then
			printCLIError("DHCP cannot be enabled when using manual policy. Disabling it automatically")
			return false
		end	
	end
    	if (configRow["IpsecVPNPolicy.Rollover"] == "0")then
			valid=ipaddressValidate(configRow)
			if (valid == true) then
				return true
			else
				return false
			end
	end
	if (configRow["IpsecVPNPolicy.PolicyType"] == "2")then
		valid = spiValidate(configRow)
		valid = encryptAlgorithmValidate(configRow)
		valid=authAlgorithmValidate(configRow)
			if (valid == true) then
				return true
			else
				return false
			end
			
		return true

	else
		if (configRow["IpsecIKEPolicy.NatTraversal"] == "1" and (configRow["IpsecIKEPolicy.NatKeepAliveTime"] == nil or configRow["IpsecIKEPolicy.NatKeepAliveTime"] == "" or configRow["IpsecIKEPolicy.NatKeepAliveTime"] == "0"))then
		printCLIError("Enter valid nat_keepalive_frequecy")
		return false
		end
		if (configRow["IpsecIKEPolicy.LocalIdentifierType"] ~= "0" and (configRow["IpsecIKEPolicy.LocalIdentifier"] == nil or configRow["IpsecIKEPolicy.LocalIdentifier"] == ""))then
			printCLIError("Enter valid local indentifier")
			return false
		end
		if (configRow["IpsecIKEPolicy.RemoteIdentifierType"] ~= "0" and (configRow["IpsecIKEPolicy.RemoteIdentifier"] == nil or configRow["IpsecIKEPolicy.RemoteIdentifier"] == ""))then
			printCLIError("Enter valid remote indentifier")
			return false
		end
		if (configRow["IpsecIKEPolicy.AuthType"] == "0" and (configRow["IpsecIKEPolicy.Presharedkey"] == nil or configRow["IpsecIKEPolicy.Presharedkey"] == ""))then
			printCLIError("Enter valid preshared key")
			return false
		end 
		if (configRow["IpsecIKEPolicy.DPD"] == "1")then
			if (configRow["IpsecIKEPolicy.DPDDetectionPeriod"] == nil or configRow["IpsecIKEPolicy.DPDDetectionPeriod"] == "")then
				printCLIError("Enter valid detection period")
				return false
			end
			if (configRow["IpsecIKEPolicy.DPDFailureCount"] == nil or configRow["IpsecIKEPolicy.DPDFailureCount"] == "")then
				printCLIError("Enter valid reconnect failure count")
				return false
			end
		end
		if (configRow["IpsecIKEPolicy.XAUTHType"] == "1")then
			if (configRow["IpsecIKEPolicy.UserName"] == nil or configRow["IpsecIKEPolicy.UserName"] == "")then
				printCLIError("Enter valid xauth username")
				return false
			end
			if (configRow["IpsecIKEPolicy.Password"] == nil or configRow["IpsecIKEPolicy.Password"] == "")then
				printCLIError("Enter valid xauth password")
				return false
			end

		end
		if (configRow["IpsecIKEPolicy.SALifeTime"] == nil or configRow["IpsecVPNPolicy.SALifeTime"] == "")then
				printCLIError("Enter valid phase2 sa lifetime")
				return false
		end
		if (configRow["IpsecIKEPolicy.SALifeTime"] == nil or configRow["IpsecVPNPolicy.SALifeTime"] == "")then
				printCLIError("Enter valid phase1 sa lifetime")
				return false
		end
	end
	return true
end

function ipaddressValidate(configRow)
	if (configRow["IpsecVPNPolicy.LocalNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.LocalStartAddress"] == nil or configRow["IpsecVPNPolicy.LocalStartAddress"] == "" or configRow["IpsecVPNPolicy.LocalStartAddress"] == "0.0.0.0"))then
			printCLIError("Invalid local start ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "2" and (configRow["IpsecVPNPolicy.LocalEndAddress"] == nil or configRow["IpsecVPNPolicy.LocalEndAddress"] == "" or configRow["IpsecVPNPolicy.LocalEndAddress"] == "0.0.0.0"))then
			printCLIError("Invalid local end ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "3" and (configRow["IpsecVPNPolicy.LocalSubnetMask"] == nil or configRow["IpsecVPNPolicy.LocalSubnetMask"] == "" or configRow["IpsecVPNPolicy.LocalSubnetMask"] == "0.0.0.0"))then
			printCLIError("Invalid local net mask")	
			return false
		end
		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.RemoteStartAddress"] == nil or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "" or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "0.0.0.0"))then
			printCLIError("Invalid remote start ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] == "2" and (configRow["IpsecVPNPolicy.RemoteEndAddress"] == nil or configRow["IpsecVPNPolicy.RemoteEndAddress"] == "" or configRow["IpsecVPNPolicy.RemoteEndAddress"] == "0.0.0.0"))then
			printCLIError("Invalid remote end ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] == "3" and (configRow["IpsecVPNPolicy.RemoteSubnetMask"] == nil or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "" or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "0.0.0.0"))then
			printCLIError("Invalid remote net mask")	
			return false
		end
		if(configRow["IpsecVPNPolicy.Netbios"] == "1") then
			if (configRow["IpsecVPNPolicy.RemoteSubnetMask"] == nil or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "" or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "0.0.0.0")then
			printCLIError("Invalid remote net mask")	
			return false
			end
		        if (configRow["IpsecVPNPolicy.RemoteStartAddress"] == nil or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "" or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "0.0.0.0")then
			printCLIError("Invalid remote start ip address")	
			return false
			end	
		end
return true
end
function encryptAlgorithmValidate(configRow)
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] ~= "0")then
		if (configRow["IpsecVPNPolicy.EncryptionKeyIn"] == nil or configRow["IpsecVPNPolicy.EncryptionKeyIn"] == "")then
			printCLIError("Invalid key in for encryption algorithm")	
			return false
		end
		if (configRow["IpsecVPNPolicy.EncryptionKeyOut"] == nil or configRow["IpsecVPNPolicy.EncryptionKeyOut"] == "")then
			printCLIError("Invalid key out for encryption algorithm")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] ~= "6" or configRow["IpsecVPNPolicy.EncryptionAlgorithm"] ~= "7")then
		if (configRow["IpsecVPNPolicy.AuthKeyIn"] == nil or configRow["IpsecVPNPolicy.AuthKeyIn"] == "")then
			printCLIError("Invalid key in for integrity algorithm")	
			return false
		end
		if (configRow["IpsecVPNPolicy.AuthKeyOut"] == nil or configRow["IpsecVPNPolicy.AuthKeyOut"] == "")then
			printCLIError("Invalid key in for integrity algorithm")	
			return false
		end
	end	
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "2")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 24)then 
			printCLIError("Invalid key in length for 3DES encryption algorithm should be of length 24")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 24)then 
			printCLIError("Invalid key out length for 3DES encryption algorithm should be of length 24")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "1")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 8)then 
			printCLIError("Invalid key in length for DES encryption algorithm should be of length 8")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 8)then 
			printCLIError("Invalid key out length for DES encryption algorithm should be of length 8")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "3")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 16)then 
			printCLIError("Invalid key in length for AES-128 encryption algorithm should be of length 16")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 16)then 
			printCLIError("Invalid key out length for AES-128 encryption algorithm should be of length 16")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "4")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 24)then 
			printCLIError("Invalid key in length for AES-192 encryption algorithm should be of length 24")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 24)then 
			printCLIError("Invalid key out length for AES-192 encryption algorithm should be of length 24")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "5")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 32)then 
			printCLIError("Invalid key in length for AES-256 encryption algorithm should be of length 32")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 32)then 
			printCLIError("Invalid key out length for AES-256 encryption algorithm should be of length 32")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "6")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 16)then 
			printCLIError("Invalid key in length for AES-CCM encryption algorithm should be of length 16")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 16)then 
			printCLIError("Invalid key out length for AES-CCM encryption algorithm should be of length 16")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "7")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 20)then 
			printCLIError("Invalid key in length for AES-GCM encryption algorithm should be of length 20")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 20)then 
			printCLIError("Invalid key out length for AES-GCM encryption algorithm should be of length 20")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "8")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 16)then 
			printCLIError("Invalid key in length for TWOFISH (128) encryption algorithm should be of length 16")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 16)then 
			printCLIError("Invalid key out length for TWOFISH (128) encryption algorithm should be of length 16")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "9")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 24)then 
			printCLIError("Invalid key in length for TWOFISH (192) encryption algorithm should be of length 24")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 24)then 
			printCLIError("Invalid key out length for TWOFISH (192) encryption algorithm should be of length 24")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "10")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 32)then 
			printCLIError("Invalid key in length for TWOFISH (256) encryption algorithm should be of length 32")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 32)then 
			printCLIError("Invalid key out length for TWOFISH (256) encryption algorithm should be of length 32")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "11")then
		if (tonumber(configRow["IpsecVPNPolicy.KeyLength"]) < 40 and tonumber(configRow["IpsecVPNPolicy.KeyLength"]) > 448 and tonumber(configRow["IpsecVPNPolicy.KeyLength"])%8 ~= 0)then
			printCLIError("Key length for BLOWFISH algorithm should be in between 30 and 448 and multiples of 8")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key in length for BLOWFISH encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key out length for BLOWFISH encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "12")then
		if (tonumber(configRow["IpsecVPNPolicy.KeyLength"]) < 40 and tonumber(configRow["IpsecVPNPolicy.KeyLength"]) > 128 and tonumber(configRow["IpsecVPNPolicy.KeyLength"])%8 ~= 0)then
			printCLIError("Key length for BLOWFISH algorithm should be in between 30 and 128 and multiples of 8")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key in length for CAST128 encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key out length for CAST128 encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)	
			return false
		end
	end

	return true
end
function authAlgorithmValidate(configRow)
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "2")then

		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 20)then
			printCLIError("Invalid key in length for SHA-1 authentication should be of length 20")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 20)then
			printCLIError("Invalid key out length for SHA-1 authentication should be of length 20")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "6")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 24)then
			printCLIError("Invalid key in length for SHA2-224 authentication should be of length 24")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 24)then
			printCLIError("Invalid key out length for SHA2-224 authentication should be of length 24")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "3")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 32)then
			printCLIError("Invalid key in length for SHA2-256 authentication should be of length 32")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 32)then
			printCLIError("Invalid key out length for SHA2-256 authentication should be of length 32")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "4")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 48)then
			printCLIError("Invalid key in length for SHA2-384 authentication should be of length 48")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 48)then
			printCLIError("Invalid key out length for SHA2-384 authentication should be of length 48")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "5")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 64)then
			printCLIError("Invalid key in length for SHA2-512 authentication should be of length 64")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 64)then
			printCLIError("Invalid key out length for SHA2-512 authentication should be of length 64")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "1")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 16)then
			printCLIError("Invalid key in length for MD5 authentication should be of length 16")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 16)then
			printCLIError("Invalid key out length for MD5 authentication should be of length 16")
			return false
		end
	end
	return true
end
function spiValidate(configRow)
	if (configRow["IpsecVPNPolicy.SPIIn"] == nil or configRow["IpsecVPNPolicy.SPIIn"] == "")then
			printCLIError("Invalid spi_in value")	
			return false
	end
	if (string.len(configRow["IpsecVPNPolicy.SPIIn"]) > 15)then
			printCLIError("Invalid spi_in value length cannot be more than 13")	
			return false
	end
	if (configRow["IpsecVPNPolicy.SPIOut"] == nil or configRow["IpsecVPNPolicy.SPIOut"] == "")then
			printCLIError("Invalid spi_out value")	
			return false
	end
	if (string.len(configRow["IpsecVPNPolicy.SPIOut"]) > 15)then
			printCLIError("Invalid spi_out value length cannot be more than 13")	
			return false
	end
return true
end
function ipsecVpnPolicyEnable(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])

	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		    local rows = {}
    		    rows["rowid"] = configRow["IpsecVPNPolicy._ROWID_"]	
		    errorFlag, statusCode = vipSecure.ipsecVPNPolicyEnable(rows, true)
	end
        if (errorFlag == "OK") then db.save() end
        statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
	return errorFlag,statusMessage	
end
function ipsecVpnPolicyDisable(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])
	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		    local rows = {}
    		    rows["rowid"] = configRow["IpsecVPNPolicy._ROWID_"]	
		    errorFlag, statusCode = vipSecure.ipsecVPNPolicyEnable(rows, false)
	end
        if (errorFlag == "OK") then db.save() end
        statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
	return errorFlag,statusMessage	
end
function ipsecVpnPolicyDelete(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])
	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		    local rows = {}
    		    rows["rowid"] = configRow["IpsecVPNPolicy._ROWID_"]	
		    errorFlag, statusCode = vipSecure.ikeDeletePolicy (rows)
		if(errorFlag == "OK") then        
        	errorFlag, statusCode = vipSecure.ipsecVPNPolicyDelete(rows)
		end
		if (errorFlag == "OK") then
			db.commitTransaction(true) 
			db.save()						 
		end
		statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
	end
	return errorFlag,statusMessage
end
function ipsecVpnPolicyGet()
local resultTab = {}
local i=0
	local table = db.getTable("IpsecVPNPolicy")
	for k,v in pairs(table) do
		i = i + 1
		local row = table[i]
		local status
		if (row["IpsecVPNPolicy.Status"] == "0")then
			status = "Enabled"
		else
			status="Disabled"
		end
		resTab.insertField (resultTab,"Status",status)
		resTab.insertField (resultTab,"Name",row["IpsecVPNPolicy.VPNPolicyName"])
		local PolicyType = ""
		if(row["IpsecVPNPolicy.PolicyType"] == "1") then
	  		PolicyType = "Auto Policy"
		elseif(row["IpsecVPNPolicy.PolicyType"] == "2") then
			PolicyType = "Manual Policy"
		end
		resTab.insertField (resultTab,"Type",PolicyType)
		local IpsecMode = ""
		if(row["IpsecVPNPolicy.TunnelOrTransport"] == "0") then
			IpsecMode = "Transport Mode"
		elseif(row["IpsecVPNPolicy.TunnelOrTransport"] == "1") then
			IpsecMode = "Tunnel Mode"
		end
		resTab.insertField (resultTab,"IPSec Mode",IpsecMode)
		if(row["IpsecVPNPolicy.LocalNetworkType"] == "0") then
			Localtype = "Any"
		elseif(row["IpsecVPNPolicy.LocalNetworkType"] == "1") then
			Localtype = row["IpsecVPNPolicy.LocalStartAddress"]
		elseif(row["IpsecVPNPolicy.LocalNetworkType"] == "2") then
    	      		Localtype = row["IpsecVPNPolicy.LocalStartAddress"]  ..  " - " .. row["IpsecVPNPolicy.LocalEndAddress"]
		elseif(row["IpsecVPNPolicy.LocalNetworkType"] == "3") then
               		Localtype = row["IpsecVPNPolicy.LocalStartAddress"] .. " / " .. row["IpsecVPNPolicy.LocalSubnetMask"]
		end
		resTab.insertField (resultTab,"Local",Localtype)
		local Remotetype = ""
        	if(row["IpsecVPNPolicy.RemoteNetworkType"] == "0") then
             	 	Remotetype = "Any"
        	elseif(row["IpsecVPNPolicy.RemoteNetworkType"] == "1") then
               		Remotetype = row["IpsecVPNPolicy.RemoteStartAddress"]
        	elseif(row["IpsecVPNPolicy.RemoteNetworkType"] == "2") then
              	 	Remotetype = row["IpsecVPNPolicy.RemoteStartAddress"]  ..  " - " .. row["IpsecVPNPolicy.RemoteEndAddress"]
        	elseif(row["IpsecVPNPolicy.RemoteNetworkType"] == "3") then
              	 	Remotetype = row["IpsecVPNPolicy.RemoteStartAddress"] .. " / " .. row["IpsecVPNPolicy.RemoteSubnetMask"]
		end
		resTab.insertField (resultTab,"Remote",Remotetype)
		local AuthType = ""
	       	if(row["IpsecVPNPolicy.AuthAlgorithm"] == "6") then
			AuthType = "SHA2-224"
        	elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "7") then
	       		AuthType = "NONE"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "2") then
	               	AuthType = "SHA-1"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "1") then
	               	AuthType = "MD5"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "3") then
	               	AuthType = "SHA2-256"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "4") then
	               	AuthType = "SHA2-384"
		elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "5") then
	               	AuthType = "SHA2-512"
		end
		resTab.insertField (resultTab,"Auth",AuthType)
		local EncrType = ""
	       	if(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "0") then
	               	EncrType = "None"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "1") then
	               	EncrType = "DES"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "2") then
	               	EncrType = "3DES"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "3") then
	               	EncrType = "AES-128"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "4") then
	               	EncrType = "AES-192"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "5") then
	               	EncrType = "AES-256"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "6") then
	               	EncrType = "AES-CCM"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "7") then
	               	EncrType = "AES-GCM"
	        elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "8") then
	              	EncrType = "TWOFISH (128)"
	        elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "9") then
	              	EncrType = "TWOFISH (192)"
	        elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "10") then
	              	EncrType = "TWOFISH (256)"
		elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "11") then
	               	EncrType = "BLOWFISH"
		elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "12") then
	               	EncrType = "CAST128"
		end
		resTab.insertField (resultTab,"Encr",EncrType)
   	end
resTab.print (resultTab, 0)
end

function ipsecVpnDhcpCfgInit(args)
configRow = db.getRow("IPsecDhcpClientIPRange", "IPsecDhcpClientIPRange._ROWID_", "1")
return 1,configRow
end
function ipsecVpnDhcpCfgSave(configRow)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	DBTable="IPsecDhcpClientIPRange"	
	errorFlag, statusCode = dhcpOverIpsec.config(configRow,"1", "edit")
	if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
	return errorFlag,statusMessage	
end
function ipsecVpnDhcpCfgInputVal(confgRow)
	if (configRow["IPsecDhcpClientIPRange.StartIPAddress"] == nil or configRow["IPsecDhcpClientIPRange.StartIPAddress"] == "" or configRow["IPsecDhcpClientIPRange.StartIPAddress"] == "0.0.0.0")then
		printCLIError("Enter valid start address")
		return false
	end
	if (configRow["IPsecDhcpClientIPRange.EndIPAddress"] == nil or configRow["IPsecDhcpClientIPRange.EndIPAddress"] == "" or configRow["IPsecDhcpClientIPRange.EndIPAddress"] == "0.0.0.0")then
		printCLIError("Enter valid end address")
		return false
	end
	if (configRow["IPsecDhcpClientIPRange.SubnetMask"] == nil or configRow["IPsecDhcpClientIPRange.SubnetMask"] == "" or configRow["IPsecDhcpClientIPRange.SubnetMask"] == "0.0.0.0")then
		printCLIError("Enter valid subnet mask")
		return false
	end
end
function ipsecVpnDhcpGet()
configRow = db.getRow("IPsecDhcpClientIPRange", "IPsecDhcpClientIPRange._ROWID_", "1")
printLabel("IP Range For DHCP Over IPsec")
print("Starting IP Address:",configRow["IPsecDhcpClientIPRange.StartIPAddress"])
print("Ending IP Address:",configRow["IPsecDhcpClientIPRange.EndIPAddress"])
print("Subnet Mask:",configRow["IPsecDhcpClientIPRange.SubnetMask"])
end
