-- vpnpassthroughCLI.lua
-- Neelima
-- TeamF1
-- 23/09/08
-- 
-- Modification History
-- 27dec08,ss   did modifications for rmi
-- 23sep08,nlm, written
--
-- Description
-- CLISH VPN passthrough LUA routines
--
-- Required Libraries
require "teamf1lualib/fwView"


-- This function displays the current NAT configuration
function vpnPassthroughInfoGet (args)
    local resultTab = {}
    printLabel ("Passthrough")
    row = db.getRow("AttackChecks", "AttackChecks._ROWID_",1)
--  The AttackChecks table should have only one entry
    print( "IPSec VPN Passthrough:")
    print( "                      ")
    
    if (row["AttackChecks.IpsecPassthrough"] == "0") then
       print( " IPSec Passthrough : Disabled")
    else
       print( " IPSec Passthrough : Enabled")
    end 
    if (row["AttackChecks.PptpPassthrough"] == "0") then
       print( " PPTP Passthrough  : Disabled")
    else
       print( " PPTP Passthrough  : Enabled")
    end 
    if (row["AttackChecks.L2tpPassthrough"] == "0") then
       print( " L2TP Passthrough  : Disabled")
    else
       print( " L2TP Passthrough  : Enabled")
    end 
end

-- This function saves the modified VPN passthrough Information
function vpnpassthroughCfgSave(configRow)
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "AttackChecks"
  
    errorFlag, statusMessage = fwView.attackChecksConfig(configRow, 1, "edit")
    if (errorFlag == "OK") then
        db.save()
    end
    return errorFlag, statusMessage
end

-- This routine reads in the current VPN Passthrough information into a configuration object
function vpnpassthroughCfgInit(args)
    local rowId = 1
    local configRow = db.getRow("AttackChecks","_ROWID_",rowId)

    if configRow == nil then
        return rowId, {}
    end
    rowId = configRow["AttackChecks._ROWID_"]
    return rowId, configRow
end

