--[[
#### TeamF1
#### www.TeamF1.com
#### Aug 21, 2007

#### File: dbglog.lua
#### Description: dbglog handler for lua pages.

#### Revisions:
01a,21Aug'07, nsr written
]]--

-- requires -- 
require "teamf1lualib/db"
require "teamf1lualib/web"

-- variables -- 
filename     ="dbglog.tgz";
DBGLOG_FILE  ="/var/dbglog.tgz";

-- update dbglog file name using system name --
local name     = db.getAttribute("system", "_ROWID_", "1", "name");
local filename = name .. "-" .. filename;

-- tar the conf. files --
os.execute   ("ps w >/tmp/ps.output ");

-- network state --
os.execute   ("route -n >/tmp/route.output ");
os.execute   ("ifconfig -a >/tmp/ifconfig.output ");
os.execute   ("netstat -n >/tmp/netstat.output ");

--Ipsec state--
os.execute   ("setkey -DP >/tmp/ipsecSP.output ");
os.execute   ("setkey -Da >/tmp/ipsecSA.output ");

-- Firewall, NAT and misc logs --
os.execute   ("iptables -L -v -n > /tmp/iptables.log ");
os.execute   ("iptables -t nat -L -v -n > /tmp/nat.log ");
os.execute   ("iptables -t mangle -L -v -n > /tmp/mangle.log ");

-- arp
os.execute   ("cat /proc/net/stat/arp_cache > /tmp/arp.log ");
os.execute   ("cat /proc/net/arp >> /tmp/arp.log ");

os.execute   ("cd /tmp && cp /proc/kallsyms .");
os.execute   ("cd /tmp && tar -czvf " .. DBGLOG_FILE .. " * /var/*");

-- send the tarred file back to agent --
web.download (DBGLOG_FILE, filename);

-- delete the temp tar file created -- 
os.execute   ("rm -rf ".. DBGLOG_FILE .. "");
