/*
Copyright (c) 2009 TeamF1, Inc.
All rights reserved.
*/

var noDSTCountries = [
"Eniwetok",
"Midway Island",
"Hawaii",
"Marquesas Is.",
"Pitcairn Is.",
"Caracas",
"Mid-Atlantic",
"Baghdad",
"Abu Dhabi",
"Kabul",
"Bombay",
"Almaty",
"Burma",
"Bangkok",
"Beijing",
"Osaka",
"Brisbane",
"Norfolk Island (Kingston)",
"Tonga",
"Kiribati"
];

function timeZoneValidate ()
    {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtCustomNtp1,Please enter a valid Primary NTP Server Name/IP Address";
    txtFieldIdArr[1] = "txtCustomNtp2,Please enter a valid Secondary NTP Server Name/IP Address";
    txtFieldIdArr[2] = "txtYear,Please enter a valid Year";
    txtFieldIdArr[3] = "txtMonth,Please enter a valid Month";
    txtFieldIdArr[4] = "txtDate,Please enter a valid Date";
    txtFieldIdArr[5] = "txtHr,Please enter a valid Hours";
    txtFieldIdArr[6] = "txtMin,Please enter a valid Minutes";
    txtFieldIdArr[7] = "txtSec,Please enter a valid Seconds";
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
         return false;
         
    if (ipaddrValidate ('txtCustomNtp1') == false)
    	return false;
    	
    if (ipaddrValidate ('txtCustomNtp2') == false)
    	return false;
    	  	       
	var yearObj = document.getElementById("txtYear");
	if (!yearObj.disabled)
		{	
		if(!numericValueRangeCheck(yearObj, '', '', 1970, 2037, true, 'Invalid Year:', '') || !yearCheck(yearObj))
			return false;
		var monthObj = document.getElementById("txtMonth");
		if(!numericValueRangeCheck(monthObj, '', '', 1, 12, true, 'Invalid Month:', '') || !dateCheck(monthObj))
			return false;
		var dateObj = document.getElementById("txtDate");
		if(!numericValueRangeCheck(dateObj, '', '', 1, 31, true, 'Invalid Day:', '') || !dateCheck(dateObj) || !dayCheck(dateObj, 'txtMonth', 'txtYear'))
			return false;
		var hoursObj = document.getElementById("txtHr");
		if(!numericValueRangeCheck(hoursObj, '', '', 0, 23, true, 'Invalid Hours:', '') || !dateCheck(hoursObj))
			return false;
		var minObj = document.getElementById("txtMin");
		if(!numericValueRangeCheck(minObj, '', '', 0, 59, true, 'Invalid Minutes:', '') || !dateCheck(minObj))
			return false;
		var secObj = document.getElementById("txtSec");
		if(!numericValueRangeCheck(secObj, '', '', 0, 59, true, 'Invalid Seconds:', '') || !dateCheck(secObj))
			return false;
		}

    return true;
    }
    
function ntpConfigTypeCheck ()
	{
	var selValue = radioCheckedValueGet ('ntp.enabled');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 1:	/* Use NTP server */
			fieldStateChangeWr ('', 'tblBeforeDate1', '', 'tblNTPSvrs');
			NtpSvrTypeCheck ();
			break;
		case 0:	/* Manual Time Setting */
			fieldStateChangeWr ('', 'tblNTPSvrs', '', 'tblBeforeDate1');
			break;
		}
	}
	
function NtpSvrTypeCheck ()
	{
	var selValue = radioCheckedValueGet ('ntp.useDefServers');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 1:	/* Use Default NTP server */
			fieldStateChangeWr ('txtCustomNtp1 txtCustomNtp2', '', '', '');
			break;
		case 0:	/* Use Custom NTP server */
			fieldStateChangeWr ('', '', 'txtCustomNtp1 txtCustomNtp2', '');
			break;
		}
	}

function timeZoneInit ()
	{
	ntpConfigTypeCheck ();
	timezoneCheck();
	}
	
function timezoneCheck()
	{
	var selTimezone = document.getElementById('selTimezone');
	var timezone = selTimezone.options[selTimezone.selectedIndex].text;
	if(!timezone) return;
	var len = noDSTCountries.length;
	for(var i=0; i<len; ++i)
		{
		if(timezone.indexOf(noDSTCountries[i]) != -1)
			{
			fieldStateChangeWr('chkAutoDaylight','','','');
			return;
			}
		}
	fieldStateChangeWr('','','chkAutoDaylight','');
	}

// Months and Day Format Validation
function dayCheck(srcObj, mnthId, yearObjId)
	{
    var day = parseInt (srcObj.value, 10);
    var month = parseInt (document.getElementById(mnthId).value, 10);
    if (month == 2) 
    	{
    	if (document.getElementById(yearObjId).value != "" && !isNaN(document.getElementById(yearObjId).value))
    		{
			if (isLeapYear (parseInt (document.getElementById(yearObjId).value, 10)) && day > 29)
				{
			    alert ("Invalid: Day should be in range of (1 - 29) for the Month '2' (February) in a Leap Year");
			    srcObj.focus();
			    return false;
				}
			else if (!isLeapYear (parseInt (document.getElementById(yearObjId).value, 10)) && day > 28) {
			    alert ("Invalid: Day should be in range of (1 - 28) for the Month '2' (February)");
			    srcObj.focus();
			    return false;		
				}
			}
		else if (day > 28)
			{
		    alert ("Invalid: Day should be in range of (1 - 28) for the Month '2' (February)");
		    srcObj.focus();
		    return false;		
			}	
		}
	if ((month==4)||(month==6)||(month==9)||(month==11))
		{
		if (day > 30) 
			{ 
		    alert ("Invalid: Day should be in range of (1 - 30) for Months April, June, September, November");
		    srcObj.focus();
		    return false; 
			}
		}
    return true;
	}

// Days Months Hours and Mins Digit Format Validation
function dateCheck(srcObj)
	{
	if (!srcObj) return false;
	if (srcObj.value.length < 2)
		{
		alert ("Please enter it in 2 digit Format : 01");
		srcObj.focus();
		return false;
		}
	return true;
	}

// leap year and Format Validation
function yearCheck(srcObj)
	{
	if (!srcObj) return false;
	if (srcObj.value.length < 4)
		{
		alert ("Please enter in 4 digits Format: 2010");
		srcObj.focus();
		return false;
		}
	return true;
	}

// leap year and Format Validation
function isLeapYear (year)
	{
    if (( (year%4==0)&&(year%100 != 0) ) || (year%400==0)) 
	   return true;
	return false;
	}
	
function ipaddrValidate (ipAddr)
    {   
	if (checkHostName (ipAddr, true, 'Invalid IP Address/Domain name: ', false) == false) 
		return false; 
	return true;  
    }

