/*
Copyright (c) 2009 TeamF1, Inc.
All rights reserved.
*/

var prevDirection = 0;
var prevMode = 0;
var url = "";
function IkePolInitialSettingsWrap ()
    {
    IkePolInitialSettings ();
    authTypeChcek ();
    enableKeepAlive();
    dpdStatusCheckWrap ();
    xauthStatusCheckWrap();
    }
function IkePolInitialSettings ()
	{
    prevDirection = comboSelectedValueGet ('selDirection');
    prevMode = comboSelectedValueGet ('selExchangeType');
	localIdentTypeCheck ();
	remoteIdentTypeCheck ();
    return;
  	}
function authTypeChcek ()
    {
    var selValue = comboSelectedValueGet ('selAuthType');
    if (!selValue) return;
    switch (parseInt (selValue, 10)) 
   		{
	  	case 0: /* Pre-Shared key */
	  		fieldStateChangeWr ('','','txtPresharedKey','');
	  		break;
	  	case 1: /* RSA Signature */
	  		fieldStateChangeWr ('txtPresharedKey','','','');
	  		break;
	  	}
    }
function enableKeepAlive(){
	var natObj=document.getElementById('rdbNat1');				
	if(natObj.checked){		
			fieldStateChangeWr ('','','txtNatKeepAlive','');
	}
	else{		
		fieldStateChangeWr ('txtNatKeepAlive','','','');
			
	}	
}
function dpdStatusCheckWrap ()
  {
	depFieldCheck ('chkDPDEnable', true, '', '', 'txtReconnectCount txtDetectionPeriod', '');
	depFieldCheck ('chkDPDEnable', false, 'txtReconnectCount txtDetectionPeriod', '', '', '');
  }
function xauthStatusCheckWrap ()
	{
	var selValue = comboSelectedValueGet ('selXAuthType');
    if (!selValue) return;
    xauthStatusCheck (parseInt (selValue, 10));
    }
function DPDCheck ()
	{
	obj = document.getElementById('txtDetectionPeriod');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid Detection Period - Please enter a value between 10-999",
                            10, 999, true, "Invalid Detection Period -", "") == false)
	return false; 

	obj = document.getElementById('txtReconnectCount');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid Reconnect after failure count - Please enter a value between 3-99",
                            3, 99, true, "Invalid Reconnect after failure count -", "") == false)
	return false; 

	}
function xauthStatusCheck (xauthStatus)
	{
	if (xauthStatus == null) return;
	switch (xauthStatus)
		{
		case 0: /* None */
			fieldStateChangeWr ('selXAuthType1 txtxAuthConfigUserName txtxAuthConfigPasswd','','','');
			break;
		case 2: /* Edge device */		
			fieldStateChangeWr ('txtxAuthConfigUserName txtxAuthConfigPasswd','','selXAuthType1','');
			break;
		case 1: /* IPSEC Host */
			fieldStateChangeWr ('selXAuthType1','','txtxAuthConfigUserName txtxAuthConfigPasswd','');
			break; 
		}
	}

function localIdentTypeCheck ()
	{
	var selValue = comboSelectedValueGet ('selLocalIdentifier');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
		case 0:	/* LOCAL ID */
            fieldStateChangeWr ('txtAddIkeLocId', '', '', '');
            break;
		default:
			fieldStateChangeWr ('', '', 'txtAddIkeLocId', '');
			break;
		}
	return;
	}

function remoteIdentTypeCheck ()
	{
	var selValue = comboSelectedValueGet ('selRemoteIdentifier');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
		case 0:	/* REMOTE ID */
			fieldStateChangeWr ('txtAddIkePeerID', '', '', '');
            break;
		default:
			fieldStateChangeWr ('', '', 'txtAddIkePeerID', '');
			break;
		}
	return;
	}

function ikePolValidate ()
    {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtAddIkePolName,Please enter a name for the IKE policy";
    txtFieldIdArr[1] = "txtAddIkeLocId,Please enter a valid local identifier";
    txtFieldIdArr[2] = "txtAddIkePeerID,Please enter a valid peer identifier";
    txtFieldIdArr[3] = "txtPresharedKey,Please enter the pre-shared key for this connection";
    txtFieldIdArr[4] = "txtToken,Please enter the Token value for this connection";
    txtFieldIdArr[5] = "txtTokenPass,Please enter the Password for this connection";
    txtFieldIdArr[6] = "txtAddIkePolLifeTime,Please enter the life-time in seconds for the security association created by this policy";
    txtFieldIdArr[7] = "txtxAuthConfigUserName,Please enter a valid XAUTH user name";
    txtFieldIdArr[8] = "txtxAuthConfigPasswd,Please enter a valid XAUTH password";
    txtFieldIdArr[9] = ",Please enter a valid NAT keep alive frequency.";
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
         return false;

	if (validateFQDN ('txtAddIkeLocId') == false)
         return false;

	if (validateFQDN ('txtAddIkePeerID') == false)
         return false;

    var result = false;
    result = fieldLengthCheck ('txtPresharedKey', 8, 49,
                               'Invalid pre-shared key: Please enter key with length between 8 - 49 characters');   
    if (result == false)
        return false;

	obj = document.getElementById('txtDetectionPeriod');
	if (numericValueRangeCheck (obj , '', '', 10, 999, true, '', '') == false)
	return false; 

	obj = document.getElementById('txtReconnectCount');
	if (numericValueRangeCheck (obj , '', '', 3, 99, true, '', '') == false)
	return false; 

    /* enable dependent stuff if modeconfig is enabled */
    var exchTypeObj = document.getElementById('selExchangeType');
    if (!exchTypeObj) return;
	 {
        var objIdArr = new Array ();
        objIdArr[0] = 'selExchangeType';
        objIdArr[1] = 'selLocalIdentifier';
        objIdArr[2] = 'selRemoteIdentifier';
        objIdArr[3] = 'selDirection';
        for (var i = 0; i < objIdArr.length; ++i)
            {
            var obj = document.getElementById(objIdArr[i]);
            if (obj)
                 obj.disabled = false;
            }
        }
        
	var localObj = document.getElementById('selLocalIdentifier');
	var remoteObj = document.getElementById('selRemoteIdentifier');
	var errStr = "User FQDN is only for Aggressive mode";
	if (!exchTypeObj) return;
	else 
		{
		if(localObj.value == 2 && exchTypeObj.value == 0)
			{
			alert(errStr);
			localObj.focus ();
			return false;
			}
		if(remoteObj.value == 2 && exchTypeObj.value == 0)
			{
			alert(errStr);
			remoteObj.focus ();
			return false;
			}		
					
		}
		var natKeepAliveObj = document.getElementById('txtNatKeepAlive');
		if(natKeepAliveObj && !natKeepAliveObj.disabled){ 
			var natKeepAliveObjVal= parseInt(natKeepAliveObj.value,10);
			if(!isNaN(natKeepAliveObjVal)){
				if(natKeepAliveObjVal==0){
					var opt = confirm("Keep Alive Frequency value of 0 disables the 'Keep Alive' feature. Are you sure you want to proceed?");
					if(!opt) return false;
				}
			}
			else{
				alert("Enter a proper value for NAT Keep Alive Frequency.");
				natKeepAliveObj.focus();
				return false;
			}
		}		    
    return true;
    }
