/*
Copyright (c) 2009 TeamF1, Inc.
All rights reserved.
*/

function ipAddrOctetCheck (ipObjArr)
	{
	for (var i = 0; i < ipObjArr.length; i++)
		{
		var octet = ipObjArr[i];
		if (octet == "" || isNaN (octet))
			return false;
		if (i == 0)
			{
			if (parseInt (octet, 10) < 1 || parseInt (octet, 10) > 223)
				return false;
			}
		else if (i == 3)
			{
			if (parseInt (octet, 10) < 0 || parseInt (octet, 10) > 254)
				return false;
			}
		else
			{
			if (parseInt (octet, 10) < 0 || parseInt (octet, 10) > 255)
				return false;
			}		
		}
	return true;
	}

function ipSnetMaskOctetCheck (snetMaskObjArr)
	{
	for (var i = 0; i < snetMaskObjArr.length; i++)
		{
		var octet = snetMaskObjArr[i];
		if (octet == "" || isNaN (octet))
			{
			alert("Please enter valid value for octate " + (i + 1));
			return false;
			}
		if ((parseInt (octet, 10) < 0) || (parseInt (octet, 10) > 255))
			{
			alert("Please enter valid value for octate " + (i + 1));
			return false;
			}
		}
	return true;
	}

function ipAddrFormatCheck (ipAddrId)
	{
    if (!ipAddrId) return false;
    var ipObj = document.getElementById(ipAddrId);
    if (!ipObj || ipObj.disabled) return false;
    var ipObjArr = ipObj.value.split (".")
    if (ipObjArr.length != 4) return false;
	/* Check IP Address Octet Range */
	if (ipAddrOctetCheck (ipObjArr) == false)
		return false;
	return true;
	}

function ipAddrValueFormatCheck (ipAddr)
	{
    if (!ipAddr) return false;
    var ipObjArr = ipAddr.split (".")
    if (ipObjArr.length != 4) return false;
	/* Check IP Address Octet Range */
	if (ipAddrOctetCheck (ipObjArr) == false)
		return false;
	return true;
	}

function ipSnetMaskFormatCheck (ipSnetMaskId)
	{
    if (!ipSnetMaskId) return false;
    var snetMaskObj = document.getElementById(ipSnetMaskId);
    if (!snetMaskObj || snetMaskObj.disabled) return false;
    var snetMaskObjArr = snetMaskObj.value.split (".")
    if (snetMaskObjArr.length != 4) 
    	{
    	alert("Please enter valid number of octates.");
    	return false;
    	}
	/* Check IP Address Octet Range */
	if (ipSnetMaskOctetCheck (snetMaskObjArr) == false)
		return false;
	return true;
	}

/* IP Address Range Validate */
function ipRangeValidate (ipAddrStartId, ipAddrEndId)
	{
	var errorFlag = false;	
    if (!ipAddrStartId || !ipAddrEndId) return true;
    var startIpObj = document.getElementById(ipAddrStartId);
    var endIpObj = document.getElementById(ipAddrEndId);
    if (!startIpObj || !endIpObj) return true;
    if (startIpObj.disabled || endIpObj.disabled) return true;    
    var startObjArr = startIpObj.value.split (".")
    var endObjArr = endIpObj.value.split (".");
    if (startObjArr.length != 4 || endObjArr.length != 4) return true;
	
	/* Check IP Address Octet Range */
	if (ipAddrOctetCheck (startObjArr) == false)
		return true;
	if (ipAddrOctetCheck (endObjArr) == false)
		return true;
		
	/* Checking First Octet */
   	var startIpOctet = parseInt (startObjArr[0], 10);
   	var endIpOctet = parseInt (endObjArr[0], 10);
   	if (startIpOctet > endIpOctet)
   		errorFlag = true;
   	else if (startIpOctet == endIpOctet)
		{
   		startIpOctet = parseInt (startObjArr[1], 10);
   		endIpOctet = parseInt (endObjArr[1], 10);
        /* Checking Second Octet */
	   	if (startIpOctet > endIpOctet)
	   		errorFlag = true;
	   	else if (startIpOctet == endIpOctet)
			{
	   		startIpOctet = parseInt (startObjArr[2], 10);
	   		endIpOctet = parseInt (endObjArr[2], 10);
            /* Checking Third Octet */
		   	if (startIpOctet > endIpOctet)
		   		errorFlag = true;
		   	else if (startIpOctet == endIpOctet)
				{
		   		startIpOctet = parseInt (startObjArr[3], 10);
		   		endIpOctet = parseInt (endObjArr[3], 10);
                /* Checking Fourth Octet */
			   	if (startIpOctet > endIpOctet)
			   		errorFlag = true;
				}   					
			}   		
		}
		
	if (errorFlag)
		{
		var errorStr = "End IP address must greater than or equal to the start IP address";		
		if (document.getElementById(ipAddrEndId + "Err"))
			document.getElementById(ipAddrEndId + "Err").innerHTML = errorStr
		else
			alert (errorStr)
		endIpObj.focus ();
		return false;
		}
	if (document.getElementById(ipAddrEndId + "Err"))
		document.getElementById(ipAddrEndId + "Err").innerHTML = ""
	return true;
	}
	

/* Converts IP string to an int */
function convert_addr(ipchars) {
    var bytes = ipchars.split('.');
    var result = ((bytes[0] & 0xff) << 24) |
                 ((bytes[1] & 0xff) << 16) |
                 ((bytes[2] & 0xff) <<  8) |
                  (bytes[3] & 0xff);
    return result;
}

/* Converts IP string to an int */
function getIPInt(tblName) {
    var obj = document.getElementById(tblName);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    octet0 =  objArr[0].value;
    octet1 =  objArr[1].value;
    octet2 =  objArr[2].value;
    octet3 =  objArr[3].value  ;

    var result = ((octet0 & 0xff) << 24) |
                 ((octet1 & 0xff) << 16) |
                 ((octet2 & 0xff) <<  8) |
                  (octet3 & 0xff);
    return result;
}

function getIPInt1(srcObjId) {
    if (!srcObjId) return false;
    var obj = document.getElementById(srcObjId);
    if (!obj) return false;
    var ipaddr = obj.value;
    var objArr = ipaddr.split (".");
    if (!objArr.length) return false;
    octet0 =  objArr[0];
    octet1 =  objArr[1];
    octet2 =  objArr[2];
    octet3 =  objArr[3];
    var result = ((octet0 & 0xff) << 24) |
                 ((octet1 & 0xff) << 16) |
                 ((octet2 & 0xff) <<  8) |
                  (octet3 & 0xff);
    return result;
}

/*
 * Compares two IPs and returns
 *  +ve number if Ip1 > IP2,
 *  0 if they are equal
 *  -ve number if IP1 < IP2.
 */

function compareIP(ip1Int, ip2Int) {
    if (ip1Int > ip2Int) return 1;
    if (ip1Int < ip2Int) return -1;
    return 0;
}

function compareIPRange(ip1Int, ip2Int) {
    if ((ip2Int - ip1Int) <= 254) return 1;
    return 0;
}

/* Check an IP (host) falls in a subnet */
function isInSubnet(host, pattern, mask) {
    return (((host & mask) == (pattern & mask)) && !isBroadcastIP(host, pattern, mask)); }

/* Check if an IP (host) is a broadcast IP */
function isBroadcastIP(host, pattern, mask) {
	return ((pattern | ~mask) == host)
}

/*
 * checks if an IP address is in a network.
 * params: ipaddr => IP to be checked (string)
 *         pattern => IP address pattern
 *       maskstr => Subnet mask
 */

function isInSubnetStr(ipaddr, pattern, maskstr) {
    var test = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/(ipaddr);
    if (test == null) {
        ipaddr = 'null'; /* dnsResolve(ipaddr);*/ /*prasanna*/
        if (ipaddr == 'null')
            return false;
    } else if (test[1] > 255 || test[2] > 255 ||
               test[3] > 255 || test[4] > 255) {
        return false;    // not an IP address
    }
    var host = convert_addr(ipaddr);
    var pat  = convert_addr(pattern);
    var mask = convert_addr(maskstr);
    return ((host & mask) == (pat & mask)); }

/* Gets IP address string by cat'ing the 4 octets  */
function getIPStr(tblName)
	{
    var obj = document.getElementById(tblName);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    return '' + objArr[0].value + '.' +
                objArr[1].value + '.' +
                objArr[2].value + '.' +
                objArr[3].value  ;
	}

function getIPStr1(srcObjId)
	{
    if (!srcObjId) return false;
    var obj = document.getElementById(srcObjId);
    if (!obj) return false;
    return obj.value;
	}

var subnetOctets = [0, 128, 192, 224, 240, 248, 252, 254, 255];
function checkSnetMask (snetMaskOctet, stIdx, endIdx)
	{
	if (isNaN (snetMaskOctet)) return true;
	var errorFlag = false;
	for (var i = stIdx; i <= endIdx; i++)
		{
		if (parseInt (snetMaskOctet,10) == subnetOctets[i])
			{
			errorFlag = true;
			break;
			}
		}
	return errorFlag;
	}

/* Validating IP Address */
function ipv4AddrValuesCheck
    (obj, objArr, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
    {
    var ipOctetMinVal = 0;
    var ipOctetMaxVal = 255;
    var isFirstByteZero = false;
    var isError = false;
    var ipOctetSpecified = false;
    var errMsg = '';
   	var tblIPAddrId = obj.id;

    for (var i = 0; i < objArr.length; i++)
         {
         ipOctetMinVal = 0;
         ipOctetMaxVal = 255;
         isError = false;
         var value = objArr[i];
         var errMsg = '';
         
         if (value.length != (parseInt (value)+"").length)
            {
            if (prefixStr) errMsg = prefixStr;
            errMsg += " remove leading 0's for octet " + (i + 1);
			if (document.getElementById(tblIPAddrId+"Err"))
				document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
			else
				alert (errMsg);
            return false;
            }
         if (alertFlag)
             {
             if (prefixStr) errMsg = prefixStr;
             if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) == 1))
                 errMsg += " Please enter 255 ";
             else if ((ipv4AddrTypeStr == 'SM') && ((i+1) == 4))
                 {
                 if (objArr[i-1] != "255")
                     errMsg += " Please enter 0 ";
                 else
                     errMsg += " Please enter 0/128/192/224/240/248/252 ";
                 }
             else if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) > 1))
                 {
                 if (objArr[i-1] != "255")
                     errMsg += " Please enter 0 ";
                 else
                     errMsg += " Please enter 0/128/192/224/240/248/252/254/255 ";
                 }
             else
                 {
                 errMsg += " Please enter a value between " + ipOctetMinVal +
                       " - " + ipOctetMaxVal + " ";
                 }
             if (suffixStr) errMsg += suffixStr;
             }
         if (value.length == 0 || value.length > 3)
             {
             if (optFlag && !ipOctetSpecified)
                 {
                 continue;
                 }
             var j = 0;
             if (i == 0)
                 {
                  /* check for full empty IP address */
                 for (j = i; j < objArr.length; ++j)
                     {
                     if (objArr[j].length)
                         break;
                      }
                 }
             if (errMsg)
                 {
                 if ((i == 0) && (j == objArr.length) && errMsg)
                     {
                     if (ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM')
						if (alertFlag)
						{
							errMsg = prefixStr + "Please enter a value 0/128/192/224/240/248/252/254/255 for each octet.";
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
						}
                     else
                        if (alertFlag)
						{
							errMsg = prefixStr + "Please enter a value between " + ipOctetMinVal +
                                " - " + ipOctetMaxVal + " for each octet.";
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
						}
                     }
                 else
                     {
                     if (octetShowFlag)
                     	{
						if (value.length > 3)
							errMsg = "Invalid octet length for octet " + (i+1);
						else
							errMsg += (i+1);
                     	}
					 if (alertFlag)
						{
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
						}

                     }
                 }
             obj.focus ();
             return false;
             }
         if (optFlag)
             {
             if (i > 0 && !ipOctetSpecified)
                 {
                 if (errMsg)
                     {
                     if (octetShowFlag) errMsg += (i+1);
                     //alert (errMsg);
					 if (alertFlag)
						{
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
						}
                     }
                 obj.focus ();
                 return false;
                 }
             ipOctetSpecified = true;
             }

         if (((i+1) == 4) && (ipv4AddrTypeStr == 'IP'))
             {
             /* last octet should not set to zero as this is ip address */
             ipOctetMinVal = 1;
             ipOctetMaxVal = 254;                          
             } 
         if (((i+1) == 4) && (ipv4AddrTypeStr == 'SN'))
             {
             /* last octet can set to zero as this is network ip */
             ipOctetMinVal = 0;
             ipOctetMaxVal = 254;                          
             } 
         if (((i+1) == 1) && (ipv4AddrTypeStr == 'IP' || ipv4AddrTypeStr == 'SN'))
             {
			/*     first octet should not exced 223 */                 
             ipOctetMinVal = 1;
             ipOctetMaxVal = 223;
             }

         if (ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM')
             {
             if ((i+1) == 1)
                isError = !checkSnetMask (value, 8, 8);
		     else if (((i+1) == 4) && ipv4AddrTypeStr == 'SM')
                {
                if (objArr[i-1] != "255")
                    isError = !checkSnetMask (value, 0, 0);
                else
                    isError = !checkSnetMask (value, 0, 6);
                }
             else
                {
                if (objArr[i-1] != "255")
                    isError = !checkSnetMask (value, 0, 0);
                else
                    isError = !checkSnetMask (value, 0, 8);
                }
             }
         else
             {
             if (((parseInt (value) > 0) && isFirstByteZero) ||
                 (parseInt (value) < ipOctetMinVal || parseInt (value) > ipOctetMaxVal))
                 {
                 isError = true;
                 }
             }
         if (isError)
             {
             if (isFirstByteZero) --i;
             if (alertFlag)
                 {
                 if (prefixStr) errMsg = prefixStr;
                 if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) == 1))
                     errMsg += " Please enter 255 ";
                 else if ((ipv4AddrTypeStr == 'SM') && ((i+1) == 4))
                     {
                     if (objArr[i-1] != "255")
                         errMsg += " Please enter 0 ";
                     else
                         errMsg += " Please enter 0/128/192/224/240/248/252 ";
                     }
                 else if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) > 1))
                     {
                     if (objArr[i-1] != "255")
                         errMsg += " Please enter 0 ";
                     else
                         errMsg += " Please enter 0/128/192/224/240/248/252/254/255 ";
                     }
                 else
                     {
                     errMsg += " Please enter a value between " + ipOctetMinVal +
                               " - " + ipOctetMaxVal + " ";
                     }
                 if (suffixStr) errMsg += suffixStr;
                 if (octetShowFlag) errMsg += (i+1);
      			 if (document.getElementById(tblIPAddrId+"Err"))
					document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
				 else
					alert (errMsg);
				 }
             obj.focus ();
             return false;
             }
         }
	 if (document.getElementById(tblIPAddrId+"Err"))
		document.getElementById(tblIPAddrId+"Err").innerHTML = "";
     return true;
     }

function ipv4Validate 
	(tblIPAddrId, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
	{
   	var errStr = ""
   	var genErrStr = ""
   	if (prefixStr) errStr += ": "
   	if (ipv4AddrTypeStr == "SM")
  		genErrStr = "Invalid Subnet Mask";
   	else 
   		genErrStr = "Invalid IP Address";
   	
    if (!tblIPAddrId) return false;
    var obj = document.getElementById(tblIPAddrId);
    if (!obj || obj.disabled) return true;
    
    if (obj.value == "" && !optFlag)
    	{
    	if (alertFlag)
    		{
    		if (document.getElementById(tblIPAddrId+"Err"))
    			document.getElementById(tblIPAddrId+"Err").innerHTML = genErrStr;
    		else
		    	alert (errStr + genErrStr);
	    	}
   	   	obj.focus ();
   	   	return false;   	   	
    	}
    else if (obj.value == "" && optFlag)
    	{
		if (document.getElementById(tblIPAddrId+"Err"))
			document.getElementById(tblIPAddrId+"Err").innerHTML = "";
    	return true;
    	}
    
    if (obj.value.length > 15)
    	{
    	if (alertFlag)
    		{
    		if (document.getElementById(tblIPAddrId+"Err"))
    			document.getElementById(tblIPAddrId+"Err").innerHTML = genErrStr;
    		else
		    	alert (errStr + genErrStr);
	    	}
   	   	obj.focus ();
   	   	return false;
    	}

    var objArr = obj.value.split (".");
    if (!objArr.length || objArr.length != 4)
    	{    	
    	if (alertFlag)
    		{
    		if (document.getElementById(tblIPAddrId+"Err"))
    			document.getElementById(tblIPAddrId+"Err").innerHTML = genErrStr;
    		else
		    	alert (errStr + genErrStr);
	    	}
   	   	obj.focus ();	    	
    	return false;
    	}
    	    
    /* Checking for invalid characters in IP address */
    for (var i = 0; i < objArr.length; i++)
		{		
		var octet = objArr[i];
			if (octet == "" || isNaN (octet))
			{
				if (alertFlag)
				{
					if (document.getElementById(tblIPAddrId+"Err"))
						document.getElementById(tblIPAddrId+"Err").innerHTML = genErrStr;
					else
						alert (errStr + genErrStr);
	    		}
	    	obj.focus ();
	    	return false;
			}
		}
    
    return ipv4AddrValuesCheck (obj, objArr, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag);
	}
	
function ipv4AddrValidate (Obj, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
	{
	if (!Obj) return;
	return ipv4Validate (Obj.id, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
	}	
	
/*
Function Name: validNetMask.
Purpose:  Determine if a string is a valid netmask.
Usage: validNetMask('255.255.252.0');
Returns: true if string is valid netmask else false
*/
function validNetMask(objId)
	{
	var msg = "Please enter valid CIDR subnet mask.";		
	var obj = document.getElementById(objId);       // get the subnet mask object 		
	if(obj)
		{
		if(ipSnetMaskFormatCheck (objId) == false)
			{			
			obj.focus();
			return false;			
			}
		else
			{
			netmask = getIPInt1(objId)                  // get decimal value of ip address
			neg = (( ~ netmask) & 0xFFFFFFFF);		
			if(!(((neg + 1) & neg) === 0))
				{
				alert(msg);
				obj.focus();
				return false;
				}
			else
				return true;		
			}
		}
	}
	
/*
Function: subnetValidation
Purpose: Returns true or false
Params: 1. id of ip address to find it falls in a subnet.
		2. id of ip address whose subnet we need to calculate.
		3. id of subnet mask of ip whose subnet we need to calculate.		
Use:subnetValidation(id1,id4,id2,id3) 	
*/	
function subnetValidation (ipAddrId_check,ipAddrId_mask,ipAddrId, snetMaskId)
	{
	/* variable declaration*/
	var objIpAddrId = null , objArr = null, ipAddrBits = null, objSnetMaskId = null;
	var subnetBits = null, lowAddressArr = null, highAddressArr = null, firstIP = null, lastIP = null;
	var ipAddrId_checkLow = null, ipAddrId_checkHigh = null, lowIpVal = null, highIpVal = null, ipAddrId_maskObj = null, objArrChk = null;	
	var ipAddrBitsChk = null, lowAddressArrChk = null, highAddressArrChk = null, firstIPChk = null, lastIPChk = null;	
	/*getting object of the ip and subnet mask of subnet to be checked*/	
    objIpAddrId = document.getElementById(ipAddrId); // get IP object
    if (!objIpAddrId) return;
    objArr = objIpAddrId.value.split(".");
    if (!objArr.length) return false;
    ipAddrBits = getNetworkAddress(objArr); // get IP Address bits 
    objSnetMaskId = document.getElementById(snetMaskId); // get subnet mask object
    if (!objSnetMaskId) return;    
    subnetBits = getNetworkMask(objSnetMaskId.value) // get Subnet Bits    
    /**/    
    /*getting object of the ip and subnet mask of subnet which is being checked*/
    objIpAddr_chk = document.getElementById(ipAddrId_check); // get IP object
    objArrChk = objIpAddr_chk.value.split(".");
    if (!objArrChk.length) return false;
    ipAddrBitsChk = getNetworkAddress(objArrChk); // get IP Address bits    
    ipAddrId_maskObj = document.getElementById(ipAddrId_mask); // get subnet mask object
    if (!ipAddrId_maskObj) return;    
    subnetBitsChk = getNetworkMask(ipAddrId_maskObj.value) // get Subnet Bits 
    
    /* First and Last address array of the subnet which is being checked*/
    lowAddressArr = getLowAddress (ipAddrBits, subnetBits);
    highAddressArr = getHighAddress (ipAddrBits, subnetBits);    
    
    /* First and Last address array of the subnet which is to be checked*/
    lowAddressArrChk = getLowAddress(ipAddrBitsChk, subnetBitsChk);
    highAddressArrChk = getHighAddress (ipAddrBitsChk, subnetBitsChk);        
    
    /* First and last IP address of the subnet which is being checked*/
    firstIP = getIPAddress(lowAddressArr);    
    lastIP = getIPAddress(highAddressArr);  
          
    /*First and last IP address of the subnet which is to be checked*/
    firstIPChk = getIPAddress(lowAddressArrChk);     
    lastIPChk = getIPAddress(highAddressArrChk);       
    
    /*Get Low and high IP from both subnets*/
    ipAddrId_checkLow = convert_addr(firstIPChk); // get decimal value of ip    
    ipAddrId_checkHigh = convert_addr(lastIPChk); // get decimal value of ip    
    lowIpVal = convert_addr(firstIP); // get decimal value of ip
    highIpVal = convert_addr(lastIP); // get decimal value of ip
	
	if(isInSubnetCheck (ipAddrId_checkLow, lowIpVal, highIpVal) || isInSubnetCheck (ipAddrId_checkHigh, lowIpVal, highIpVal))
		return true;
	else
		return false;
    }		
/*
Function: toArray_
Purpose: Returns array containing IP octates converted from decimal value of IP address
Use:  countSetbits('255.255.255.0'))
*/

function toArray_(val) 
	{
	var ret = new Array();
	for (var j = 3; j >= 0; --j)
		ret[j] |= ((val >>> 8*(3-j)) & (0xff));    
    return ret;
}
/*
Function: countSetbits
Purpose: Returns number of set bits in the subnet mask
params: 1. decimal value of subnet mask
Use:  countSetbits(val))
*/
function countSetbits(num_)
	{
	num_ = num_ - ((num_ >> 1) & 0x55555555);
	num_ = (num_ & 0x33333333) + ((num_ >> 2) & 0x33333333);
	return ((num_ + (num_ >> 4) & 0xF0F0F0F) * 0x1010101) >> 24;
	}
/*
Function: getNetworkMask
Purpose: Returns net mask based on set bits
Use:  getNetworkMask('255.255.255.0'))
*/
function getNetworkMask (netMaskAddr)
	{
	var netmask = 0 ;
	for (var j = 0; j < countSetbits (convert_addr(netMaskAddr)); ++j) {
    	netmask |= (1 << 31-j);    	
    }    
	return netmask ;
	}
/*
Function: getNetworkAddress
Purpose: Returns binary address of the IP address.
Use:  getNetworkAddress(toArray_(convert_addr("192.168.10.10")))
 */	
function getNetworkAddress(addrArray) 
	{
	var addr = 0;
	var j = 1;
	for (var i = 0; i <= 3; ++i) 
		{
		addr |= ((addrArray[i] & 0xff) << 8*(4-j));
		j++;
		}
	return addr;
    }
/*
Function: getLowAddress
Purpose: Returns array of octates of low address.
Use:  getLowAddress(addressbits, subnetMaskBits)
 */	        
function getLowAddress(ipAddrBits, subnetBits)
	{
	return toArray_((ipAddrBits & subnetBits) + 1 );
	}

/*
Function: getHighAddress
Purpose: Returns array of octates of high address.
Use:  getHighAddress(addressbits, subnetMaskBits)
 */	        

function getHighAddress(ipAddrBits, subnetBits)
	{
	return toArray_((ipAddrBits | ~subnetBits) - 1);
	}

/*
Function: getIPAddress
Purpose: Returns IP address.
Use:  getIPAddress(octateArray)
 */	        

function getIPAddress(octateArr)
	{
	return octateArr[0] + "." + octateArr[1] + "." + octateArr[2] + "." + octateArr[3];
	}

/*
Function: isInSubnetCheck
Purpose: Checks whether an subnet ip falls within a subnet range
params: 1.decimal value of subnet ip
		2.decimal value of first ip of subnet
		3.decimal value of last ip of subnet
Use:  isInSubnetCheck(val1, val2, val3)
Returns: true or false
*/

function isInSubnetCheck (ipAddrId_checkVal, lowIpVal, highIpVal)
	{
	return ((ipAddrId_checkVal >= lowIpVal) && (ipAddrId_checkVal <= highIpVal));    	
	}