/*
Copyright (c) 2009 TeamF1, Inc.
All rights reserved.
*/

function scheduleFormValidate ()
    {
    var obj = null;
    var time = 0;
	/* get and validate start hours */
	obj = document.getElementById('txtSchedStartTimeHrs');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid start time for schedule. Enter valid hour between 1 and 12",
                            1, 12, true, "Invalid start time for schedule.", "hours") == false)
         return false;
	/* get and validate start minutes */
	obj = document.getElementById('txtSchedStartTimeMns');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid start time for schedule. Enter valid minutes between 0 and 59",
                            0, 59, true, "Invalid start time for schedule.", "minutes") == false)
         return false;
	/* get and validate end hours */
	obj = document.getElementById('txtSchedEndTimeHrs');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid end time for schedule. Enter valid hour between 1 and 12",
                            1, 12, true, "Invalid end time for schedule.", "hours") == false)
         return false;
	/* get and validate end hours */
	obj = document.getElementById('txtSchedEndTimeMns');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid end time for schedule. Enter valid minutes between 0 and 59",
                            0, 59, true, "Invalid end time for schedule.", "minutes") == false)
         return false;
    return true;
    }

function numObj (id, minLen, minVal, maxVal, errMsg)
	{
	this.id = id;
	this.minLen = minLen;
	this.minVal = minVal;
	this.maxVal = maxVal;
	this.errMsg = errMsg;
	}

function dateValidate (hoursId, minId, errObjId)
	{
	var dtVarObj = new Array ();
	
	dtVarObj[0] = new numObj(hoursId, 1, 1, 12, "Invalid Hours: Please enter a value between 1 - 12");
	dtVarObj[1] = new numObj(minId, 1, 0, 59, "Invalid Minutes: Please enter a value between 0 - 59");
	
	var idObj = null;
	for (var idx = 0; idx < dtVarObj.length; ++idx)
		{
		idObj = document.getElementById (dtVarObj[idx].id);
		if (!idObj || idObj.disabled) continue;
		if ((idObj.value.length < dtVarObj[idx].minLen) ||
			(parseInt (idObj.value, 10) < dtVarObj[idx].minVal) ||
			((dtVarObj[idx].maxVal != 0) && (parseInt (idObj.value, 10) > dtVarObj[idx].maxVal)))
			{
			if (document.getElementById(errObjId))
				document.getElementById(errObjId).innerHTML = dtVarObj[idx].errMsg
			else
				alert (dtVarObj[idx].errMsg);
			idObj.focus ();
			return false;
			}
		}
	//document.getElementById(errObjId).innerHTML = "";
	return true;
	}

function pageValidate ()
    {
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtSheName,Please enter the SheduleName";    

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
        return false;
        
	if (specificDaySelectionCheck () == false)
		return false;

	var selValue= comboSelectedValueGet ('selSchedTimeType');
	if (!selValue) return;
	if (parseInt(selValue, 10) == 0)
		{
	    if (dateValidate ('txtSchedStartTimeHrs', 'txtSchedStartTimeMns','date1Err') == false)
	  		return false;
	  	if (dateValidate ('txtSchedEndTimeHrs', 'txtSchedEndTimeMns','date2Err') == false)
	   		return false;
		selValue= comboSelectedValueGet ('selSchedType');
		if (parseInt (selValue, 10) == 0)
			{
	   		if (!timeValidate ())
	   			return false;
	   		}
	   	else
	   		{
	   		document.getElementById('date2Err').innerHTML = "";
	   		}
   		}
	return true;
    }

function timeValidate ()
    {
    var meridian1 = document.getElementById('selStartMeridian').value;
    var meridian2 = document.getElementById('selEndMeridian').value;
    
    if( meridian1 == meridian2 )
    {
    	var hr1 = parseInt (document.getElementById('txtSchedStartTimeHrs').value, 10);
    	var hr2 = parseInt (document.getElementById('txtSchedEndTimeHrs').value, 10);
		var min1 = parseInt (document.getElementById('txtSchedStartTimeMns').value,10);
    	var min2 = parseInt (document.getElementById('txtSchedEndTimeMns').value,10);
		if(hr1==hr2)
		{
			if(min1 >= min2)
			{
				document.getElementById('date2Err').innerHTML = "Please check minutes";
				return false;
			}
			else
				document.getElementById('date2Err').innerHTML = "";
		}
		else if (hr1>hr2)
		{
			if (hr1 != 12)
				{
				document.getElementById('date2Err').innerHTML = "End hour cannot be less than the start hour";
				return false;
				}
		}
		else
			document.getElementById('date2Err').innerHTML = "";
    }
    else if (meridian1 == 'PM' && meridian2 == 'AM')
    {
    	document.getElementById('date2Err').innerHTML = "End Time hours cannot extend to next day";
    	return false
    }
    else
    	document.getElementById('date2Err').innerHTML = "";

	return true;
	} 

function scheduleDayOptCheck ()
	{
	var selValue= comboSelectedValueGet ('selSchedType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* specific day */
			fieldStateChangeWr ('','','chkSun chkMon chkTue chkWed chkThu chkFri chkSat','');
			break;
		case 1:	/* all day */
			fieldStateChangeWr ('chkSun chkMon chkTue chkWed chkThu chkFri chkSat','','','');
			if (document.getElementById ('errMsg'))
				document.getElementById ('errMsg').innerHTML = "";
			if (document.getElementById('date2Err'))
				document.getElementById('date2Err').innerHTML = "";
			break;
		}
	}

function specificDaySelectionCheck ()
	{
	var selValue= comboSelectedValueGet ('selSchedType');
	if (!selValue) return;
	if (parseInt(selValue, 10) == 0)
		{
		if (document.getElementById('chkSun').checked ||
		    document.getElementById('chkMon').checked ||
		    document.getElementById('chkTue').checked ||
		    document.getElementById('chkWed').checked ||
		    document.getElementById('chkThu').checked ||
		    document.getElementById('chkFri').checked ||
		    document.getElementById('chkSat').checked)
			return true;
		else
			{
			errMag = 'Please select day(s) on which this schedule should apply.';
			if (document.getElementById ('errMsg'))
				document.getElementById ('errMsg').innerHTML = errMag;
			else
				alert (errMag);
			return false;
			}
		}
	return true;
	}

function scheduleTimeOptCheck ()
	{
	var selValue= comboSelectedValueGet ('selSchedTimeType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* specific times */
			fieldStateChangeWr ('','','txtSchedStartTimeHrs txtSchedStartTimeMns selStartMeridian txtSchedEndTimeHrs txtSchedEndTimeMns selEndMeridian','');
			break;
		case 1:	/* all day */
			fieldStateChangeWr ('txtSchedStartTimeHrs txtSchedStartTimeMns selStartMeridian txtSchedEndTimeHrs txtSchedEndTimeMns selEndMeridian','','','');
			break;
		}
	}

function scheduleInit ()
	{
	scheduleDayOptCheck ();
	scheduleTimeOptCheck ();
	}
