/*
Copyright (c) 2009 TeamF1, Inc.
All rights reserved.
*/

/* Validates VPN Policy Configurations */
function vpnPolicyValidate()
    {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtVPName,Please enter a name for the VPN policy";
    txtFieldIdArr[1] = "vpnPolicyRemoteEndpointFQDNTxt,Invalid FQDN. Please specify a Fully Qualified Domain Name for the remote endpoint";
    txtFieldIdArr[2] = "localStartIP,Please enter valid Start IP Address";
    txtFieldIdArr[3] = "localEndIP,Please enter Valid End IP Address";
    txtFieldIdArr[4] = "localSubnet,Please enter Valid SubnetMask";
    txtFieldIdArr[5] = "remoteStartIP,Please enter Valid Start IP Address";
    txtFieldIdArr[6] = "remoteEndIP,Please enter Valid End IP Address";
    txtFieldIdArr[7] = "remoteSubnet,Please enter Valid SubnetMask";
    txtFieldIdArr[8] = "txtVPSPIIn,Please enter a valid incoming SPI for manual policy entry";
    txtFieldIdArr[9] = "txtVPSPIOut,Please enter a valid outgoing SPI for manual policy entry";
    txtFieldIdArr[10] = "manualPolicyKeyLen,Please enter a valid Key Length.";
    txtFieldIdArr[11] = "manualPolicyKeyIn,Please enter the incoming encryption check key for manual policy entry";
    txtFieldIdArr[12] = "manualPolicyKeyOut,Please enter the outgoing encryption key for manual policy entry";               
    txtFieldIdArr[13] = "autoPolicyKeyLen,Please enter a valid Key Length.";
    txtFieldIdArr[14] = "txtVPIntKeyIn,Please enter the incoming integrity key for manual policy entry";
    txtFieldIdArr[15] = "txtVPIntKeyOut,Please enter the outgoing integrity check key for manual policy entry";
    txtFieldIdArr[16] = "txtVPSALifeTimeSec,Please enter a valid Lifetime";
    txtFieldIdArr[17] = "selAutoIkePol,No IKE Policy to Configure VPN Policy, Please Configure an Ike Policy";
    
        
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
        
	var spiInObj = document.getElementById ('txtVPSPIIn');
	var spiOutObj = document.getElementById ('txtVPSPIOut');
	if (!spiInObj.disabled && spiInObj.value == "0x")
		{
		var errMsg = "Please enter a valid incoming SPI for manual policy entry"
		if (document.getElementById ('txtVPSPIInErr'))
			document.getElementById ('txtVPSPIInErr').innerHTML = errMsg;
		else
			alert (errMsg);
		return false;
		}
		
	if (!spiOutObj.disabled && spiOutObj.value == "0x")
		{
		var errMsg = "Please enter a valid outgoing SPI for manual policy entry"
		if (document.getElementById ('txtVPSPIOutErr'))
			document.getElementById ('txtVPSPIOutErr').innerHTML = errMsg;
		else
			alert (errMsg);
		return false;
		}
 
    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
    	return false;
    	
	if (remoteEndPointCheck () == false)
    	return false;    	
         
	if (localSubnetIpChange() == false)
    	return false;
    	
	if (ipv4Validate ('localEndIP', 'IP', false, true,
             "Invalid IP address.", "for octet ", true) == false)
    	return false;

    var locStartIpObj = document.getElementById('localStartIP');
    var locEndIpObj = document.getElementById('localEndIP');
    if (!locStartIpObj.disabled && !locEndIpObj.disabled)
        {
        var locStartIp = getIPInt1('localStartIP')
        var locEndIp = getIPInt1('localEndIP');
        var locSnetMask = getIPInt1('hdSnetMask');

        if (isInSubnet(locStartIp, locEndIp, locSnetMask)) {
        } else {
    		var errorstr = "Local Start and End IP Addresses must be in same subnet.";
        	if (document.getElementById('localEndIPErr'))
    	    	document.getElementById('localEndIPErr').innerHTML = errorstr;
        	else
        		alert (errorstr);
		    document.getElementById('localEndIP').focus();
        	return false;
	    	}
	    }

	if (ipRangeValidate ('localStartIP','localEndIP', '', '') == false)
		return false;
	
	if (ipv4Validate ('localSubnet', 'SM', false, true,
             "Invalid Subnet Mask.", "for octet ", true) == false)
    	return false;
    	
	if (remoteSubnetIpChange() == false)
    	return false;
    	
	if (ipv4Validate ('remoteEndIP', 'IP', false, true,
             "Invalid IP address.", "for octet ", true) == false)
    	return false;

    var rmtStartIpObj = document.getElementById('remoteStartIP');
    var rmtEndIpObj = document.getElementById('remoteEndIP');
    if (!rmtStartIpObj.disabled && !rmtEndIpObj.disabled)
        {
        var rmtStartIp = getIPInt1('remoteStartIP')
        var rmtEndIp = getIPInt1('remoteEndIP');
        var rmtSnetMask = getIPInt1('hdSnetMask');

        if (isInSubnet(rmtStartIp, rmtEndIp, rmtSnetMask)) {
        } else {
	    	var errorstr = "Remote Start and End IP Addresses must be in same subnet.";
    	    if (document.getElementById('remoteEndIPErr'))
        		document.getElementById('remoteEndIPErr').innerHTML = errorstr;
        	else
    	    	alert (errorstr);
    		document.getElementById('remoteEndIP').focus();
        	return false;
		    }
        }

	if (ipRangeValidate ('remoteStartIP','remoteEndIP', '', '') == false)
		return false;
    	
	if (ipv4Validate ('remoteSubnet', 'SM', false, true,
             "Invalid Subnet Mask.", "for octet ", true) == false)
    	return false;

	if (encrKeyLenValidate () == false)
		return false;

	if (intgAlgoKeyLenValidate () == false)
		return false;         
         
    var selRemoteObj = document.getElementById ('selectRemoteIP');
    if (!selRemoteObj) return true;  /* do not check for disable state */
    selRemoteObj.disabled = false;
    if( saValueRangeCheck () == false)
		return false;         

	var selValue = comboSelectedValueGet ('selRmtEPType');
	if (parseInt (selValue, 10) == 0)
		{
		var wan1IPAddr = document.getElementById ('hdWan1IP').value;
		var wan2IPAddr = document.getElementById ('hdWan2IP').value;
		var remoteEndPointAddr = document.getElementById ('vpnPolicyRemoteEndpointFQDNTxt').value;
		if (remoteEndPointAddr != "")
			{
			var errorStr = "";
			if (remoteEndPointAddr == wan1IPAddr)
				errorStr = "Remote end point must not same as Dedicated WAN IP address"
			else if (remoteEndPointAddr == wan2IPAddr)
				errorStr = "Remote end point must not same as Secondary WAN IP address"
			if (errorStr != "")
				{
				if (document.getElementById ('vpnPolicyRemoteEndpointFQDNTxtErr'))
					document.getElementById ('vpnPolicyRemoteEndpointFQDNTxtErr').innerHTML = errorStr;
				else
					alert (errorStr);
	            document.getElementById ('vpnPolicyRemoteEndpointFQDNTxt').focus ();
				return false;
				}
			}
		}
	var autoKeyLenObj=document.getElementById ('autoPolicyKeyLen');
	if(autoKeyLenObj && !autoKeyLenObj.disabled)
		{
		var encrAlgoVal = comboSelectedValueGet('selAutoEncType');
		if(encrAlgoVal == "11")
			{			
			if(numericValueRangeCheck (autoKeyLenObj, '', '', 40, 448, true, '', '')==false)return false;		
			}
		else
			{			
			if(numericValueRangeCheck (autoKeyLenObj, '', '', 40, 128, true, '', '')==false)return false;	
			}
		var keyLenVal=parseInt(autoKeyLenObj.value,10);
		if(	keyLenVal%8!=0)
			{
			alert("Key Length must be multiple of 8.");
			autoKeyLenObj.focus();
			return false;
			}
		}
    if(checkDirection () == false) return false;
    return true;
    }
    
function remoteIPChange ()
	{
	var chkObj = document.getElementById ('chkNetbios');
	if (!chkObj || chkObj.disabled) return;
	var selRemoteObj = document.getElementById ('selectRemoteIP');
	if (!selRemoteObj) return; /* do not check for disable state */
	if (chkObj.checked)
		{
		selRemoteObj.selectedIndex = 3;
		dropFieldSelectselectRemoteIP ();
        selRemoteObj.disabled = true;
        selRemoteObj.readOnly = true;
      //  nbWarnMsg.innerHTML = "This field is not editable, because netbios is selected.";
		}
	else
		{
		//selRemoteObj.selectedIndex = 0;
		selRemoteObj.disabled = false;
		selRemoteObj.readOnly = false;
		//nbWarnMsg.innerHTML = "";
		dropFieldSelectselectRemoteIP ();
		}
	}
function autoPolicyPfsKey ()
	{
	depFieldCheck ('pfsKey', true, '', '', 'pfsKeyGroup', '');
	depFieldCheck ('pfsKey', false, 'pfsKeyGroup', '', '', '');
	}
function dropFieldSelectselectPolicyType ()
    {
	var selValue = comboSelectedValueGet ('selGeneralPolicyType');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
   		case 1:	/* AUTO POLICY */
   			fieldStateChangeWr ('hdRmtEndPoint', 'manualPolicy', 'selRmtEPType', 'autoPolicy tblPhase1Auth tblEncr tblRemote tblLocal tblPhase1Nat');
   			autoPolicyPfsKey ();
            checkEncType ();
            viewChange();
            checkDhcp();
            IkePolInitialSettingsWrap ();
   			break;
   		case 2:	/* MANUAL POLICY */
   			var dhcpObj = document.getElementById('chkDhcp');
   			var policyObj = document.getElementById('selGeneralPolicyType');
			if (!dhcpObj) return;
			if(dhcpObj.checked)
				{
                alert("Can not use Manual Policy when DHCP is enabled.Please use Auto Policy.");
                policyObj.selectedIndex = 0;
                return;	
                }
   			fieldStateChangeWr ('selRmtEPType', 'autoPolicy tblPhase1Auth tblEncr tblRemote tblLocal tblPhase1Nat', 'hdRmtEndPoint', 'manualPolicy');
   			document.getElementById ('selRmtEPType').selectedIndex = 0;
   			dropFieldSelectEncAlg ();
   			break;
   		default:
   			break;
   		}
	}
	function dropFieldSelectselectModeType ()
    {
	var selValue = comboSelectedValueGet ('selGeneralTunnelOrTransport');	
	var dhcpObj = document.getElementById('chkDhcp');
	if (!dhcpObj) return;
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
   		case 1:	/* Tunnel Mode */
   			if(dhcpObj.checked)
                fieldStateChangeWr ('', 'tblRemoteTraffic tblLocalTraffic', '', '');
            else
            {
   			fieldStateChangeWr ('', '', 'chkDhcp', 'tblRemoteTraffic tblLocalTraffic');
   			dropFieldSelectselectLocalIP ();
			dropFieldSelectselectRemoteIP ();
			}
			fieldStateChangeWr ('', '', 'chkNetbios hdNetbios', '');
            remoteIPChange ();   			
   			break;
   		case 0:	/* Transport Mode */
   			var dhcpObj = document.getElementById('chkDhcp');
   			var selObj = document.getElementById ('selGeneralTunnelOrTransport');
   			if(dhcpObj.checked)
                {
                alert("Can not use Transport Mode when DHCP is enabled.Please select Tunnel Mode.");
                 selObj.selectedIndex = 0;
                return;	
                }
   			fieldStateChangeWr ('chkNetbios hdNetbios chkDhcp', 'tblRemoteTraffic tblLocalTraffic', '', '');   			
   			break;
   		default:
   			break;
   		}
	}	
	
function dropFieldSelectselectLocalIP ()
    {
	var selValue = comboSelectedValueGet ('selTrafficLocalIp');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
   		{
   		case 0:
   			fieldStateChangeWr ('localStartIP localEndIP localSubnet', '', '', '');
   			break;
   		case 1:
   			fieldStateChangeWr ('localEndIP localSubnet', '', 'localStartIP', '');
   			break;
   		case 2:
   			fieldStateChangeWr ('localSubnet', '', 'localStartIP localEndIP', '');
   			break;
   		case 3:
   			fieldStateChangeWr ('localEndIP', '', 'localStartIP localSubnet', '');
   			break;
   		default:
   			break;
   		}
	}
function dropFieldSelectselectRemoteIP ()
    {
	var selValue = comboSelectedValueGet ('selectRemoteIP');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
   		{
   		case 0:
   			fieldStateChangeWr ('remoteStartIP remoteEndIP remoteSubnet', '', '', '');
   			break;
   		case 1:
   			fieldStateChangeWr ('remoteEndIP remoteSubnet', '', 'remoteStartIP', '');
   			break;
   		case 2:
   			fieldStateChangeWr ('remoteSubnet', '', 'remoteStartIP remoteEndIP', '');
   			break;
   		case 3:
   			fieldStateChangeWr ('remoteEndIP', '', 'remoteStartIP remoteSubnet', '');
   			break;
   		default:
   			break;
   		}
	}

function checkEncType ()
    {
   	var optVal = comboSelectedValueGet ('selAutoEncType');
   	if (optVal == null) return;
   	switch (parseInt (optVal, 10))
   		{
   		case 6:
   			fieldStateChangeWr ('selAutoIntType autoPolicyKeyLen', '', '', '');
   			break;
   		case 7:
   			fieldStateChangeWr ('selAutoIntType autoPolicyKeyLen', '', '', '');
            break;
        case 11:   			
   		case 12:
   			fieldStateChangeWr ('', '', 'autoPolicyKeyLen', '');
   			break;
   		default:
   			fieldStateChangeWr ('autoPolicyKeyLen', '', 'selAutoIntType', '');
   			break;
   		}
    }

function dropFieldSelectEncAlg ()
    {
   	var optVal = comboSelectedValueGet ('selectManualPolicyEncAlg');
   	if (optVal == null) return;
   	switch (parseInt (optVal, 10))
   		{
   		case 0:
   			fieldStateChangeWr ('manualPolicyKeyLen manualPolicyKeyIn manualPolicyKeyOut', '', 'selInetegrityAlgo txtVPIntKeyIn txtVPIntKeyOut', '');
   			break;
   		case 6:
   			fieldStateChangeWr ('manualPolicyKeyLen selInetegrityAlgo txtVPIntKeyIn txtVPIntKeyOut', '', 'manualPolicyKeyIn manualPolicyKeyOut', '');
   			break;
   		case 7:
   			fieldStateChangeWr ('selInetegrityAlgo txtVPIntKeyIn txtVPIntKeyOut', '', 'manualPolicyKeyIn manualPolicyKeyOut', '');
   			break;
   		case 11:   			
   		case 12:
   			fieldStateChangeWr ('', '', 'manualPolicyKeyLen', '');
   			break;   		
   		default:
   			fieldStateChangeWr ('manualPolicyKeyLen', '', 'manualPolicyKeyIn manualPolicyKeyOut selInetegrityAlgo txtVPIntKeyIn txtVPIntKeyOut', '');
   			break;
   		}
	}
	
function vpnPolicyAddInitialSettings ()
	{
	dropFieldSelectselectPolicyType ();	
	dropFieldSelectselectLocalIP ();
	dropFieldSelectselectRemoteIP ();		
	remoteIPChange ();
	viewChange();	
	var typeObj = document.getElementById ('policyType').value;
	if(typeObj == "1")		
		fieldStateChangeWr ('chkNetbios hdNetbios', '', '', '');	
    }

function saValueRangeCheck ()
{
    var saObj = document.getElementById ('txtVPSALifeTimeSec');
	var selValue = comboSelectedValueGet ('selSaLifetimeType');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
   	{
	case 0:
		return numericValueRangeCheck1 (saObj, '', '', 300, true, 'Invalid SA Life time value:', 'seconds');
   		break;
	case 1:
		return numericValueRangeCheck1 (saObj, '', '', 1920000, true, 'Invalid SA Life time value:', 'Kbytes');
   		break;
   	default:
   		break;
   	}
}

function viewChange()
{
/*	var obj =document.getElementById('selAutoIkePol');
	if (obj.options.length == 0 || obj.disabled)
		fieldStateChangeWr ('btAutoPolicyViewSel', '', '', '');
	else
		{
		fieldStateChangeWr ('', '', 'btAutoPolicyViewSel', '');
		value = obj.options[obj.selectedIndex].id;
		document.getElementById('btAutoPolicyViewSel').name="button.view.IpsecIKEPolicy.viewIkePolicy." + value;
		}
		*/
}

function SPInOut (id)
{
	var value = document.getElementById(id).value;
	if (value.charAt(0) != '0' && value.charAt(1) != 'x')
	{
		value = "0x" + value;
	}
	document.getElementById(id).value = value;
}

function localSubnetIpChange()
{
	if(document.getElementById('selTrafficLocalIp').value == 3)
		{
		if (ipv4AddrValidate (document.getElementById('localStartIP'), 'SN', false, true, 'Invalid IP address.', 'for octet ', true))
			{
			var subnetIp = document.getElementById('localStartIP').value;
			var splitIp = subnetIp.split(".");
			splitIp[3] = "0";
			document.getElementById('localStartIP').value = splitIp.join(".");
			return true;
			}
		else
			return false;
		}
	else
		return ipv4AddrValidate (document.getElementById('localStartIP'), 'IP', false, true, 'Invalid IP address.', 'for octet ', true);
}

function remoteSubnetIpChange()
{
	if(document.getElementById('selectRemoteIP').value == 3)
		{
		if (ipv4AddrValidate (document.getElementById('remoteStartIP'), 'SN', false, true, 'Invalid IP address.', 'for octet ', true))
			{
			var subnetIp = document.getElementById('remoteStartIP').value;
			var splitIp = subnetIp.split(".");
			splitIp[3] = "0";
			document.getElementById('remoteStartIP').value = splitIp.join(".");
			return true;
			}
		else
			return false;
		}
	else
		return ipv4AddrValidate (document.getElementById('remoteStartIP'), 'IP', false, true, 'Invalid IP address.', 'for octet ', true);
}
    
function encrKeyLenValidate ()
	{
	var selEncrValue = comboSelectedValueGet ('selectManualPolicyEncAlg');
	if (selEncrValue == null)
         return true;
	var minKeyLen = 0;
	var errStr = "";
	switch (parseInt (selEncrValue, 10))
		{
		case 1:	/* DES */
			minKeyLen = 8;
			errStr = "for encryption algorithm: DES. Key must be 8 characters long.";
			break;
		case 2:	/* 3DES */
			minKeyLen = 24;
			errStr = "for encryption algorithm: 3DES. Key must be 24 characters long.";
			break;
		case 3:	/* AES-128 */
			minKeyLen = 16;
			errStr = "for encryption algorithm: AES-128. Key must be 16 characters long.";
			break;
		case 4:	/* AES-192 */
			minKeyLen = 24;
			errStr = "for encryption algorithm: AES-192. Key must be 24 characters long.";
			break;
		case 5:	/* AES-256 */
			minKeyLen = 32;
			errStr = "for encryption algorithm: AES-256. Key must be 32 characters long.";
			break;
		case 6:	/* AES-CCM */
			minKeyLen = 16;
			errStr = "for encryption algorithm: AES-CCM. Key must be 16 characters long.";
			break;
		case 7:	/* AES-GCM */
			minKeyLen = 20;
			errStr = "for encryption algorithm: AES-GCM. Key must be 20 characters long.";
			break;
		case 8:	/* TWOFISH (128)*/
			minKeyLen = 16;
			errStr = "for encryption algorithm: TWOFISH (128). Key must be 16 characters long.";
			break;
		case 9:	/* TWOFISH (192) */
			minKeyLen = 24;
			errStr = "for encryption algorithm: TWOFISH (192). Key must be 24 characters long.";
			break;
		case 10:	/*TWOFISH (256)*/
			minKeyLen = 32;
			errStr = "for encryption algorithm: TWOFISH (256). Key must be 32 characters long.";
			break;
		case 11:	/* BLOWFISH */			
			var keyLenObj= document.getElementById('manualPolicyKeyLen');
			var keyLenVal=parseInt(keyLenObj.value,10);
			if(	keyLenVal%8!=0){
				alert("Key Length must be multiple of 8.");
				keyLenObj.focus();
				return false;
			}
			if(numericValueRangeCheck (keyLenObj, '', '', 40,448, true, '', '')==false)return false;		
			var len=keyLenVal/8 ;
			minKeyLen = len;
			errStr = "for encryption algorithm: BLOWFISH . Key must be " +len +" characters long.";
			break;
		case 12:	/* CAST128 */
			var keyLenObj= document.getElementById('manualPolicyKeyLen');
			var keyLenVal=parseInt(keyLenObj.value,10);
			if(	keyLenVal%8!=0){				
				alert("Key Length must be multiple of 8.");				
				keyLenObj.focus();
				return false;
			}
			if(numericValueRangeCheck (keyLenObj, '', '', 40,128, true, '', '')==false)return false;			
			var len=keyLenVal/8 ;
			minKeyLen = len;
			errStr = "for encryption algorithm: CAST128. Key must be "+ len+" characters long.";
			break;
		case 0:	/* NULL */
		default:
			minKeyLen = 0;
			errStr = "";
			break;
		}
    /* check for minimum length */
	if (fieldLengthCheck ('manualPolicyKeyIn', minKeyLen, minKeyLen,
				"Invalid Key-In length " + errStr) == false)
		return false;
	if (fieldLengthCheck ('manualPolicyKeyOut', minKeyLen, minKeyLen,
				"Invalid Key-Out length " + errStr) == false)
		return false;
    /* check for key validity */
    var keyInObj = document.getElementById ('manualPolicyKeyIn');
    if (keyInObj.disabled) return true;
    var keyOutObj = document.getElementById ('manualPolicyKeyOut');
    if (keyOutObj.disabled) return true;
	switch (parseInt (selEncrValue, 10))
		{
		case 2:	/* 3DES */
            splitPos = 8;
            errStr = "For 3DES, every 8 bytes in 24 byte key-in should be different";
            var keyInStr = keyInObj.value;
            if ((keyInStr.substring (0, splitPos) == 
                         keyInStr.substring (splitPos, splitPos + splitPos)) ||
                (keyInStr.substring (splitPos, splitPos + splitPos) == 
                         keyInStr.substring (splitPos  + splitPos)) ||
                (keyInStr.substring (0, splitPos) == 
                         keyInStr.substring (splitPos  + splitPos)))
                {
                if (document.getElementById ('manualPolicyKeyInErr'))
                	document.getElementById ('manualPolicyKeyInErr').innerHTML = errStr;
                else
	                alert (errStr);
                keyInObj.focus ();
                return false;
                }
            var keyOutStr = keyOutObj.value;
            errStr = "For 3DES, every 8 bytes in 24 byte key-out should be different";
            if ((keyOutStr.substring (0, splitPos) == 
                         keyOutStr.substring (splitPos, splitPos + splitPos)) || 
                (keyOutStr.substring (splitPos, splitPos + splitPos) == 
                         keyOutStr.substring (splitPos  + splitPos)) || 
                (keyOutStr.substring (0 , splitPos) == 
                         keyOutStr.substring (splitPos  + splitPos)))
                {
                if (document.getElementById ('manualPolicyKeyOutErr'))
                	document.getElementById ('manualPolicyKeyOutErr').innerHTML = errStr;
                else
	                alert (errStr);
                keyOutObj.focus ();
                return false;
                }
			break;
		case 1:	/* DES */
		case 3:	/* AES-128 */
		case 4:	/* AES-192 */
		case 5:	/* AES-256 */
		case 0:	/* NULL */
		default:
			minKeyLen = 0;
			errStr = "";
			break;
		}
    
	return true;
	}    
	
function intgAlgoKeyLenValidate ()
	{
	var selAlgoValue = comboSelectedValueGet ('selInetegrityAlgo');
	if (selAlgoValue == null) return true;
	var minKeyLen = 0;
	var errStr = "";
	switch (parseInt (selAlgoValue, 10))
		{
		case 1:	/* MD5 */
			minKeyLen = 16;
			errStr = "for integrity algorithm: MD5. Key must be 16 characters long.";
			break;
		case 2:	/* SHA1 */
			minKeyLen = 20;
			errStr = "for integrity algorithm: SHA1. Key must be 20 characters long.";
			break;
		case 3:	/* SHA2-256 */
			minKeyLen = 32;
			errStr = "for integrity algorithm: SHA2-256. Key must be 32 characters long.";
			break;
		case 4:	/* SHA2-384 */
			minKeyLen = 48;
			errStr = "for integrity algorithm: SHA2-384. Key must be 48 characters long.";
			break;
		case 5:	/* SHA2-512 */
			minKeyLen = 64;
			errStr = "for integrity algorithm: SHA2-512. Key must be 64 characters long.";
			break;
		case 6:	/* SHA2-224 */
			minKeyLen = 28;
			errStr = "for integrity algorithm: SHA2-224. Key must be 28 characters long.";
			break;
		default:
			minKeyLen = 0;
			errStr = "";
			break;
		}
	if (fieldLengthCheck ('txtVPIntKeyIn', minKeyLen, minKeyLen,
			"Invalid Key-In length " + errStr) == false)
		return false;
	if (fieldLengthCheck ('txtVPIntKeyOut', minKeyLen, minKeyLen,
			"Invalid Key-Out length length " + errStr) == false)
		return false;
	return true;
	}

function remoteEndPointCheck ()
	{
	var rmtEndpointTypeObj = document.getElementById ('selRmtEPType');
	var selValue = rmtEndpointTypeObj.value;
	if (parseInt (selValue, 10) == 0)
		{
		if (ipv4Validate ('vpnPolicyRemoteEndpointFQDNTxt', 'IP', false, true,
	             "Invalid IP address.", "for octet ", true) == false)
	    	return false;
		}
	else
		{
		if (validateFQDN ('vpnPolicyRemoteEndpointFQDNTxt') == false)
	    	return false;
		}
	if (document.getElementById ('vpnPolicyRemoteEndpointFQDNTxtErr'))
		document.getElementById ('vpnPolicyRemoteEndpointFQDNTxtErr').innerHTML = "";
	return true;
	}
	
function clearErrorMsg ()
	{
	if (document.getElementById ('vpnPolicyRemoteEndpointFQDNTxtErr'))
		document.getElementById ('vpnPolicyRemoteEndpointFQDNTxtErr').innerHTML = "";
	}
	
function checkDhcp ()
    {
    var dhcpObj = document.getElementById('chkDhcp');
    checkDhcpIpsecMode ();
    if(dhcpObj.checked)
    	{    	
        fieldStateChangeWr ('hdNetbios chkNetbios', 'tblLocalTraffic tblRemoteTraffic manualPolicy', '', '');
        }
    else
    	{    	
        dropFieldSelectselectModeType ();
        fieldStateChangeWr ('', 'hdNetbios chkNetbios', '', '');
        remoteIPChange ();
        }
	}
	
function checkDhcpIpsecMode ()
	{
	var dhcpObj = document.getElementById('chkDhcp');
	var selObj = document.getElementById ('selGeneralPolicyType');
	if(dhcpObj.checked && selObj.value == "2")
        {
        alert("Can not use Manual Policy when DHCP is enabled. Please select Auto Policy.");
        selObj.selectedIndex = 0;
        dropFieldSelectselectPolicyType ();        
        }

	selObj = document.getElementById ('selGeneralTunnelOrTransport');
	if(dhcpObj.checked && selObj.value == "0")
        {
        alert("Can not use Transport Mode when DHCP is enabled. Please select Tunnel Mode.");
        selObj.selectedIndex = 0;
        dropFieldSelectselectModeType ();         
        }    
	}
function checkDirection ()
    {
    	var selValue = parseInt(comboSelectedValueGet ('selDirection'),10);
    	var dhcpObj = document.getElementById('chkDhcp');
    	if(!dhcpObj || dhcpObj.disabled) return true;
    	var directionObj = document.getElementById('selDirection');
    	if(!directionObj) return true; 
    	if(dhcpObj.checked && (selValue == 0 || selValue == 2))
    	    {
    	    	alert("Can not use Direction type Initiator or Both when DHCP over Ipsec in enabled.Please select Responder direction type.")
    	    	return false;    	    	 
    	    }
    	return true;
    	
     }
 
	
	
