/*
Copyright (c) 2009 TeamF1, Inc.
All rights reserved.
*/

function vpnWizValidate1 ()
    {
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtVPNWizName,Please enter a name for the VPN connection being configured";
    txtFieldIdArr[1] = "txtVPWizPsk,Please enter a pre-shared key to be used for the VPN connection";
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
    	return false;
    	
    if(fieldLengthCheck ('txtVPWizPsk', 8, 49, 'Please enter key with length between 8 - 49 characters') == false) return false;  

    return true;
    }

function vpnWizValidate2 ()
    {
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtVPWizRmtIp,Please enter the remote node's IP address or internet name";
    txtFieldIdArr[1] = "txtVPIkeLId,Please enter the local node's IP address or internet name";
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
    	return false;

    if (checkInternetName (1) == false)
	return false;

    if (checkInternetName (2) == false)
	return false;

    if (document.getElementById ('txtVPIkeLId').value == document.getElementById ('txtVPWizRmtIp').value)
	{
	var errMsg = "Remote and Local Gateway IP Address / FQDN should not be same"
	if (document.getElementById ('txtVPWizRmtIpErr'))
		document.getElementById ('txtVPWizRmtIpErr').innerHTML = errMsg;
	else
		alert (errMsg);
	document.getElementById ('txtVPWizRmtIp').focus();
	return false;
	}
	
    return true;
    }

function vpnWizValidate3 ()
    {
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "vpnPolicyRemoteLanIPAddress,Please enter LAN IP Address";
    txtFieldIdArr[1] = "vpnPolicyRemoteLanIPMask,Please enter Subnet Mask";
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
    	return false;

    if (ipv4Validate ('vpnPolicyRemoteLanIPAddress', 'SN', false, true,
                      "Invalid IP address.", "for octet ", true) == false)
    	return false;

    if (ipv4Validate ('vpnPolicyRemoteLanIPMask', 'SM', false, true,
                      "Invalid IP address.", "for octet ", true) == false)
    	return false;
	
    return true;
    }

function wanDefaultsSet ()
	{
	if (parseInt (comboSelectedValueGet ('selPeerType'), 10) == 1)
		return;
	var locIdObj = document.getElementById ('txtVPIkeLId');
	var wan1DdnsObj = document.getElementById ('hdWan1DdnsState');
	var wan2DdnsObj = document.getElementById ('hdWan2DdnsState');
	if (!locIdObj || !wan1DdnsObj || !wan2DdnsObj) return;
	var wanChoice = comboSelectedValueGet ('selLocalWanInt');
	switch (parseInt (wanChoice, 10))
		{
		case 1:	/* WAN2 */
			if (wan2DdnsObj.value == "1")
				{
				document.getElementById ('selLocalGwType').selectedIndex = 1;
				locIdObj.value = hdWan2Fqdn.value;
				}
			else
				{
				document.getElementById ('selLocalGwType').selectedIndex = 0;
				locIdObj.value = hdWan2IP.value;
				}
			break;
		case 0:	/* WAN1 */
		default:
			if (wan1DdnsObj.value == "1")
				{
				document.getElementById ('selLocalGwType').selectedIndex = 1;
	            locIdObj.value = hdWan1Fqdn.value;				
				}
			else
				{
				document.getElementById ('selLocalGwType').selectedIndex = 0;
	            locIdObj.value = hdWan1IP.value;			
				}				
			break;
		}
	return;
	}

function gateWaySetup ()
	{
	fieldStateChangeWr ('' , '', 'txtVPNWizName txtVPWizPsk vpnPolicyRemoteLanIPAddress vpnPolicyRemoteLanIPMask', '');
	wanDefaultsSet ();
	var rmtIdObj = document.getElementById ('txtVPWizRmtIp');
	if (!rmtIdObj) return;
    rmtIdObj.value = "";
	document.getElementById ('selRemoteGwType').selectedIndex = 0;
	}

function clientIpsecHostSetup ()
	{
	fieldStateChangeWr ('vpnPolicyRemoteLanIPAddress vpnPolicyRemoteLanIPMask' , '', 'txtVPNWizName txtVPWizPsk', '');
	var locIdObj = document.getElementById ('txtVPIkeLId');
	if (!locIdObj) return;
    locIdObj.value = hdLocId.value;
	document.getElementById ('selLocalGwType').selectedIndex = 1;
	var rmtIdObj = document.getElementById ('txtVPWizRmtIp');
	if (!rmtIdObj) return;
    rmtIdObj.value = hdRmtId.value;
	document.getElementById ('selRemoteGwType').selectedIndex = 1;
	}

function vpnWizardInit ()
	{
	var selValue = comboSelectedValueGet ('selPeerType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Gateway */
			gateWaySetup ();
			break;
		case 1:	/* VPN Client */
			clientIpsecHostSetup ();
			break;
		}
	}
	
function checkInternetName (opFlag)
	{
	if (opFlag == 1)
		{
		var selOption = comboSelectedValueGet ('selRemoteGwType');
		if (parseInt (selOption, 10) == 0)
		{
			if (ipv4Validate ('txtVPWizRmtIp', 'IP', false, true,
		             "Invalid IP address.", "for octet ", true) == false)
		    	return false;
			}
		else
			{
			if (validateFQDN ('txtVPWizRmtIp') == false)
		    	return false;
			}
		return true
		}
	else if (opFlag == 2)
		{
		var selOption = comboSelectedValueGet ('selLocalGwType');
		if (parseInt (selOption, 10) == 0)
			{
			if (ipv4Validate ('txtVPIkeLId', 'IP', false, true,
		             "Invalid IP address.", "for octet ", true) == false)
		    	return false;
			}
		else
			{
			if (validateFQDN ('txtVPIkeLId') == false)
		    	return false;
			}
		return true
		}
	return true;
	}

function showScreen (screenNumber)
	{
	for (var idx = 1; idx <= 4; idx++)
		{
		var screenObj = document.getElementById ("trwizardScreen" + idx)
		if (screenObj)
			{
			if (idx == screenNumber)
				screenObj.className = "show";
			else if (screenObj.className == "show")
				screenObj.className = "hide";
			}
		}
	}

function showNextScreen ()
	{
	var selValue = comboSelectedValueGet ('selPeerType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Gateway */
			showScreen (3);
			break;
		case 1:	/* VPN Client */
			showSummary ();
			break;
		}
	}
	
function showPrevScreen ()
	{
	var selValue = comboSelectedValueGet ('selPeerType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Gateway */
			showScreen (3);
			break;
		case 1:	/* VPN Client */
			showScreen (2);
			break;
		}
	}

function showSummary ()
	{
	showScreen (4);
	var tdObj = document.getElementById ('tdConType');
	var selValue = comboSelectedValueGet ('selPeerType');
	if (selValue == "0")
		tdObj.innerHTML = "Site-to-Site";
	else if (selValue == "1")
		tdObj.innerHTML = "Remote Access";
	tdObj = document.getElementById ('tdConName');
	var txtObj = document.getElementById ('txtVPNWizName');
	if (tdObj && txtObj) tdObj.innerHTML = txtObj.value;
	tdObj = document.getElementById ('tdPreSharedKey');
	txtObj = document.getElementById ('txtVPWizPsk');
	if (tdObj && txtObj) tdObj.innerHTML = txtObj.value;
	tdObj = document.getElementById ('tdLocalGateway');
	txtObj = document.getElementById ('selLocalWanInt');
	if (tdObj && txtObj) tdObj.innerHTML = txtObj.options[txtObj.selectedIndex].text;
	tdObj = document.getElementById ('tdRemoteWANIP');
	txtObj = document.getElementById ('txtVPWizRmtIp');
	if (tdObj && txtObj) tdObj.innerHTML = txtObj.value;
	tdObj = document.getElementById ('tdLocalWANIP');
	txtObj = document.getElementById ('txtVPIkeLId');
	if (tdObj && txtObj) tdObj.innerHTML = txtObj.value;
	tdObj = document.getElementById ('tdRemoteLanSubnet');
	if (selValue == "0")
		{
		txtObj = document.getElementById ('vpnPolicyRemoteLanIPAddress');
		var txtObj1 = document.getElementById ('vpnPolicyRemoteLanIPMask');
		if (tdObj && txtObj) tdObj.innerHTML = txtObj.value + "/" + txtObj1.value;
		}
	else if (selValue == "1")
		if (tdObj) tdObj.innerHTML = "N/A";
	} 
