--[[
#### Adarsh Uppula
#### TeamF1
#### www.TeamF1.com
#### June 29, 2007

#### File: platform.lua
#### Description: Main handler for lua pages.

#### Revisions:
01d, 08mar10, db  over ridden the db.save routine
01c, 20feb10, sen remove check for valid session if pageTOGO is blocked.htm
01b, 27feb08, rbh added the security check for dbglogs.
01c, 23Apr08, shv Fix to get dynamic status messages for wps using ajax.
01d, 12Jul08, shv Added two global variables to use in connection status
              pop up for WAN1 and WAN2.
01e, 15Jul08, shv added sslvpn login support.
]]--

--************* Requires *************

require "teamf1lualib/db"
require "teamf1lualib/web"
require "teamf1lualib/login"
require "teamf1lualib/util"
require "teamf1lualib/factDef"
require "cgilua.cookies"

--************* Global Variables *************

configRow = {}
configRowId = "-1"
statusCode = "NONE"
statusMessage = ""
errorFlag = "OK"
rebootFlag = false
status = -2

FullName = ""
SplitParts = {}
Page = ""
Action = ""
menuNumber = "0"
pageId = "0"
logicalIntName = ""
addrFamily = ""
urlStr = ""
spUrlStr = ""
isDynLnk = false
vsignUser = ""
vsignRetryCount = "0"

ButtonType = ""
DBTable = ""
NextPage = ""
RowId = "0"
ButtonValue = ""

HOME_PAGE = "index.htm"
SSL_PORTAL_PAGE = "sslVpnRedirect.htm"
SSL_PORTAL_LOGIN_PAGE = "portalLogin.htm"
VSIGN_AUTH_PAGE = "verisignAuthentication.htm"
HELP_VSIGN_AUTH_PAGE = "helpVerisignAuthentication.htm"
HELP_INDEX_PAGE = "helpIndex.htm"
PLATFORM_PAGE = "platform.lua"
FORCED_LOGIN_PAGE = "forcedLogin.htm"
REBOOT_PAGE = "statusPage.htm"
ERROR_PAGE = "errorPage.htm"
LANGUAGE = "en_US"
SETTINGS_FILE = ""
DB_FILE_NAME="/tmp/system.db"
BLOCKED_PAGE="blocked.htm"

ACCESS_LEVEL = -1

--************* Initial Code *************

db.connect(DB_FILE_NAME)
SETTINGS_FILE = db.getAttribute("environment", "name", "TEAMF1_CFG_ASCII", "value")
UNIT_NAME = db.getAttribute("unitInfo","_ROWID_","1","modelId") or ''
COMPANY_NAME = db.getAttribute("webBrandingTags","_ROWID_","1","companyName") or ''
COPYRIGHTS = db.getAttribute("webBrandingTags","_ROWID_","1","copyright") or ''
COPYRIGHTS_TRENDMICRO = "&#169; 2009 Trend Micro Incorporated. All rights reserved."
WEB_ADDRESS = db.getAttribute("webBrandingTags","_ROWID_","1","webAddress") or ''
SUPPORT_LINK = db.getAttribute("webBrandingTags","_ROWID_","1","supportLink") or ''
PRODUCT_FAMILY = db.getAttribute("webBrandingTags","_ROWID_","1","prodFamily") or ''
APP_NAME = db.getAttribute("webBrandingTags","_ROWID_","1","appName") or ''
VERSION = db.getAttribute("system","_ROWID_","1","firmwarePri") or ''
REG_TM = db.getAttribute("webBrandingTags","_ROWID_","1","tradeMark") or ''
WEB_LINK = db.getAttribute("webBrandingTags","_ROWID_","1","webAddress") or ''
UNIT_INFO = db.getAttribute("webBrandingTags","_ROWID_","1","unitName") 
            or db.getAttribute("UDIInfo","_ROWID_","1","udi") or ''
-- turn on debugging
util.setDebugStatus(false)
-- turn on output
util.setOutputStatus(false)

--************* Logic *************--

local pageToGoTo = HOME_PAGE
local shouldRunPage = false
local refererVal = os.getenv("HTTP_REFERER")
local requestMethod = os.getenv("REQUEST_METHOD")

-- [[ check if dbglog.cgi was invoked , if so, call dbglog.lua ]] --
if (string.find(cgilua.urlpath , "dbglog.cgi")) then
    -- set cgi action variable to dbglog -- 
    cgi.action="dbglog"
end

--[[check for clicks and find which page to go to]]--
if (util.tableSize(cgi) > 0) then
	local field, splitted, value = web.cgiFindButton(cgi, "button")
	-- if button press (POST)
	if (splitted ~= nil) then
		Page = cgi.thispage
		FullName = field
		SplitParts = splitted
		ButtonType = splitted[2]
		if (#splitted == 3) then
			NextPage = splitted[3]
		else
			DBTable = splitted[3]
			NextPage = splitted[4]
		end
		if (#splitted >= 5) then
			RowId = splitted[5]
		end
		ButtonValue = value["1"]
		
		--[[let page handle different types of clicks]]--
		if (ButtonType ~= "") then
			pageToGoTo = Page
		end
	-- else link press (GET)
	else
		-- if action
		if (cgi.action) then
			shouldRunPage = true
			pageToGoTo = cgi.action .. ".lua"
		-- else if page
		elseif (cgi.page) then
			pageToGoTo = cgi.page
		end
	end
end

--[[decide where to go depending on login validation]]--
-- if from login page, then go to login page
if (Page == HOME_PAGE) then
	pageToGoTo = HOME_PAGE
else
	if (pageToGoTo ~= HOME_PAGE) then
        if (refererVal~=nil) then
            local refererVal = login.parseReferer (refererVal)
            -- validate current http referer value
            local valid = login.refererValidation(cgilua.cookies.get("TeamF1Login"), SAPI.Request.servervariable("REMOTE_ADDR"), refererVal)
            if (valid==false) then
               pageToGoTo = ERROR_PAGE
            end
        elseif (refererVal == nil) then
            if(requestMethod == "POST") then
                pageToGoTo = ERROR_PAGE
            end
        end
    end

	--validate user login
	local returnVal = login.revalidate(cgilua.cookies.get("TeamF1Login"), SAPI.Request.servervariable("REMOTE_ADDR"))
	-- if ok, or authenticated and we came from forced login
	if (returnVal == "OK" or (returnVal == "AUTHENTICATED" and Page == FORCED_LOGIN_PAGE)) then
		pageToGoTo = pageToGoTo --pageToGoTo already set to right place we want to go to
    elseif (Page == FORCED_LOGIN_PAGE) then
		pageToGoTo = pageToGoTo --pageToGoTo already set to right place we want to go to
    elseif (pageToGoTo == HELP_INDEX_PAGE or pageToGoTo == SSL_PORTAL_LOGIN_PAGE or pageToGoTo == VSIGN_AUTH_PAGE or pageToGoTo == HELP_VSIGN_AUTH_PAGE) then
		pageToGoTo = pageToGoTo --pageToGoTo is helpIndex.htm then no need to check for cookie
	-- if bad login state, go to login page
	else
			if(pageToGoTo == BLOCKED_PAGE) then
				pageToGoTo = BLOCKED_PAGE
			else
            	shouldRunPage = false
	        	pageToGoTo = HOME_PAGE
			end
    end
end

--[[Check if the user is authorised to access dbglogs]]--

if (cgi.action == "dbglog") then
    if(ACCESS_LEVEL ~= 0) then
        shouldRunPage = false
        statusMessage = db.getAttribute("stringsMap", "stringId", "ADMIN_REQD", LANGUAGE)
        pageToGoTo = HOME_PAGE
        cgi.action = ""
    end
end

--[[run or go to page]]--
if (shouldRunPage) then
	web.runPage(pageToGoTo)
	return
else
    
    --[[ Check whether NON-ADMIN or NON-Guest users are accessing the 
    --   configuration pages OTHER than certain files(like help etc.,)
    -- 
    --   THis check is aimed to avoid NON-previleged access to configuration
    --   pages for userTypes like IPSEC users/SSLVPN users etc..,
    --   
    --   The user will be logged out on NON-PREVILEGED access
    --   ]]--
    --   
    -- We should NOT do the check, in case of Login redirection !  
	util.appendDebugOut("STATUS MESSAGE(before condition)     : " .. statusMessage .. "<br>")
    if (ACCESS_LEVEL ~= -1 and 
        ACCESS_LEVEL ~= 0 and 
        ACCESS_LEVEL ~= 1 and 
        pageToGoTo ~= HOME_PAGE and 
        pageToGoTo ~= "portalLogin.htm") then
        util.appendDebugOut("ACCESS LEVEL       : " .. ACCESS_LEVEL .. "<br>")
        util.appendDebugOut("requestedPage      : " .. pageToGoTo .. "<br>")
        local iS = '-1'
        local iE = '-1'
        iS, iE = string.find(pageToGoTo, "userPortal")
        iS = iS or '-1'
        iE = iE or '-1'
        if (iS == '-1' or iE == '-1') then
            shouldRunPage = false
            statusMessage = "NON PRIVILEGED ACCESS !"
            pageToGoTo = HOME_PAGE
            cgi.action = ""
	        util.appendDebugOut("ALERT : NON PRIVILEGED ACCESS !<br>")
        end    
    end
	util.appendDebugOut("STATUS MESSAGE(After condition)     : " .. statusMessage .. "<br>")

	web.goToPage(pageToGoTo)
end
	
-- print output if need to
if (util.getOutputStatus() == true) then
	cgilua.put(util.getOut())
end

-- print debugging if need to
if (util.getDebugStatus() == true) then
	util.appendDebugOut("<br>")

	util.appendDebugOut("STATUS MESSAGE: " .. statusMessage .. "<br>")
	util.appendDebugOut("ACCESS LEVEL: " .. ACCESS_LEVEL .. "<br>")
	util.appendDebugOut("Current time = ")
	util.appendDebugOut(os.time() .. "<br>")
	util.appendDebugOut("CGI table<br>" .. util.tableToStringRec(cgi or {}))

	util.appendDebugOut("Session table<br>" .. db.printTable("loginSession"))
	util.appendDebugOut("Accounts table<br>" .. db.printTable("users"))
	--util.appendDebugOut("Defaults table<br>" .. db.printTable("tableDefaults"))
	--util.appendDebugOut("Strings table<br>" .. db.printTable("stringsMap"))

	util.appendDebugOut("dot11VAP table<br>" .. db.printTable("dot11VAP"))
	util.appendDebugOut("dot11RogueAP table<br>" .. db.printTable("dot11RogueAP"))
	util.appendDebugOut("dot11Interface table<br>" .. db.printTable("dot11Interface"))
	util.appendDebugOut("networkInterface table<br>" .. db.printTable("networkInterface"))
	util.appendDebugOut("dot11Profile table<br>" .. db.printTable("dot11Profile"))
	util.appendDebugOut("dot11Radio table<br>" .. db.printTable("dot11Radio"))
	util.appendDebugOut("dot11Card table<br>" .. db.printTable("dot11Card"))
	util.appendDebugOut("ethernet table<br>" .. db.printTable("ethernet"))
	util.appendDebugOut("bridgeTable table<br>" .. db.printTable("bridgeTable"))
	util.appendDebugOut("bridgePorts table<br>" .. db.printTable("bridgePorts"))

	util.appendDebugOut("interfaceStats table<br>" .. db.printTable("interfaceStats"))
	util.appendDebugOut("dot11STA table<br>" .. db.printTable("dot11STA"))
	util.appendDebugOut("dot11ACL table<br>" .. db.printTable("dot11ACL"))
	--util.appendDebugOut("dot11VAPStats table<br>" .. db.printTable("dot11VAPStats"))
	--util.appendDebugOut("dot11NodeStats table<br>" .. db.printTable("dot11NodeStats"))
	util.appendDebugOut("radiusClient table<br>" .. db.printTable("radiusClient"))
	util.appendDebugOut("vlan table<br>" .. db.printTable("vlan"))
	
	util.appendDebugOut("ntp table<br>" .. db.printTable("ntp"))
    util.appendDebugOut("logging table<br>" .. db.printTable("logging"))
	util.appendDebugOut("logConfig table<br>" .. db.printTable("logConfig"))
	util.appendDebugOut("eventLog table<br>" .. db.printTable("eventLog"))
	util.appendDebugOut("compFacilityMap table<br>" .. db.printTable("compFacilityMap"))

	util.appendDebugOut("reboot table<br>" .. db.printTable("reboot"))
	util.appendDebugOut("environment table<br>" .. db.printTable("environment"))
	util.appendDebugOut("system table<br>" .. db.printTable("system"))
	util.appendDebugOut("saveTables table<br>" .. db.printTable("saveTables"))

	util.appendDebugOut("system num cols<br>" .. db.printTable("system"))
	util.appendDebugOut("snmpTrap num cols<br>" .. db.printTable("snmpTrap"))
	util.appendDebugOut("dot11NodeStats num cols<br>" .. db.numCols("dot11NodeStats"))
	util.appendDebugOut("dot11VAPStats num cols<br>" .. db.numCols("dot11VAPStats"))
	util.appendDebugOut("system num cols<br>" .. db.numCols("system"))
	util.appendDebugOut("snmpTrap num cols<br>" .. db.numCols("snmpTrap"))
	
   cgilua.put(util.getDebugOut())
end

